/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FinancialOverlay } from "./FinancialOverlay";
import { DependencyProperty } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { Number_$type, typeCast, runOn, markType, markDep, getEnumerator, Point_$type, fromEnum } from "igniteui-angular-core";
import { CategoryFrame } from "./CategoryFrame";
import { Series } from "./Series";
import { SafeEnumerable } from "./SafeEnumerable";
import { TrendCalculators } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { Polyline } from "igniteui-angular-core";
import { Polygon } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
import { Flattener } from "igniteui-angular-core";
/**
 * @hidden
 */
export class BollingerBandsOverlay extends FinancialOverlay {
    constructor() {
        super();
        this.ry = 0;
        this.rz = 0;
        this.rw = new List$1(Number_$type, 0);
        this.rx = new List$1(Number_$type, 0);
        this.ab = BollingerBandsOverlay.$;
        this.ok = new CategoryFrame(4);
        this.om = new CategoryFrame(4);
        this.oj = new CategoryFrame(4);
    }
    kp(a, b, c, d) {
        if (this.pz().contains(b)) {
            this.rq = false;
        }
        super.kp(a, b, c, d);
        switch (b) {
            case BollingerBandsOverlay.$$p[1]:
                this.rq = false;
                this.k3(false);
                break;
            case BollingerBandsOverlay.$$p[0]:
                this.k3(false);
                break;
        }
    }
    rr() {
        this.rw.clear();
        this.rx.clear();
        let a = getEnumerator(TrendCalculators.e(new SafeEnumerable(this.py), this.r1));
        let b = getEnumerator(TrendCalculators.f(new SafeEnumerable(this.py), this.r1));
        this.rz = 1.7976931348623157E+308;
        this.ry = -1.7976931348623157E+308;
        let c = true;
        let d = true;
        let e = this.r0;
        while (c || d) {
            if (a.moveNext()) {
                this.rw.add(a.current);
            }
            else {
                c = false;
            }
            if (b.moveNext()) {
                this.rx.add(b.current);
            }
            else {
                d = false;
            }
            if (c && d) {
                this.rz = Math.min(this.rz, a.current - b.current * e);
                this.ry = Math.max(this.ry, a.current + b.current * e);
            }
        }
        return true;
    }
    ao(a) {
        if (this.rw == null || this.rx == null || a == null || this.cd == null || a != this.o2) {
            return null;
        }
        let b = new AxisRange(this.rz, this.ry);
        return b;
    }
    q7(a, b) {
        super.q7(a, b);
        let c = b.bv;
        let d = b.bu;
        let e = this.getEffectiveViewport1(b);
        let f = this.oh;
        let g = this.o2;
        let h = new ScalerParams(0, c, d, f.ca, e);
        let i = new ScalerParams(0, c, d, g.ca, e);
        a.f.clear();
        a.m.clear();
        a.p.clear();
        let j = typeCast(ISortingAxis_$type, this.oh);
        if (j != null && j.i$b.count != this.cd.count) {
            return;
        }
        let k = 0;
        k = this.p7(c, d, e);
        if (!this.rq) {
            this.rq = this.rr();
            if (this.o2 != null) {
                this.o2.co(true);
            }
        }
        i.b = this.fa();
        let l = this.oh.d2(2, h) - this.oh.d2(1, h);
        for (let m = b.bx.c; m <= b.bx.d; ++m) {
            let n;
            if (j == null) {
                n = b.bx.getBucket(m);
            }
            else {
                let o = j.i$b._inner[m];
                let p = j.i$d(o);
                let q = this.rw._inner[m];
                let r = this.rx._inner[m];
                let s = q;
                let t = r;
                let u = p;
                let v = 1;
                while (m < b.bx.d) {
                    o = j.i$b._inner[m + 1];
                    u = j.i$d(o);
                    if (u - p > l) {
                        break;
                    }
                    m++;
                    s += this.rw._inner[m];
                    t += this.rx._inner[m];
                    v++;
                }
                s /= v;
                t /= v;
                let w = s - t * this.r0;
                let x = s;
                let y = s + t * this.r0;
                let z = NaN;
                if (!isNaN_(p)) {
                    z = this.oh.dz(p, h);
                }
                n = [z, w, x, y];
            }
            let aa = Math.max(1, l);
            if (!isNaN_(n[0]) && m * aa >= this.rs) {
                if (this.oh != null && typeCast(ISortingAxis_$type, this.oh) !== null) {
                    n[0] = n[0] + k;
                }
                else {
                    n[0] = f.dz(n[0], h) + k;
                }
                n[1] = g.dz(n[1], i);
                n[2] = g.dz(n[2], i);
                n[3] = g.dz(n[3], i);
                a.f.add(n);
            }
        }
    }
    jl(a, b) {
        super.jl(a, b);
        let c = b;
        if (c != null) {
            c.b4();
        }
    }
    fh(a, b, c) {
        if (this.rw == null) {
            return super.fh(a, b, c);
        }
        let d = this.getEffectiveViewport1(this.bs);
        let e = this.p7(this.bs.bv, this.bs.bu, d);
        let f = new ScalerParams(0, this.bs.bv, this.bs.bu, this.oh.ca, d);
        f.c = this.b6.o7;
        return this.fj(this.rw, a, this.oh, f, e, runOn(this, this.p6), b, c);
    }
    gf(a, b) {
        if (this.rw == null) {
            return super.gf(a, b);
        }
        return this.gg(a, b, this.oh, runOn(this, this.p6), this.rw);
    }
    gd(a, b) {
        if (this.rw == null) {
            return super.gd(a, b);
        }
        return this.ge(a, b, this.oh, runOn(this, this.p6), this.rw);
    }
    ec(a, b, c) {
        let d = super.ec(a, b, c);
        if (!this.pp(this.pz())) {
            d = false;
        }
        return d;
    }
    q9(a, b) {
        super.q9(a, b);
        let c = typeCast(BollingerBandsOverlayView.$, b);
        let d = this.getEffectiveViewport1(b);
        if (b.b0(a)) {
            c.b4();
            let e = a.f.count;
            let f = (g) => a.f._inner[g][0];
            let g = (h) => a.f._inner[e - 1 - h][0];
            let h = (i) => a.f._inner[i][1];
            let i = (j) => a.f._inner[j][2];
            let j = (k) => a.f._inner[e - 1 - k][3];
            c.b5(e, f, g, h, i, j);
            b.b2(a);
        }
        this.op.a0(this, this.po(), runOn(this, this.n9), this.qd(b), this.qf(b));
        let k = false;
        let l = this.op.b;
        let m = a.f;
        let n = this.cd.count;
        if (l != null) {
            k = true;
        }
        if (k) {
            let o = new ScalerParams(0, b.bv, b.bu, this.oh.ca, d);
            this.q6(m, -1, n, this.oh, o, b.q);
        }
        let p = c.cc;
        let q = c.cd;
        let r = c.ce;
        let s = c.b7;
        this.op.ad(q, true, false, true, true);
        this.op.an = null;
        this.op.am = null;
        this.op.ad(p, true, false, false, true);
        this.op.ad(r, true, false, false, true);
        this.op.ad(s, false, true, false, false);
        s._opacity = this.op.j * this.er;
    }
    bp() {
        return new BollingerBandsOverlayView(this);
    }
    kk(a) {
        super.kk(a);
        this.rv = typeCast(BollingerBandsOverlayView.$, a);
    }
    qg() {
        return 3;
    }
    fa() {
        return Series.fb(this.rw, null);
    }
}
BollingerBandsOverlay.$t = markType(BollingerBandsOverlay, 'BollingerBandsOverlay', FinancialOverlay.$);
BollingerBandsOverlay.$$p = markDep(DependencyProperty, PropertyMetadata, BollingerBandsOverlay, 'raisePropertyChanged', ['Multiplier:r0:r4', [1, 2], 'Period:r1:r5', [1, 14]]);
/**
 * @hidden
 */
export class BollingerBandsBucketCalculator extends FinancialBucketCalculator {
    constructor(a) {
        super(a);
        this.f = null;
        this.f = a;
    }
    getBucket(a) {
        let b = a * this.b;
        let c = Math.min(b + this.b - 1, this.a.bz.cd.count - 1);
        if (b <= c) {
            let d = this.f.b3.r0;
            let e = 0;
            let f = 0;
            let g = 0;
            for (let h = b; h <= c; ++h) {
                if (!isNaN_(this.f.b3.rw._inner[h]) && !isNaN_(this.f.b3.rx._inner[h])) {
                    e += this.f.b3.rw._inner[h];
                    f += this.f.b3.rx._inner[h];
                    ++g;
                }
            }
            if (g > 0) {
                e = e / g;
                f = f / g;
                return [0.5 * (b + c), e - f * d, e, e + f * d];
            }
        }
        return [NaN, NaN, NaN, NaN];
    }
}
BollingerBandsBucketCalculator.$t = markType(BollingerBandsBucketCalculator, 'BollingerBandsBucketCalculator', FinancialBucketCalculator.$);
/**
 * @hidden
 */
export class BollingerBandsOverlayView extends FinancialSeriesView {
    constructor(a) {
        super(a);
        this.b3 = null;
        this.b8 = new Polygon();
        this.cf = new Polyline();
        this.cg = new Polyline();
        this.ch = new Polyline();
        this.b6 = new Polygon();
        this.b9 = new Polyline();
        this.ca = new Polyline();
        this.cb = new Polyline();
        this.b3 = a;
    }
    as() {
        super.as();
        if (!this.q) {
            this.e.bx = 1;
        }
    }
    by() {
        return new BollingerBandsBucketCalculator(this);
    }
    b5(a, b, c, d, e, f) {
        for (let g of fromEnum(Flattener.d(a, b, d, this.e.fq))) {
            this.b8.ak.add({ $type: Point_$type, x: b(g), y: d(g) });
            this.cf.ak.add({ $type: Point_$type, x: b(g), y: d(g) });
        }
        for (let h of fromEnum(Flattener.d(a, b, e, this.e.fq))) {
            this.cg.ak.add({ $type: Point_$type, x: b(h), y: e(h) });
        }
        for (let i of fromEnum(Flattener.d(a, c, f, this.e.fq))) {
            this.b8.ak.add({ $type: Point_$type, x: c(i), y: f(i) });
            this.ch.ak.add({ $type: Point_$type, x: c(i), y: f(i) });
        }
        this.aq();
    }
    b4() {
        this.b8.ak.clear();
        this.cf.ak.clear();
        this.cg.ak.clear();
        this.ch.ak.clear();
        this.aq();
    }
    get b7() {
        return this.b8;
    }
    get cc() {
        return this.cf;
    }
    get cd() {
        return this.cg;
    }
    get ce() {
        return this.ch;
    }
    bc() {
        super.bc();
        this.b6.ak = this.b8.ak;
        this.b9.ak = this.cf.ak;
        this.ca.ak = this.cg.ak;
        this.cb.ak = this.ch.ak;
        let a = this.bo();
        this.b6._fill = a;
        this.b6._opacity = 1;
        this.b9._stroke = a;
        this.b9.ac = this.e.eu + 3;
        this.ca._stroke = a;
        this.ca.ac = this.e.eu + 3;
        this.cb._stroke = a;
        this.cb.ac = this.e.eu + 3;
    }
    a6(a, b) {
        super.a6(a, b);
        if (a.d) {
            if (b) {
                a.t(this.b6);
                a.u(this.b9);
                a.u(this.ca);
                a.u(this.cb);
            }
            else {
                a.t(this.b8);
                a.u(this.cf);
                a.u(this.cg);
                a.u(this.ch);
            }
        }
    }
    al(a) {
        super.al(a);
        this.e.a5.exportPolygonData(a, this.b8, "FillShape", ["Fill"]);
        this.e.a5.exportPolylineData(a, this.cf, "BottomLine", ["Lower", "Main"]);
        this.e.a5.exportPolylineData(a, this.cg, "CentralLine", ["Central"]);
        this.e.a5.exportPolylineData(a, this.ch, "TopLine", ["Upper"]);
    }
}
BollingerBandsOverlayView.$t = markType(BollingerBandsOverlayView, 'BollingerBandsOverlayView', FinancialSeriesView.$);
//# sourceMappingURL=BollingerBandsOverlay_combined.js.map