/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, typeCast, markType, Array_$type, Number_$type, Point_$type, enumGetBox, runOn, fromEnum, markDep } from "igniteui-angular-core";
import { IBucketizer_$type } from "./IBucketizer";
import { ArgumentNullException } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ISortingAxis_$type } from "./ISortingAxis";
import { ScalerParams } from "./ScalerParams";
import { Series } from "./Series";
import { truncate, intDivide, isNaN_, isInfinity } from "igniteui-angular-core";
import { FramePreparer } from "./FramePreparer";
import { IIsCategoryBased_$type } from "./IIsCategoryBased";
import { List$1 } from "igniteui-angular-core";
import { ISupportsMarkers_$type } from "./ISupportsMarkers";
import { IProvidesViewport_$type } from "./IProvidesViewport";
import { ISupportsErrorBars_$type } from "./ISupportsErrorBars";
import { CategoryFrame } from "./CategoryFrame";
import { PreparationParams } from "./PreparationParams";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { NumericAxisBase } from "./NumericAxisBase";
import { IHasCategoryTrendline_$type } from "./IHasCategoryTrendline";
import { IHasSingleValueCategory_$type } from "./IHasSingleValueCategory";
import { DefaultCategoryTrendlineHost } from "./DefaultCategoryTrendlineHost";
import { DefaultSingleValueProvider } from "./DefaultSingleValueProvider";
import { SingleValuesHolder } from "./SingleValuesHolder";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { ICategorySeriesInteractionManager_$type } from "./ICategorySeriesInteractionManager";
import { DVContainer } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { Pool$1 } from "igniteui-angular-core";
import { Clipper } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { round10N } from "igniteui-angular-core";
/**
 * @hidden
 */
export class CategoryBucketCalculator extends Base {
    constructor(a) {
        super();
        this.c = null;
        this.e = 0;
        this.f = 0;
        this.d = 0;
        if (a == null) {
            throw new ArgumentNullException(0, "view");
        }
        this.c = a;
        this.e = -1;
        this.d = 0;
    }
    getBucket(a) {
        return null;
    }
    getBucketWithoutUnknowns(a) {
        return this.getBucket(a);
    }
    getErrorBucket(a, b) {
        return NaN;
    }
    g(a) {
        let b = this.c.bv;
        let c = this.c.bu;
        let d = this.c.ct;
        let e = typeCast(CategoryAxisBase.$, d.fetchXAxis());
        let f = d.cd;
        if (b.isEmpty || c.isEmpty || e == null || f == null || f.count == 0) {
            this.d = 0;
            return;
        }
        let g = d.getEffectiveViewport1(this.c);
        let h = d.ny(this.c);
        let i = typeCast(ISortingAxis_$type, e);
        if (i == null || i.i$b == null) {
            let j = new ScalerParams(0, b, c, e.ca, g);
            let k = Math.floor(e.d3(h.left, j, 0));
            let l = Math.ceil(e.d3(h.right, j, 0));
            if (e.ca) {
                l = Math.ceil(e.d3(h.left, j, 0));
                k = Math.floor(e.d3(h.right, j, 0));
            }
            let m = Math.floor((l - k + 1) * a / h.width);
            this.d = truncate(Math.max(1, m));
            this.e = truncate(Math.max(0, Math.floor(k / this.d) - 1));
            this.f = truncate(Math.ceil(l / this.d));
        }
        else {
            this.e = i.i$e(b, c, g, h);
            this.f = i.i$g(b, c, g, h);
            this.d = 1;
        }
    }
    getBucketInfo(a, b, c, d) {
        a = this.e;
        b = this.f;
        c = this.d;
        d = this.c.ct.fq;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    }
    cacheValues() {
    }
    unCacheValues() {
    }
}
CategoryBucketCalculator.$t = markType(CategoryBucketCalculator, 'CategoryBucketCalculator', Base.$, [IBucketizer_$type]);
/**
 * @hidden
 */
export class CategoryFramePreparerBase extends FramePreparer {
    constructor(a, ..._rest) {
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = _rest[0];
                    let d = [c, typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c), typeCast(IBucketizer_$type, c)];
                    {
                        let f = d[0];
                        let g = d[1];
                        let h = d[2];
                        let i = d[3];
                        let j = d[4];
                        super(1, g, h, i);
                        this.g = null;
                        this.h = null;
                        this.m = false;
                        this.o = new List$1(Array_$type, 0);
                        this.p = new List$1(Number_$type, 0);
                        this.n = new List$1(Number_$type, 0);
                        this.h = f;
                        this.g = j;
                    }
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    let e = _rest[2];
                    let f = _rest[3];
                    let g = _rest[4];
                    super(1, d, e, f);
                    this.g = null;
                    this.h = null;
                    this.m = false;
                    this.o = new List$1(Array_$type, 0);
                    this.p = new List$1(Number_$type, 0);
                    this.n = new List$1(Number_$type, 0);
                    this.h = c;
                    this.g = g;
                }
                break;
        }
    }
    i(a) {
        let b = new PreparationParams();
        b.f = this.h.useHighMarkerFidelity;
        b.b = this.h.scaler;
        b.c = this.h.yScaler;
        b.d = typeCast(ISortingAxis_$type, b.b);
        b.a = typeCast(CategoryFrame.$, a);
        if (b.a == null || b.b == null || b.c == null) {
            return null;
        }
        let c;
        let d;
        let e;
        let f;
        let g = this.g.getBucketInfo(c, d, e, f);
        c = g.p0;
        d = g.p1;
        e = g.p2;
        f = g.p3;
        b.i = c;
        b.j = d;
        b.h = e;
        b.g = f;
        if (b.j < b.i) {
            return null;
        }
        let h;
        let i;
        let j;
        let k = this.a.getViewInfo(i, h);
        i = k.p0;
        h = k.p1;
        j = this.a.getEffectiveViewport();
        b.m = h;
        b.l = i;
        b.k = j;
        if (Rect.l_op_Equality(b.m, Rect.empty) || Rect.l_op_Equality(b.l, Rect.empty)) {
            return null;
        }
        if (this.h != null && (typeCast(Series.$, this.h) !== null && this.h.c7) && this.g != null) {
            b.e = true;
        }
        return b;
    }
    r(a, b, c, d) {
        return a.getSeriesOffset(b, c, d, this.h.currentMode2Index, this.h.currentCategoryMode);
    }
    s(a) {
        return this.r(a.b, a.m, a.l, a.k);
    }
    d(a, b) {
        let c = this.i(a);
        if (c == null || this.g == null) {
            return;
        }
        c.a.f.clear();
        c.a.k.clear();
        c.a.m.clear();
        c.a.p.clear();
        c.a.i.clear();
        c.a.h.clear();
        c.a.g.clear();
        let d = this.c.shouldDisplayMarkers;
        let e = false;
        let f = this.s(c);
        let g = this.j(c);
        if (c.d != null && c.d.i$b != null && c.d.i$b.count != g.e) {
            return;
        }
        if (c.d != null && c.d.i$a) {
            c.d.i$h();
        }
        this.g.cacheValues();
        if (this.m && c.d != null && c.d.i$b.count > 0) {
            let h = c.d.i$b._inner[c.i];
            this.z(g, h, true, c.e);
            while ((isNaN_(g.c) || isNaN_(g.d)) && c.i > 0) {
                c.i = c.i - 1;
                h = c.d.i$b._inner[c.i];
                this.z(g, h, true, c.e);
            }
            let i = c.d.i$b._inner[c.j];
            this.z(g, i, true, c.e);
            while ((isNaN_(g.c) || isNaN_(g.d)) && c.j < g.e - 1) {
                c.j = c.j + 1;
                i = c.d.i$b._inner[c.j];
                this.z(g, i, true, c.e);
            }
        }
        if (this.m && c.d == null) {
            let j = c.i;
            let k = this.g.getBucket(j);
            while ((isNaN_(k[1]) || isNaN_(k[2])) && c.i > 0) {
                c.i = c.i - 1;
                j = c.i;
                k = this.g.getBucket(j);
            }
            let l = c.j;
            k = this.g.getBucket(l);
            while ((isNaN_(k[1]) || isNaN_(k[2])) && c.j < (intDivide(g.e, c.h))) {
                c.j = c.j + 1;
                l = c.j;
                k = this.g.getBucket(l);
            }
        }
        this.w(c, g, f);
        let m = this.t(c, g, f, d, e);
        this.c.updateMarkerCount(m);
        this.v(typeCast(CategoryFrame.$, a), b);
        this.g.unCacheValues();
        return;
    }
    v(a, b) {
    }
    get q() {
        return this.o;
    }
    t(a, b, c, d, e) {
        let f = 0;
        let g = false;
        let h = null;
        let i = false;
        let j = a.d != null;
        let k = a.m;
        let l = a.l;
        let m = typeCast(NumericAxisBase.$, a.c) !== null && a.c.j3;
        let n = a.f;
        let o = this.h.mayContainUnknowns;
        let p = this.o;
        let q = this.n;
        let r = this.p;
        p.clear();
        q.clear();
        r.clear();
        let s = this.g;
        let t = this.h.provideCollisionDetector();
        let u = 0;
        let v = a.k;
        let w = new ScalerParams(0, k, l, a.b.j$a, v);
        let x = ((() => {
            let $ret = new ScalerParams(0, k, l, a.c.j$a, v);
            $ret.b = typeCast(Series.$, this.h) !== null ? this.h.fa() : NaN;
            return $ret;
        })());
        if (j) {
            u = a.b.j$c(2, w) - a.b.j$c(1, w);
            i = this.k();
        }
        let y = a.i;
        let z = a.j;
        let aa = a.a.f;
        let ab = typeCast(IDateTimeAxis_$type, a.b);
        if (ab != null) {
            ab.StartTimeCursor();
        }
        for (let ac = y; ac <= z; ++ac) {
            let ad;
            if (!j) {
                if (!o) {
                    ad = s.getBucketWithoutUnknowns(ac);
                }
                else {
                    ad = s.getBucket(ac);
                }
            }
            else {
                ad = ((() => { let ae = this.f(a, ac, b, u, g, h, c); ac = ae.p1; g = ae.p4; h = ae.p5; return ae.ret; })());
            }
            let ae = !m || (m && ad[1] > 0);
            let af = ad[0];
            if (!j || !isNaN_(ad[0])) {
                aa.add(ad);
                if (g && i) {
                    if (h != null) {
                        aa.add(h);
                    }
                }
                if (d && ae) {
                    let ag = ac * a.h;
                    let ah = ag;
                    if (j && a.d.i$b != null && ag >= 0 && ag < a.d.i$b.count) {
                        ag = a.d.i$b._inner[ag];
                    }
                    let ai = new Array(ad.length);
                    ai[0] = ad[0];
                    ai[1] = ad[1];
                    ai[2] = ad[2];
                    if (n && ag < b.e) {
                        ai = new Array(ad.length);
                        ai[0] = af;
                        this.z(b, ag, true, a.e);
                        ai[1] = b.c;
                        ai[2] = b.d;
                    }
                    p.add(ai);
                    q.add(a.a.f.count - 1);
                    r.add(ag);
                }
            }
        }
        if (ab != null) {
            ab.ResetTimeCursor();
        }
        this.y(a, c, j, w, x, e, d);
        if (d) {
            let aj = p.count;
            let ak;
            for (let al = 0; al < aj; al++) {
                ak = p._inner[al];
                if (this.l(a.a, ak, t, Math.min(r._inner[al], b.e - 1), f, q._inner[al])) {
                    ++f;
                }
            }
        }
        return f;
    }
    k() {
        if (typeCast(Series.$, this.h) !== null) {
            return this.h.cy;
        }
        return false;
    }
    f(a, b, c, d, e, f, g) {
        let h;
        f = null;
        e = false;
        let i = typeCast(CategorySeries.$, this.h);
        let j = a.l;
        let k = a.m;
        let l = a.k;
        let m = new ScalerParams(0, k, j, a.b.j$a, l);
        let n = new ScalerParams(0, k, j, a.c.j$a, l);
        let o = a.e;
        if (a.d == null || a.d.i$b == null || a.d.i$b.count == 0) {
            return {
                ret: [NaN, NaN, NaN],
                p1: b,
                p4: e,
                p5: f
            };
        }
        if (i != null && i.cd != null && i.cd.count < a.d.i$b.count) {
            return {
                ret: [NaN, NaN, NaN],
                p1: b,
                p4: e,
                p5: f
            };
        }
        let p = a.d.i$b._inner[b];
        let q = a.d.i$d(p);
        let r = q;
        this.z(c, p, false, o);
        while (b < a.j) {
            p = a.d.i$b._inner[b + 1];
            r = a.d.i$d(p);
            this.z(c, p, true, o);
            if (r - q >= d || isNaN_(c.c) || isNaN_(c.d)) {
                if (e) {
                    let s = a.d.i$b._inner[b];
                    this.z(c, s, true, o);
                    f = [a.b.j$b(q, m), c.c, c.d];
                }
                break;
            }
            if (!e && this.k()) {
                let t = a.d.i$b._inner[b];
                this.z(c, t, true, o);
                let u = [a.b.j$b(q, m), c.c, c.d];
                if (!isNaN_(u[0])) {
                    if (!isNaN_(u[1]) && !isNaN_(u[2])) {
                        if (a.d != null) {
                            u[0] = u[0] + g;
                        }
                        a.a.f.add(u);
                        e = true;
                    }
                    else {
                        break;
                    }
                }
            }
            b++;
            this.u(c, p, o);
        }
        let v = NaN;
        if (!isNaN_(q)) {
            v = a.b.j$b(q, m);
        }
        h = this.e(v, c);
        return {
            ret: h,
            p1: b,
            p4: e,
            p5: f
        };
    }
    y(a, b, c, d, e, f, g) {
        let h = a.h;
        let i = a.a.f.count;
        let j = a.a.f;
        let k = this.o;
        let l = k.count;
        if (f) {
            let m = a.c.j$b(a.c.kn, e);
            a.c.j$e(a.a.k, 0, a.a.k.count, e);
            let n = a.a.k;
            let o = n.count;
            for (let p = 0; p < n.count; p++) {
                n._inner[p] = Math.abs(n._inner[p] - m);
            }
        }
    }
    w(a, b, c) {
    }
}
CategoryFramePreparerBase.$t = markType(CategoryFramePreparerBase, 'CategoryFramePreparerBase', FramePreparer.$);
/**
 * @hidden
 */
export class CategoryFramePreparer extends CategoryFramePreparerBase {
    constructor(a, ..._rest) {
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = _rest[0];
                    let d = [c, typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c), typeCast(IBucketizer_$type, c)];
                    {
                        let f = d[0];
                        let g = d[1];
                        let h = d[2];
                        let i = d[3];
                        let j = d[4];
                        super(1, f, g, h, i, j);
                        this.aa = new DefaultCategoryTrendlineHost();
                        this.ab = new DefaultSingleValueProvider();
                        this.ac = null;
                        this.ad = null;
                        this.ac = this.aa;
                        if (typeCast(IHasCategoryTrendline_$type, f) !== null) {
                            this.ac = typeCast(IHasCategoryTrendline_$type, f);
                        }
                        this.ad = this.ab;
                        if (typeCast(IHasSingleValueCategory_$type, f) !== null) {
                            this.ad = typeCast(IHasSingleValueCategory_$type, f);
                        }
                    }
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    let e = _rest[2];
                    let f = _rest[3];
                    let g = _rest[4];
                    super(1, c, d, e, f, g);
                    this.aa = new DefaultCategoryTrendlineHost();
                    this.ab = new DefaultSingleValueProvider();
                    this.ac = null;
                    this.ad = null;
                    this.ac = this.aa;
                    if (typeCast(IHasCategoryTrendline_$type, c) !== null) {
                        this.ac = typeCast(IHasCategoryTrendline_$type, c);
                    }
                    this.ad = this.ab;
                    if (typeCast(IHasSingleValueCategory_$type, c) !== null) {
                        this.ad = typeCast(IHasSingleValueCategory_$type, c);
                    }
                }
                break;
        }
    }
    l(a, b, c, d, e, f) {
        let g = b[0];
        let h = b[1];
        let i = new Rect(0, g - 5, h - 5, 11, 11);
        if (!isNaN_(g) && !isNaN_(h) && !isInfinity(g) && !isInfinity(h) && c.tryAdd(i)) {
            a.m.add({ $type: Point_$type, x: g, y: h });
            this.c.updateMarkerTemplate(e, d, f);
            return true;
        }
        return false;
    }
    j(a) {
        let b = new SingleValuesHolder();
        let c = this.ad.valueColumn;
        b.f = c;
        return b;
    }
    x(a, b, c, d, e, f) {
        if (d) {
            b[0] = b[0] + c;
        }
        else {
            b[0] = a.b.j$b(b[0], e) + c;
        }
        b[1] = a.c.j$b(b[1], f);
        if (a.h > 1 || d) {
            b[2] = a.c.j$b(b[2], f);
        }
        else {
            b[2] = b[1];
        }
    }
    y(a, b, c, d, e, f, g) {
        super.y(a, b, c, d, e, f, g);
        let h = a.h;
        let i = a.a.f.count;
        let j = a.a.f;
        let k = this.q;
        let l = k.count;
        let m = new List$1(Number_$type, 0);
        if (!c) {
            m.add(0);
        }
        let n = new List$1(Number_$type, 0);
        n.add(1);
        if (c || h > 1) {
            n.add(2);
        }
        a.b.j$d(j, m, 0, i, d);
        a.c.j$d(j, n, 0, i, e);
        for (let o = 0; o < i; o++) {
            j._inner[o][0] = j._inner[o][0] + b;
        }
        if (h == 1 && !c) {
            for (let p = 0; p < i; p++) {
                j._inner[p][2] = j._inner[p][1];
            }
        }
        if (g) {
            a.b.j$d(k, m, 0, l, d);
            a.c.j$d(k, n, 0, l, e);
            for (let q = 0; q < l; q++) {
                k._inner[q][0] = k._inner[q][0] + b;
            }
            if (h == 1 && !c) {
                for (let r = 0; r < l; r++) {
                    k._inner[r][2] = k._inner[r][1];
                }
            }
        }
    }
    w(a, b, c) {
        if (this.ac.trendLineType == 0 || this.ac.trendlinePreparer == null || this.ac.trendLinePeriod < 1) {
            return;
        }
        this.ac.trendlinePreparer.prepareLine(this.ac, a, b, c);
    }
    z(a, b, c, d) {
        let e = a;
        let f = e.f;
        let g = f.item(b);
        let h = g;
        if (d) {
            let i = this.g.getBucket(b);
            g = i[1];
            h = i[1];
        }
        if (c) {
            e.c = g;
            e.d = h;
        }
        else {
            e.a = g;
            e.b = h;
        }
    }
    u(a, b, c) {
        let d = a;
        let e = d.f;
        if (b < e.count) {
            let f;
            if (c) {
                let g = this.g.getBucket(b);
                f = g[1];
            }
            else {
                f = e.item(b);
            }
            d.a = Math.min(d.a, f);
            d.b = Math.max(d.b, f);
        }
    }
    e(a, b) {
        let c = b;
        return [a, c.a, c.b];
    }
}
CategoryFramePreparer.$t = markType(CategoryFramePreparer, 'CategoryFramePreparer', CategoryFramePreparerBase.$);
/**
 * @hidden
 */
export class CategorySeries extends MarkerSeries {
    constructor() {
        super();
        this.pz = null;
        this.qc = null;
        this.qg = false;
        this.qf = false;
        this.assigningCategoryStyle = null;
        this.assigningCategoryMarkerStyle = null;
        this.qa = null;
        this.qb = null;
        this.pw = new CategoryFrame(3);
        this.py = new CategoryFrame(3);
        this.pv = new CategoryFrame(3);
        this.px = new CategoryFrame(3);
        this.p2 = null;
        this.p6 = null;
        this.p2 = new CategorySeriesRenderManager();
        this.p6 = new CategoryTransitionSourceFramePreparer();
        this.qg = false;
        this.qf = false;
        this.ab = CategorySeries.$;
    }
    bp() {
        let a = new CategorySeriesView(this);
        return a;
    }
    get qd() {
        if (this.qc == null) {
            this.qc = DVContainer.instance.createInstance(ICategorySeriesInteractionManager_$type, () => this.cg.n);
        }
        return this.qc;
    }
    ct(a, b, c) {
        if (!this.hasMarkers) {
            return false;
        }
        let d = this.getEffectiveViewport1(this.bs);
        let e = this.fetchXAxis();
        let f = new ScalerParams(1, this.b6.os, this.n6, e.ca);
        f.c = d;
        let g = this.fetchYAxis();
        let h = new ScalerParams(1, this.b6.os, this.n6, g.ca);
        h.c = d;
        let i = this.b6.os;
        let j = this.n6;
        let k = this.currentMode2Index;
        let l = 0;
        if (e.b7 && e.b5) {
            l = e.getSeriesOffset(i, j, d, k, e.categoryMode);
        }
        a.clear();
        this.oh.cf((m) => {
            if (m._visibility == 0) {
                let n = new SeriesPointOfInterest();
                let o = m.n;
                let p = m.o;
                if (o < this.n6.left || o > this.n6.right || p < this.n6.top || p > this.n6.bottom) {
                    return;
                }
                if (e.b4 && !e.b7 && e.categoryMode != 0) {
                    n.b = m.ak;
                }
                else {
                    n.b = e.d2(o, f);
                }
                if (g.b4 && !g.b7 && g.categoryMode != 0) {
                    n.c = m.ak;
                }
                else {
                    n.c = g.d2(p, h);
                }
                n.a = m.content;
                if (b) {
                    n.d = this.qy(n.c, c);
                }
                else {
                    n.d = e.fm(m.ak);
                }
                a.add(n);
            }
        });
        return true;
    }
    qy(a, b) {
        if (b >= 0) {
            return round10N(a, b).toString();
        }
        else {
            return a.toString();
        }
    }
    kk(a) {
        super.kk(a);
        this.p3 = a;
    }
    preferredCategoryMode(a) {
        return 0;
    }
    get categoryAxis() {
        return this.pu();
    }
    pu() {
        return this.fetchXAxis();
    }
    qe() {
        return this.fetchYAxis();
    }
    get_cz() {
        return true;
    }
    ac() {
        super.ac();
        this.p3.cr.g(this.fq);
    }
    qm() {
        return (this.assigningCategoryStyle != null && this.qg) || (this.be != 1);
    }
    qn() {
        return (this.assigningCategoryMarkerStyle != null && this.qf) || (this.be != 1);
    }
    rb(a) {
        if (this.assigningCategoryStyle != null && this.qg) {
            this.assigningCategoryStyle(this, a);
        }
    }
    ra(a) {
        if (this.assigningCategoryMarkerStyle != null && this.qf) {
            this.assigningCategoryMarkerStyle(this, a);
        }
    }
    po(a, b) {
        return null;
    }
    jl(a, b) {
        super.jl(a, b);
        if (a) {
            this.q5(b);
        }
    }
    bb() {
        let a = super.bb();
        return a;
    }
    j2() {
        super.j2();
        let a = this.fetchXAxis();
        if (a != null) {
            a.hc(false);
        }
        let b = this.fetchYAxis();
        if (b != null) {
            b.hc(false);
        }
    }
    lo(a, b) {
        super.lo(a, b);
        this.p3.cr.g(this.fq);
        this.k3(false);
    }
    ln(a, b) {
        if (this.d3 && this.fw < 0.05 && (this.b6 == null || !this.b6.dz())) {
            this.d4 = true;
        }
        super.ln(a, b);
        this.p3.cr.g(this.fq);
        this.k3(false);
    }
    kp(a, b, c, d) {
        super.kp(a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                let e = this.fetchYAxis();
                let f = this.fetchXAxis();
                if (c != null && d == null) {
                    this.jp(f);
                    this.jp(e);
                }
                if (c == null && d != null) {
                    this.ku(f);
                    this.ku(e);
                }
                this.p3.cr.g(this.fq);
                this.k3(false);
                break;
            case "SyncLink":
                if (this.b1 != null && this.b6 != null) {
                    this.p3.cr.g(this.fq);
                }
                this.k3(false);
                break;
            case "TransitionProgress":
                this.py.c(this.fw, this.pw, this.pv);
                if (this.cp(this.bs)) {
                    return;
                }
                if (this.fw == 1) {
                    this.pv.v();
                    this.rc(this.pv, this.p3);
                    if (this.d3) {
                        this.d3 = false;
                        this.jm();
                        this.b7.r = truncate(this.fk());
                        this.b7.b = this.b8;
                    }
                }
                else {
                    this.rc(this.py, this.p3);
                }
                if (this.b6 != null) {
                    this.b6.k7(this);
                }
                break;
            case "ErrorBarSettings":
                this.ka();
                break;
            case CategorySeries.$$p[4]:
                this.k3(false);
                break;
            case CategorySeries.$$p[1]:
                this.qg = this.qi();
                this.k3(false);
                break;
            case CategorySeries.$$p[0]:
                this.qf = this.qh();
                this.k3(false);
                break;
        }
    }
    qi() {
        return this.qk;
    }
    qh() {
        return this.qj;
    }
    qs(a) {
        return this.e6(a, this.fetchXAxis());
    }
    get_dg() {
        return typeCast(ISortingAxis_$type, this.pu()) !== null;
    }
    aq() {
        return this.pu();
    }
    gb(a) {
        return this.qd.b$d(this, a);
    }
    gq(a) {
        return this.qd.b$f(this, a);
    }
    f9(a) {
        let b = truncate(Math.round(this.e4(a)));
        return b;
    }
    e4(a) {
        return this.qd.b$c(this, a);
    }
    av(a, b, c) {
        if (this.dl(this.be) && !c) {
            let d = this.p9(a, b, this.qb);
            this.qb = d;
            return d;
        }
        else {
            let e = this.p7(a, b, this.qb);
            e.e = true;
            this.qb = e;
            return e;
        }
    }
    get_da() {
        return true;
    }
    jj() {
        super.jj();
        this.qa = null;
        this.qb = null;
    }
    au(a, b, c) {
        if (this.cu && this.dl(this.be) && !c) {
            let d = this.p8(a, b, this.qa);
            this.qa = d;
            return d;
        }
        else {
            let e = this.p7(a, b, this.qa);
            this.qa = e;
            return e;
        }
    }
    qr() {
        return this.p3.cu.a;
    }
    p9(a, b, c) {
        if (!this.ok()) {
            return null;
        }
        let d = this.pv;
        if (this.cn()) {
            d = this.py;
        }
        let e = this.qr();
        return this.qd.b$b(this, e, this.qv(this.bs), this.qu(this.bs), d.f, a, b, c);
    }
    p8(a, b, c) {
        let d = this.qv(this.bs);
        let e = this.qw(this.bs);
        let f = this.qu(this.bs);
        let g = this.pv;
        if (this.cn()) {
            g = this.py;
        }
        return this.qd.b$a(this, g.f, d, e, f, a, b, c);
    }
    p7(a, b, c) {
        let d = new HighlightingInfo();
        d.b = this;
        d.h = 0;
        d.g = this.cd.count - 1;
        d.d = true;
        if (c != null && c.h == d.h && c.g == d.g) {
            return c;
        }
        return d;
    }
    q7(a, b, c, d, e, f) {
        let g = this.be != 1;
        this.p2.a1(this.p2.d, d.cf, a, b, c, d, e, f, true);
        this.p2.aa(this.es);
        let h = this.p2.av;
        let i = null;
        let j = this.cd;
        let k = null;
        if (g && this.b6 != null) {
            i = this.b6.az.getHighlightingInfo(this, j, h.o, h.n, true);
            if (this.b6.az.isCrossSeriesHighlight(this)) {
                k = this.b6.az.getHighlightingInfo(this, j, h.o, h.n, true);
            }
            h.b = i;
        }
        h.f = f;
        this.ra(h);
        this.p2.y(this, i, f, g, h.m, this.b6.az.totalHighlightingProgress);
    }
    q8(a, b, c, d, e, f) {
        let g = this.be != 1;
        this.p2.a1(this.p2.b, d.cf, a, b, c, d, e, f, false);
        this.p2.ab(this.es);
        let h = this.p2.aw;
        let i = null;
        let j = this.cd;
        if (g && this.b6 != null) {
            i = this.b6.az.getHighlightingInfo(this, j, h.o, h.n, false);
            h.b = i;
        }
        h.f = f;
        this.rb(h);
        this.p2.z(this, i, f, g, b < 0);
    }
    ec(a, b, c) {
        let d = super.ec(a, b, c);
        d = d && this.qq(this.fetchXAxis());
        d = d && this.qq(this.fetchYAxis());
        let e = c;
        if (!c.o() || b.isEmpty || a.isEmpty || this.cd == null) {
            d = false;
        }
        if (!d) {
            e.cr.d = 0;
        }
        return d;
    }
    qq(a) {
        if (a == null || a.bh == null) {
            return false;
        }
        let b = typeCast(CategoryAxisBase.$, a);
        if (b != null) {
            if (b.itemsSource == null) {
                return false;
            }
            if (b.j8 < 1) {
                return false;
            }
        }
        else {
            let c = typeCast(NumericAxisBase.$, a);
            if (c != null) {
                return c.kd != c.kc;
            }
        }
        return true;
    }
    dt() {
        return this.ql;
    }
    p4() {
        return 12;
    }
    jm() {
        super.jm();
        this.pw.v();
        this.pv.v();
        this.py.v();
    }
    k4(a) {
        super.k4(a);
        this.p3.cr.g(this.fq);
        if (this.cp(this.bs)) {
            this.pv.y();
            this.py.y();
            this.pw.y();
            return;
        }
        if (this.dv) {
            if (this.cn()) {
                if (this.b7.g) {
                    this.b7.t();
                }
                this.rc(this.py, this.p3);
            }
            else {
                this.rc(this.pv, this.p3);
            }
            return;
        }
        if (this.dr(a)) {
            let b = this.pw;
            if (this.cn()) {
                if (this.b7.g) {
                    this.b7.t();
                }
                this.pw = this.py;
                this.py = b;
            }
            else {
                this.pw = this.pv;
                this.pv = b;
            }
            this.q9(this.pv, this.p3);
            if (this.d5) {
                this.b7.w();
                this.b7.r = truncate(this.fl());
                this.b7.b = this.b9 != null ? this.b9 : this.b8;
                this.p6.p(this.pw, this.pv, this.isVertical, this.fetchXAxis(), this.fetchYAxis(), this.p5, this.p4(), this.b3, this.b2(), runOn(this, this.qt), this.p3.bu);
            }
            this.jh();
            this.lb();
            if (this.d5) {
                this.d4 = false;
                this.d3 = true;
            }
        }
        else {
            this.q9(this.pv, this.p3);
            this.rc(this.pv, this.p3);
        }
    }
    b2() {
        return 3;
    }
    qt() {
        if (this.isVertical) {
            return this.n6.left;
        }
        return this.n6.bottom;
    }
    qx() {
        let a = 0;
        let b = this.fetchXAxis();
        for (let c of fromEnum(this.b6.series)) {
            if (c == this) {
                return a;
            }
            let d = typeCast(CategorySeries.$, c);
            if (d != null) {
                let e = typeCast(CategoryAxisBase.$, d.fetchXAxis());
                if (e == b && d.preferredCategoryMode(e) == 2) {
                    a++;
                }
            }
        }
        return -1;
    }
    get GetErrorBarsXAxis() {
        return this.fetchXAxis();
    }
    get GetErrorBarsYAxis() {
        return this.fetchYAxis();
    }
    q6(a, b) {
        this.p2.az(this, this.qn(), runOn(this, this.po), this.qu(a), this.qv(a));
        let c = this.p2.d;
        let d = c != null;
        let e = this.pu();
        if (e == null) {
            return;
        }
        let f = this.getEffectiveViewport1(a);
        let g = new ScalerParams(0, a.bv, a.bu, e.ca, f);
        let h = this.cd == null ? 0 : this.cd.count;
        let i = a;
        let j = b.f;
        let k = i.cr.e;
        let l = i.cr.f;
        let m = i.cr.d;
        let n = k * m;
        for (let o = 0; o < a.cu.count; o++) {
            let p = a.cu.item(o);
            let q = p.content;
            if (d) {
                let r = p.al;
                this.q7(j, r, h, e, g, a.q);
            }
            this.p2.ac(p, q);
        }
    }
    rc(a, b) {
        this.nx = a.aa;
        b.au();
    }
    q9(a, b) {
        a.u();
    }
    qu(a) {
        return a.cr.d;
    }
    qv(a) {
        return a.cr.e;
    }
    qw(a) {
        return a.cr.f;
    }
    q5(a) {
        let b = a;
        b.cu.count = 0;
    }
    k5(a, b) {
        super.k5(a, b);
        if (!this.d2) {
            this.bs.a2(b);
            return;
        }
        let c = typeCast(CategorySeriesView.$, this.br);
        c.cr.g(this.fq);
        this.bs.a2(b);
        if (this.cp(this.br)) {
            return;
        }
        this.rd();
        this.d2 = false;
    }
    rd() {
        let a = typeCast(CategorySeriesView.$, this.br);
        if (!this.dw) {
            this.q9(this.px, a);
        }
        this.dw = false;
        this.rc(this.px, a);
    }
    p0(a) {
        let b = typeCast(CategorySeriesView.$, a);
        if (b != null && b.q) {
            if (b.p) {
                return new CategoryFramePreparer(1, typeCast(IIsCategoryBased_$type, this), typeCast(ISupportsMarkers_$type, b), b, this, b.cr);
            }
            else {
                return new CategoryFramePreparer(1, typeCast(IIsCategoryBased_$type, this), typeCast(ISupportsMarkers_$type, b), this.b6.b8.o, this, b.cr);
            }
        }
        else {
            return this.pz;
        }
    }
    am(a) {
        if (this.fetchXAxis() == a) {
            return this.fetchYAxis();
        }
        if (this.fetchYAxis() == a) {
            return this.fetchXAxis();
        }
        return null;
    }
    ag() {
        return [this.fetchXAxis(), this.fetchYAxis()];
    }
    static pp(a, b, c, d, e) {
        let f = null;
        if (b > -1 && !d.isEmpty && !c.isEmpty) {
            let g = a._inner[0][0] < c.left - 2000 ? c.left - 10 : NaN;
            let h = c.bottom + 10;
            let i = a._inner[b][0] > c.right + 2000 ? c.right + 10 : NaN;
            let j = c.top - 10;
            f = new Clipper(1, g, h, i, j, e);
        }
        return f;
    }
}
CategorySeries.$t = markType(CategorySeries, 'CategorySeries', MarkerSeries.$, [IHasCategoryModePreference_$type, ISupportsErrorBars_$type]);
CategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, CategorySeries, 'raisePropertyChanged', ['IsCustomCategoryMarkerStyleAllowed:qj:re', [0, false], 'IsCustomCategoryStyleAllowed:qk:rf', [0, false], 'IsTransitionInEnabled:ql:rg', [0, false], 'TransitionInMode:p5:rh', [CategoryTransitionInMode_$type, enumGetBox(CategoryTransitionInMode_$type, 0)], 'UseHighMarkerFidelity:qp:ri', [0, false]]);
/**
 * @hidden
 */
export class CategorySeriesView extends MarkerSeriesView {
    constructor(a) {
        super(a);
        this.ct = null;
        this.cw = 0;
        this.cr = null;
        this.cu = null;
        this.cw = -1;
        this.ct = a;
        this.cr = this.cs();
        this.cu = ((() => {
            let $ret = new Pool$1(Marker.$);
            $ret.create = runOn(this, this.b0);
            $ret.activate = runOn(this, this.cj);
            $ret.disactivate = runOn(this, this.cl);
            $ret.destroy = runOn(this, this.ck);
            return $ret;
        })());
    }
    cv(a) {
        if (this.cw != a.t) {
            return true;
        }
        return false;
    }
    cy(a) {
        this.cw = a.t;
    }
    updateMarkerTemplate(a, b, c) {
        if (!this.b1.om) {
            let d = this.cu.item(a);
            let e = d.content;
            e.item = this.e.cd.item(b);
            d.ak = b;
            d.al = c;
        }
    }
    cs() {
        return new CategoryBucketCalculator(this);
    }
    get shouldDisplayMarkers() {
        return this.ct.ok();
    }
    updateMarkerCount(a) {
        this.cu.count = a;
    }
    cf(a) {
        this.cu.c(a);
    }
    cx() {
    }
}
CategorySeriesView.$t = markType(CategorySeriesView, 'CategorySeriesView', MarkerSeriesView.$, [ISupportsMarkers_$type]);
//# sourceMappingURL=CategoryBucketCalculator_combined.js.map