/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { CategoryAxisBase } from "./CategoryAxisBase";
import { Base, Number_$type, typeCast, Array_$type, markType, TypeRegistrar } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { HorizontalAxisLabelPanel } from "./HorizontalAxisLabelPanel";
import { Rect } from "igniteui-angular-core";
import { MathUtil } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { NumericScaler } from "./NumericScaler";
import { LinearCategorySnapper } from "./LinearCategorySnapper";
import { NumericYAxis } from "./NumericYAxis";
import { LabelPosition } from "./LabelPosition";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate, isNaN_, isInfinity } from "igniteui-angular-core";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
/**
 * @hidden
 */
export class CategoryXAxis extends CategoryAxisBase {
    constructor() {
        super();
        this.li = 1;
        this.lh = 1;
        this.ll = null;
        this.k8 = 0;
        this.k9 = 0;
        this.jv = new List$1(Number_$type, 0);
        this.ab = CategoryXAxis.$;
    }
    a3() {
        return new CategoryXAxisView(this);
    }
    gy(a) {
        super.gy(a);
        this.k6 = a;
    }
    get lk() {
        return this.li;
    }
    set lk(a) {
        this.li = a;
    }
    get lj() {
        return this.lh;
    }
    set lj(a) {
        this.lh = a;
    }
    au() {
        if (this.cr) {
            return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
        }
        else {
            return new HorizontalAxisLabelPanel();
        }
    }
    getCategorySize(a, b, c) {
        let d = this.i8(b, c);
        return d.width / (this.j8 * a.width);
    }
    j0(a, b, c) {
        let d = !isNaN_(this.jx) ? MathUtil.b(this.jx, 0, 1) : 0;
        let e = 0;
        if (!isNaN_(this.j4)) {
            e = Math.min(this.j4, 1);
        }
        else {
            e = 0;
        }
        ;
        let f = 1 - 0.5 * d;
        let g = this.ka == 0 ? 1 : this.ka;
        let h = this.getCategorySize(a, b, c) * f / (g - (g - 1) * e);
        return h;
    }
    getGroupCenter(a, b, c, d) {
        let e = 0.5;
        if (this.ka > 1) {
            let f = !isNaN_(this.jx) ? MathUtil.b(this.jx, 0, 1) : 0;
            let g = 0;
            if (!isNaN_(this.j4)) {
                g = Math.min(this.j4, 1);
            }
            let h = 1 - 0.5 * f;
            let i = h / (this.ka - (this.ka - 1) * g);
            let j = (h - i) / (this.ka - 1);
            e = 0.25 * f + 0.5 * i + a * j;
        }
        return this.getCategorySize(b, c, d) * e;
    }
    dm() {
        return this.lf;
    }
    lq(a) {
        let b = this.bh != null ? this.bh.os : Rect.empty;
        b = b.copy();
        let c = this.ja;
        let d = this.i7();
        let e = new Rect(0, 0, 0, 1, 1);
        let f = new ScalerParams(0, e, e, this.ca, d);
        let g = !b.isEmpty && !c.isEmpty && this.jo != null ? this.jo.indexOf(a) : -1;
        let h = g > -1 ? this.dz(g, f) : NaN;
        if (!isNaN_(h) && this.bh.dt) {
            if (!isNaN_(h)) {
                if (h < b.left + 0.1 * b.width) {
                    h = h + 0.4 * b.width;
                    b.x = h - 0.5 * b.width;
                }
                if (h > b.right - 0.1 * b.width) {
                    h = h - 0.4 * b.width;
                    b.x = h - 0.5 * b.width;
                }
            }
            this.bh.md(b, false, true);
        }
    }
    dz(a, b) {
        if (!b.c.isEmpty) {
            let c = this.le(a, NumericScaler.ac, b.c, this.categoryMode);
            c = (c - b.d.left) / b.d.width;
            c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
            return c;
        }
        return this.le(a, b.e, b.d, this.categoryMode);
    }
    k5(a) {
        if (typeCast(List$1.$.specialize(Array_$type), a) !== null) {
            return a.asArray();
        }
        return null;
    }
    gs(a, b, c, d, e) {
        let f;
        let g = e.e;
        let h = e.d;
        let i = e.c;
        let j = e.a;
        let k = !i.isEmpty;
        let l = this.categoryMode == 0 ? this.j8 - 1 : this.j8;
        if (l < 0) {
            l = 0;
        }
        let m = i.left;
        let n = i.width;
        let o = g.left;
        let p = g.width;
        let q = h.left;
        let r = h.width;
        let s = 0;
        let t = 1;
        let u = this.k5(a);
        let v = false;
        if (u != null) {
            v = true;
        }
        let w;
        for (let x = 0; x < b.count; x++) {
            w = b.item(x);
            for (let y = c; y < d; y++) {
                if (v) {
                    f = u[y];
                }
                else {
                    f = a.item(y);
                }
                if (k) {
                    let z = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                    if (j) {
                        z = 1 - z;
                    }
                    z = m + n * (z - s) / t;
                    z = (z - q) / r;
                    let aa = q + r * (z - o) / p;
                    f[w] = aa;
                }
                else {
                    let ab = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                    if (j) {
                        ab = 1 - ab;
                    }
                    ab = q + r * (ab - o) / p;
                    f[w] = ab;
                }
            }
        }
    }
    d0(a, b, c) {
        if (!b.c.isEmpty) {
            let d = this.le(a, NumericScaler.ac, b.c, c);
            d = (d - b.d.left) / b.d.width;
            d = b.d.left + b.d.width * (d - b.e.left) / b.e.width;
            return d;
        }
        return this.le(a, b.e, b.d, c);
    }
    le(a, b, c, d) {
        let e = d == 0 ? this.j8 - 1 : this.j8;
        if (e < 0) {
            e = 0;
        }
        let f = e >= 1 ? (a) / (e) : e == 0 ? 0.5 : NaN;
        if (this.cb) {
            f = 1 - f;
        }
        return c.left + c.width * (f - b.left) / b.width;
    }
    d2(a, b) {
        if (!b.c.isEmpty) {
            let c = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
            c = (c * b.d.width) + b.d.left;
            c = this.getUnscaledValue3(c, NumericScaler.ac, b.c, this.categoryMode);
            return c;
        }
        return this.getUnscaledValue3(a, b.e, b.d, this.categoryMode);
    }
    d3(a, b, c) {
        if (!b.c.isEmpty) {
            let d = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
            d = (d * b.d.width) + b.d.left;
            d = this.getUnscaledValue3(d, NumericScaler.ac, b.c, c);
            return d;
        }
        return this.getUnscaledValue3(a, b.e, b.d, c);
    }
    getUnscaledValue3(a, b, c, d) {
        let e = b.left + (a - c.left) * b.width / c.width;
        if (this.cb) {
            e = 1 - e;
        }
        let f = d == 0 ? this.j8 - 1 : this.j8;
        if (f < 0) {
            f = 0;
        }
        return e * f;
    }
    lr(a, b) {
        if (a == NaN || b == NaN || this.jo == null || this.jo.count == 0) {
            return;
        }
        let c = a / this.jo.count;
        let d = (b + 1) / this.jo.count;
        this.bh.o8 = new Rect(0, c, this.bh.o8.y, d - c, this.bh.o8.height);
    }
    hd(a) {
        super.hd(a);
        let b = this.bh != null ? this.bh.os : Rect.empty;
        let c = this.ja;
        let d = this.i5();
        let e = this.i4();
        let f = new ScalerParams(0, b, c, this.ca, d);
        let g = this.a4.ay();
        let h = this.a4.a1();
        let i = this.a4.az();
        let j = this.a4.a0();
        let k = this.a4.e();
        let l = this.a4.f();
        let m = this.a4.g();
        let n = this.jo;
        let o = this.k7();
        this.hl();
        this.go(g);
        this.go(h);
        this.go(i);
        this.go(j);
        this.cx.clear();
        this.cy.clear();
        this.jv.clear();
        this.a4.at(this, b, c);
        if (b.isEmpty || c.isEmpty) {
            this.bq.count = 0;
            this.bp.count = 0;
            this.bo.count = 0;
        }
        if (this.bq.count == 0 && this.bp.count == 0) {
            this.a4.y();
        }
        if (this.ay != null) {
            this.ay.registerAxis(this);
        }
        if (this.itemsSource == null || o == null || n.count == 0) {
            this.bq.count = 0;
            this.bp.count = 0;
            this.bo.count = 0;
            this.a4.y();
            return;
        }
        if (!b.isEmpty && !c.isEmpty) {
            let p = this.d2(e.left, f);
            let q = this.d2(e.right, f);
            let r = 0;
            let s = false;
            if (this.cq) {
                let t = Math.abs(q - p);
                r = Math.ceil(t) + 1;
                if (this.ca) {
                    if (Math.abs(q - Math.floor(q)) < Math.abs(p - Math.ceil(p))) {
                        s = true;
                    }
                }
                else {
                    if (Math.abs(q - Math.ceil(q)) < Math.abs(p - Math.floor(p))) {
                        s = true;
                    }
                }
            }
            if (this.ca) {
                p = Math.ceil(p);
                q = Math.floor(q);
            }
            else {
                p = Math.floor(p);
                q = Math.ceil(q);
            }
            if (this.cq) {
                if (Math.abs(q - p) < r) {
                    if (this.ca) {
                        if (s) {
                            q--;
                        }
                        else {
                            p++;
                        }
                    }
                    else {
                        if (s) {
                            q++;
                        }
                        else {
                            p--;
                        }
                    }
                }
            }
            let u = c.bottom;
            let v = u - c.top;
            if (this.ai != null) {
                let w = typeCast(NumericYAxis.$, this.ai);
                if (w != null) {
                    let x = this.hh(u, v, b, c, d, c.top, c.bottom);
                    u = x.p0;
                    v = x.p1;
                }
            }
            this.gw(g, u, c, k, true);
            this.a4.ao(v);
            let y = Math.min(p, q);
            let z = Math.max(p, q);
            let aa = e.width;
            if (this.cq) {
                let ab = this.dz(y, f);
                let ac = this.dz(z, f);
                aa = Math.abs(ac - ab);
            }
            let ad = new LinearCategorySnapper(1, y, z, aa, this.lf, this.categoryMode, this.ec());
            let ae = Math.floor((y - 0) / ad.g);
            let af = Math.ceil((z - 0) / ad.g);
            this.la = ad.g;
            if (!isNaN_(ae) && !isNaN_(af)) {
                let ag = truncate(ae);
                let ah = truncate(af);
                let ai = this.ld(0 + ag * ad.g, f);
                let aj = this.dz(ad.g, f);
                let ak = Math.abs(aj - this.dz(0, f));
                this.a4.ap(aj);
                let al = truncate(Math.ceil(e.right));
                let am = truncate(Math.floor(e.left));
                let an = this.lg;
                let ao = an > 0 && an < ad.g;
                let ap = c.right;
                let aq = this.jv;
                let ar = ad.g;
                let as = truncate(ar);
                let at = this.ka;
                let au = this.ca;
                let av = this.categoryMode;
                this.ll = null;
                for (let aw = ag; aw <= ah; ++aw) {
                    let ax = this.ld(0 + (aw + 1) * ad.g, f);
                    if (ai <= ap) {
                        if (aw % 2 == 0) {
                            this.hn(h, ai, ax, c);
                        }
                        this.hm(i, ai, c, l, false);
                        aq.add(ai);
                    }
                    if (this.categoryMode != 0 && this.ka != 0 && this.cl) {
                        if (ao) {
                            let ay = ak * this.lg;
                            if (this.ca) {
                                let az = ai;
                                while (az - ay > ax) {
                                    az -= ay;
                                    if (Math.abs(az - ax) < 0.0001) {
                                        break;
                                    }
                                    this.hm(j, az, c, m, false);
                                }
                            }
                            else {
                                let a0 = ai;
                                while (a0 + ay < ax) {
                                    a0 += ay;
                                    if (Math.abs(a0 - ax) < 0.0001) {
                                        break;
                                    }
                                    this.hm(j, a0, c, m, false);
                                }
                            }
                            this.lb = this.lg;
                        }
                        else {
                            for (let a1 = 0; a1 < truncate(ad.g); a1++) {
                                for (let a2 = 0; a2 < this.ka; a2++) {
                                    let a3 = this.getGroupCenter(a2, b, c, d);
                                    if (this.ca) {
                                        a3 = -a3;
                                    }
                                    let a4 = this.dz(a1 + aw * ad.g, f) + a3;
                                    this.hm(j, a4, c, m, false);
                                }
                            }
                            this.lb = 0.5;
                        }
                    }
                    let a5 = this.lc(aw * ar, ai, av == 0, f);
                    let a6 = truncate(Math.round(a5));
                    if (a6 >= am && a6 <= al) {
                        let a7 = 0;
                        if (ar >= 1) {
                            a7 = aw * truncate(Math.floor(ar));
                        }
                        else {
                            if ((aw * ar) * 2 % 2 == 0) {
                                a7 = truncate(Math.floor(aw * ar));
                            }
                            else {
                                a7 = -1;
                            }
                        }
                        if (o != null && a7 < n.count && a7 >= 0) {
                            let a8 = o.getItem(a7);
                            let a9 = this.e9(a8);
                            this.ll = a8;
                            if (!isNaN_(a5) && !isInfinity(a5) && a9 != null) {
                                if ((typeof a9 === 'string') && Base.equalsStatic(a9, "")) {
                                }
                                else {
                                    this.cx.add1(a9);
                                    this.cy.add(new LabelPosition(a5));
                                }
                            }
                        }
                    }
                    ai = ax;
                }
            }
            this.ll = null;
            if ((this.ay == null || this.ay.visibility == 0) && this.ai != null) {
                if (this.ay != null && (this.ay.location == 4 || this.ay.location == 5)) {
                    this.bh.ja();
                }
            }
            this.a4.au(this.cx, this.cy);
            this.kv();
        }
    }
    cp() {
        if (this.ci && this.cq) {
            this.bb = this.ba();
        }
        if (this.jo == null) {
            return false;
        }
        let a = this.jo.count;
        if (a != this.lj) {
            let b = new AxisRangeChangedEventArgs(0, 1, 1, this.lj, a);
            this.lj = a;
            this.g7(b);
            return true;
        }
        return false;
    }
    get lf() {
        return this.c(CategoryXAxis.ls);
    }
    set lf(a) {
        this.h(CategoryXAxis.ls, a);
    }
    get la() {
        return this.k8;
    }
    set la(a) {
        if (this.la != a) {
            let b = this.k8;
            this.k8 = a;
            this.g6("ActualInterval", b, this.la);
        }
    }
    ea() {
        return this.la;
    }
    get lg() {
        return this.c(CategoryXAxis.lt);
    }
    set lg(a) {
        this.h(CategoryXAxis.lt, a);
    }
    get lb() {
        return this.k9;
    }
    set lb(a) {
        if (this.lb != a) {
            let b = this.k9;
            this.k9 = a;
            this.g6("ActualMinorInterval", b, this.lb);
        }
    }
    jr(a) {
        if (a == null) {
            return false;
        }
        let b = this.bd();
        if (b == null) {
            return false;
        }
        return b.synchronizeHorizontally;
    }
    get_a1() {
        return 0;
    }
    get a1() {
        return this.get_a1();
    }
    k7() {
        return this.jo;
    }
    ld(a, b) {
        return this.dz(a, b);
    }
    lc(a, b, c, d) {
        if (!c) {
            let e = this.ld(a + 1, d);
            return (b + e) / 2;
        }
        return b;
    }
    get isVertical() {
        return this.ch;
    }
    j$c(a, b) {
        return this.d2.apply(this, arguments);
    }
    j$b(a, b) {
        return this.dz.apply(this, arguments);
    }
    j$d(a, b, c, d, e) {
        this.gs.apply(this, arguments);
    }
    j$e(a, b, c, d) {
        this.gt.apply(this, arguments);
    }
    j$f(a, b, c, d) {
        this.gu.apply(this, arguments);
    }
    get j$a() {
        return this.ca;
    }
}
CategoryXAxis.$t = markType(CategoryXAxis, 'CategoryXAxis', CategoryAxisBase.$);
CategoryXAxis.ls = DependencyProperty.i("Interval", Number_$type, CategoryXAxis.$, new PropertyMetadata(2, NaN, (a, b) => {
    a.g6("Interval", b.oldValue, b.newValue);
    a.hc(false);
}));
CategoryXAxis.lt = DependencyProperty.i("MinorInterval", Number_$type, CategoryXAxis.$, new PropertyMetadata(2, NaN, (a, b) => {
    (typeCast(CategoryXAxis.$, a)).g6("MinorInterval", b.oldValue, b.newValue);
    (typeCast(CategoryXAxis.$, a)).hc(false);
}));
/**
 * @hidden
 */
export class CategoryXAxisView extends CategoryAxisBaseView {
    constructor(a) {
        super(a);
        this.bg = null;
        this.bg = a;
    }
}
CategoryXAxisView.$t = markType(CategoryXAxisView, 'CategoryXAxisView', CategoryAxisBaseView.$);
//# sourceMappingURL=CategoryXAxis_combined.js.map