/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Brush } from "igniteui-angular-core";
import { XYChart } from "./XYChart";
import { IndicatorPane } from "./IndicatorPane";
import { Base, BaseError, EventArgs, runOn, delegateRemove, delegateCombine, typeCast, fromEnum, EnumUtil, Number_$type, String_$type, enumGetBox, markType, TypeRegistrar, fromEn } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { DataSeriesType_$type } from "igniteui-angular-core";
import { IDataSeriesAdapterRule_$type } from "igniteui-angular-core";
import { SimpleFinancialPriceSeriesRule } from "igniteui-angular-core";
import { SubCollectionsRule } from "igniteui-angular-core";
import { XamDataChart } from "./XamDataChart";
import { FinancialChartVolumeType_$type } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode_$type } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode_$type } from "./FinancialChartYAxisMode";
import { FinancialChartType_$type } from "./FinancialChartType";
import { NumericYAxis } from "./NumericYAxis";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { FinancialChartZoomSliderType_$type } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "igniteui-angular-core";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { ObservableCollection$1 } from "igniteui-angular-core";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartViewModel } from "./FinancialChartViewModel";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { Series } from "./Series";
import { Rect } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { MarkerSeries } from "./MarkerSeries";
import { SyncSettings } from "./SyncSettings";
import { SyncManager } from "./SyncManager";
import { FinancialOverlayType_$type } from "./FinancialOverlayType";
import { ArrayExtension } from "igniteui-angular-core";
import { FinancialIndicatorType_$type } from "./FinancialIndicatorType";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { FinancialChartVisualData } from "./FinancialChartVisualData";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { ScalerParams } from "./ScalerParams";
import { stringReplace, stringJoin, stringIsNullOrEmpty } from "igniteui-angular-core";
import { timeSpanFromDays } from "igniteui-angular-core";
import { dateMaxValue, dateMinValue } from "igniteui-angular-core";
import { isNaN_, isInfinity } from "igniteui-angular-core";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartIndicatorMenu } from "./FinancialChartIndicatorMenu";
import { TrendLineType_$type } from "igniteui-angular-core";
import { FinancialChartIndicatorMenuContext } from "./FinancialChartIndicatorMenuContext";
import { FinancialChartTypePickerContext } from "./FinancialChartTypePickerContext";
import { FinancialChartRangeSelectorContext } from "./FinancialChartRangeSelectorContext";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorView } from "./FinancialChartRangeSelectorView";
/**
 * @hidden
 */
export class FinancialChart extends XYChart {
    constructor() {
        super();
        this.r1 = null;
        this.uj = null;
        this.uh = null;
        this.ue = null;
        this.ug = null;
        this.ui = null;
        this.uf = null;
        this.q7 = null;
        this.u1 = null;
        this.u2 = null;
        this.uy = null;
        this.u3 = null;
        this.u4 = null;
        this.uz = null;
        this.u0 = null;
        this.sp = null;
        this.tu = 40;
        this.rv = null;
        this.rt = null;
        this.rx = null;
        this.r2 = null;
        this.vc = null;
        this.sl = null;
        this.s9 = false;
        this.s8 = false;
        this.te = false;
        this.sv = false;
        this.up = 10;
        this.tw = NaN;
        this.ty = NaN;
        this.tx = NaN;
        this.tz = 0;
        this.rd = 0;
        this.rg = 0;
        this.ri = 0;
        this.ss = true;
        this.q9 = 0;
        this.st = false;
        this.rn = null;
        this.rp = null;
        this.tg = null;
        this.su = true;
        this.sm = null;
        this.rk = 1;
        this.qb = null;
        this.qc = null;
        this.qd = null;
        this.qe = null;
        this.qg = null;
        this.qf = null;
        this.qa = null;
        this.p9 = null;
        this.tv = 1;
        this.tt = 1;
        this.ts = 1;
        this.rz = null;
        this.ul = -2147483648;
        this.tr = 2;
        this.uo = 3;
        this.um = 10;
        this.uk = 30;
        this.un = 9;
        this.q4 = null;
        this.q5 = null;
        this.q0 = null;
        this.applyCustomIndicators = null;
        this.yx = null;
        this.t0 = 1;
        this.sr = false;
        this.rr = null;
        this.to = dateMinValue();
        this.tn = dateMaxValue();
        this.tl = null;
        this.hf();
        this.tl = new ObservableCollection$1(Base.$, 0);
        if (this.xAxisBreaks != null) {
            let a = this.xAxisBreaks;
            a.collectionChanged = delegateCombine(a.collectionChanged, (a, b) => this.ym());
        }
        this.x7();
    }
    ig(a, b, c) {
        super.ig(a, b, c);
        switch (a) {
            case "ToolbarTemplate":
            case "RangeSelectorTemplate":
                this.q8 = new FinancialChartToolbar(this, this.u9);
                break;
            case "Toolbar":
                let d = b;
                if (d != null) {
                    d.chartTypeChanged = delegateRemove(d.chartTypeChanged, runOn(this, this.xv));
                    d.trendLineTypeChanged = delegateRemove(d.trendLineTypeChanged, runOn(this, this.xy));
                    d.volumeTypeChanged = delegateRemove(d.volumeTypeChanged, runOn(this, this.xz));
                    d.l(null);
                }
                if (this.q8 != null) {
                    this.q8.ac = this.rf;
                    this.q8.ai = this.a9;
                    this.q8.y = this.ra;
                    this.q8.al = this.s6;
                    if (this.ug != null) {
                        this.q8.l(this.ug);
                    }
                    let e = this.q8;
                    e.chartTypeChanged = delegateCombine(e.chartTypeChanged, runOn(this, this.xv));
                    ;
                    let f = this.q8;
                    f.trendLineTypeChanged = delegateCombine(f.trendLineTypeChanged, runOn(this, this.xy));
                    let g = this.q8;
                    g.volumeTypeChanged = delegateCombine(g.volumeTypeChanged, runOn(this, this.xz));
                }
                break;
            case "ChartType":
                if (this.q8 != null) {
                    this.q8.y = this.ra;
                }
                break;
            case "VolumeType":
                if (this.q8 != null) {
                    this.q8.ac = this.rf;
                }
                break;
            case "TrendLineType":
                if (this.q8 != null) {
                    this.q8.ai = this.a9;
                }
                break;
            case "IsToolbarVisible":
                if (this.q8 == null) {
                    break;
                }
                this.q8.al = this.s6;
                this.setGridRows();
                break;
        }
    }
    xz(a, b) {
        this.rf = this.q8.ac;
    }
    xy(a, b) {
        this.a9 = this.q8.ai;
    }
    xv(a, b) {
        this.ra = this.q8.y;
    }
    x7() {
        this.r1 = new IndicatorPane();
        this.rs = TypeRegistrar.create("FinancialLegend");
    }
    provideGrid(a) {
        this.uj = a;
        this.ys();
        this.setGridRows();
        if (this.q8 != null) {
            this.q8.bg(a);
        }
    }
    onDocumentClick(a) {
        if (this.q8 != null) {
            this.q8.bl(a);
        }
    }
    getContext() {
        let a = this.q8.v();
        let b = new FinancialChartContext();
        b.vm = new FinancialChartViewModel();
        b.vm.toolbar = a;
        b.container = this.ed;
        b.toolbarContainer = this.ug;
        b.legendContainer = this.uf;
        b.indicatorsContainer = this.ue;
        b.volumeContainer = this.uh;
        b.zoomContainer = this.ui;
        return b;
    }
    provideContainer(a) {
        let b = a;
        if (b != null) {
            let c = "financialChartMainGrid";
            let d = b.createElement("div");
            d.setStyleProperty("width", "100%");
            d.setStyleProperty("height", "100%");
            if (this.q8 == null) {
                this.q8 = new FinancialChartToolbar(this, this.u9);
            }
            this.q8.w.isIndicatorMenuVisible = this.sx && this.sy;
            this.ug = b.getSubRenderer(d);
            this.q8.l(this.ug);
            let e = b.createElement("div");
            e.setStyleProperty("width", "100%");
            e.setStyleProperty("height", "100%");
            let f = b.createElement("div");
            f.setStyleProperty("width", "100%");
            f.setStyleProperty("height", "100%");
            this.uf = b.getSubRenderer(f);
            let g = b.createElement("div");
            g.setStyleProperty("width", "100%");
            g.setStyleProperty("height", "100%");
            this.ue = b.getSubRenderer(g);
            let h = b.createElement("div");
            h.setStyleProperty("width", "100%");
            h.setStyleProperty("height", "100%");
            this.uh = b.getSubRenderer(h);
            let i = b.createElement("div");
            i.setStyleProperty("width", "100%");
            i.setStyleProperty("height", "100%");
            this.ui = b.getSubRenderer(i);
            a = b.getSubRenderer(e);
        }
        else {
            this.ug = null;
            if (this.q8 != null) {
                this.q8.l(null);
            }
            if (this.sq != null) {
                this.sq.provideContainer(null);
                this.sq = null;
            }
            if (this.rs != null) {
                this.rs.provideContainer(null);
            }
        }
        super.provideContainer(a);
        if (b != null) {
            if (this.volumeChart != null) {
                this.volumeChart.provideContainer(this.uh);
            }
            if (this.r1 != null) {
                this.r1.h(this.ue);
            }
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.provideContainer(this.ui);
                if (a != null) {
                    this.xf();
                }
                else {
                    this.sq = null;
                }
            }
            if (this.rs != null) {
                this.rs.provideContainer(this.uf);
            }
            this.setGridRows();
        }
    }
    yi(a, b, c) {
        if (a != null) {
            a.provideContainer(null);
        }
        if (b != null) {
            b.provideContainer(c);
        }
        this.setGridRows();
    }
    yw(a, b) {
        this.yi(a, b, this.ui);
        if (b == null) {
            return;
        }
        this.xf();
    }
    xf() {
        if (this.ui == null) {
            return;
        }
        if (this.sq != null) {
            this.sq.provideContainer(null);
        }
        this.sq = TypeRegistrar.create("ZoomSlider");
        this.sq.provideContainer(this.ui);
        let a = this.sq;
        a.windowRectChanged = delegateCombine(a.windowRectChanged, (a, b) => {
            if (this.dataChart != null) {
                this.dataChart.o8 = new Rect(0, this.sq.windowRect.left, this.dataChart.os.top, this.sq.windowRect.width, this.dataChart.os.height);
            }
        });
        this.xg();
    }
    yu(a, b) {
        this.yi(a, b, this.uh);
    }
    setGridRows() {
        if (this.uj == null) {
            return;
        }
        let a = new Array(6);
        a[0] = (this.s6 ? this.t5 : 0) + "px";
        a[1] = this.s2 ? "min-content" : "0px";
        a[2] = "auto";
        a[3] = this.indicatorCharts == null || this.indicatorCharts.count == 0 ? "0px" : this.indicatorCharts.count * 150 + "px";
        a[4] = this.volumeChart == null ? "0px" : "100px";
        a[5] = this.zoomSliderChart == null ? "0px" : "100px";
        if (this.sq != null) {
            if (a[5] == "0px") {
                this.sq.hide();
            }
            else {
                this.sq.show();
            }
        }
        this.uj.setStyleProperty("-ms-grid-rows", stringReplace(stringJoin(" ", ...a), "auto", "1fr"));
        this.uj.setStyleProperty("grid-template-rows", stringJoin(" ", ...a));
        if (this.ed == null) {
            return;
        }
        if (this.dataChart != null) {
            this.dataChart.notifyContainerResized();
        }
        if (this.r1 != null) {
            this.r1.f();
        }
        if (this.volumeChart != null) {
            this.volumeChart.notifyContainerResized();
        }
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.notifyContainerResized();
        }
        if (this.sq != null) {
            this.sq.notifySizeChanged();
        }
    }
    hs() {
        super.hs();
        this.jw = 3;
        this.o6 = 0;
        this.dp = NaN;
        this.dh = 30;
        this.b5 = true;
        this.cb = false;
        if (this.dataChart != null) {
            let a = this.dataChart.b8.j.e();
            this.qj = a.d;
            this.qk = a.e;
            this.qi = a.d;
            this.yy = this.dataChart.sj;
        }
        let b = new BrushCollection();
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "rgba(139, 220, 92, .3)";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "rgba(139, 91, 177, .3)";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "rgba(109, 177, 255, .3)";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "rgba(115, 86, 86, .3)";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "rgba(140, 231, 217, .3)";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "rgba(168, 168, 183, .3)";
            return $ret;
        })()));
        this.ql = b;
        let c = new BrushCollection();
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "#8bdc5c";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "#8b5bb1";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "#6db1ff";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "#735656";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "#8ce7d9";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "#a8a8b7";
            return $ret;
        })()));
        this.qm = c;
    }
    ye() {
        if (this.r1 != null) {
            this.r1.b = null;
            this.r1.b = this.indicatorCharts;
        }
        this.setGridRows();
    }
    yf() {
        this.setGridRows();
    }
    yo() {
        this.ye();
    }
    xe() {
        if (this.sq == null || this.zoomSliderChart == null || this.dataChart == null || this.dataChart.series.count == 0) {
            return;
        }
        let a = this.ed.rootWrapper.width();
        let b = this.dataChart.o7.left + this.dataChart.o7.width;
        let c = this.dataChart.o7.left;
        let d = a - b;
        this.sq.startInset = c - this.sq.trackStartInset;
        this.sq.endInset = d - this.sq.trackEndInset;
        if (this.sq.endInset < 0) {
            let e = this.sq.endInset;
            this.sq.endInset = 0;
            this.dataChart.fk += (e * -1);
        }
        if (this.sq.startInset < 0) {
            let f = this.sq.startInset;
            this.sq.startInset = 0;
            this.dataChart.fh += (f * -1);
        }
        this.zoomSliderChart.fh = c;
        this.zoomSliderChart.fk = d;
        this.zoomSliderChart.fd = this.sq.barExtent;
    }
    x5() {
        this.xe();
    }
    hp(a) {
        super.hp(a);
        if (a != null) {
            a.fc = 0;
        }
    }
    yz(a) {
        return a.ol();
    }
    y2() {
        return this.uf == null ? null : this.y1(this.uf.rootWrapper);
    }
    y0(a) {
        if (a == null || a.d == null) {
            return null;
        }
        return this.y1(a.d.rootWrapper);
    }
    y1(a) {
        if (a == null) {
            return null;
        }
        let b = a.getOffset();
        return new Rect(0, b.left, b.top, a.width(), a.height());
    }
    t1() {
        if (this.uj == null) {
            return NaN;
        }
        let a = this.uj.getOffset();
        return this.uj.width() + (a == null ? 0 : a.left);
    }
    h0(source_, a, b) {
        super.h0(source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.jg(source_, a, b);
        }
    }
    h1(source_, a, b) {
        super.h1(source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.jh(source_, a, b);
        }
    }
    hz(source_) {
        super.hz(source_);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.jd(source_);
        }
    }
    h3(source_, a, b, c) {
        super.h3(source_, a, b, c);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.ji(source_, a, b, c);
        }
    }
    hv(a, b) {
        super.hv(a, b);
        if (this.s3(a)) {
            a.toolTip = null;
        }
    }
    get q8() {
        return this.q7;
    }
    set q8(a) {
        let b = this.q8;
        if (a != b) {
            this.q7 = a;
            this.id("Toolbar", b, this.q8);
        }
    }
    get u8() {
        return this.u1;
    }
    set u8(a) {
        let b = this.u8;
        if (a != b) {
            this.u1 = a;
            this.id("RangeSelectorTemplate", b, this.u8);
        }
    }
    get u9() {
        return this.u2;
    }
    set u9(a) {
        let b = this.u9;
        if (a != b) {
            this.u2 = a;
            this.id("ToolbarTemplate", b, this.u9);
        }
    }
    get u5() {
        return this.uy;
    }
    set u5(a) {
        let b = this.u5;
        if (a != b) {
            this.uy = a;
            this.id("ChartTypePickerTemplate", b, this.u5);
        }
    }
    get va() {
        return this.u3;
    }
    set va(a) {
        let b = this.va;
        if (a != b) {
            this.u3 = a;
            this.id("TrendLineTypePickerTemplate", b, this.va);
        }
    }
    get vb() {
        return this.u4;
    }
    set vb(a) {
        let b = this.vb;
        if (a != b) {
            this.u4 = a;
            this.id("VolumeTypePickerTemplate", b, this.vb);
        }
    }
    get u6() {
        return this.uz;
    }
    set u6(a) {
        let b = this.u6;
        if (a != b) {
            this.uz = a;
            this.id("IndicatorMenuTemplate", b, this.u6);
        }
    }
    get u7() {
        return this.u0;
    }
    set u7(a) {
        let b = this.u7;
        if (a != b) {
            this.u0 = a;
            this.id("OverlayPickerTemplate", b, this.u7);
        }
    }
    get sq() {
        return this.sp;
    }
    set sq(a) {
        let b = this.sq;
        if (a != b) {
            this.sp = a;
            this.id("ZoomSlider", b, this.sq);
        }
    }
    get_dh() {
        return super.get_dh();
    }
    set_dh(a) {
        super.set_dh(a);
    }
    get_b5() {
        return super.get_b5();
    }
    set_b5(a) {
        super.set_b5(a);
    }
    get t5() {
        return this.tu;
    }
    set t5(a) {
        let b = this.t5;
        if (a != b) {
            this.tu = a;
            this.id("ToolbarHeight", b, this.t5);
        }
    }
    jp() {
        return this.xAxis;
    }
    jq() {
        return this.yAxis;
    }
    onAttachedToUI() {
        super.onAttachedToUI();
        if (this.sq != null) {
            this.sq.onAttachedToUI();
        }
    }
    onDetachedFromUI() {
        super.onDetachedFromUI();
        if (this.sq != null) {
            this.sq.onDetachedFromUI();
        }
    }
    w(a) {
        return 20;
    }
    get_cl() {
        return ((() => {
            let $ret = new List$1(DataSeriesType_$type, 0);
            $ret.add(20);
            return $ret;
        })());
    }
    get cl() {
        return this.get_cl();
    }
    get_ck() {
        return ((() => {
            let $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
            $ret.add(new SimpleFinancialPriceSeriesRule());
            $ret.add(new SubCollectionsRule());
            return $ret;
        })());
    }
    get ck() {
        return this.get_ck();
    }
    qu(a) {
        return this.qv(a);
    }
    r8(a) {
        return this.r9(a);
    }
    qt(a) {
        let b = this.qu(0);
        b.name = a;
        return b;
    }
    hc() {
        this.xAxis = this.qt("xAxis");
        this.yAxis = this.r8(0);
        this.yAxis.name = "yAxis";
        this.volumeAxis = this.r8(0);
        this.volumeAxis.name = "volumeAxis";
        this.volumeXAxis = this.qt("volumeXAxis");
        this.ti = new List$1(NumericYAxis.$, 0);
        this.tk = new List$1(CategoryAxisBase.$, 0);
        this.indicatorAxis = this.r8(0);
        this.indicatorAxis.name = "indicatorAxis";
        this.indicatorXAxis = this.qt("indicatorXAxis_0");
        this.ti.add(this.indicatorAxis);
        this.tk.add(this.indicatorXAxis);
        if (this.xAxis.ay == null) {
            this.xAxis.ay = new AxisLabelSettings();
        }
        if (this.yAxis.ay == null) {
            this.yAxis.ay = new AxisLabelSettings();
        }
        if (this.volumeAxis.ay == null) {
            this.volumeAxis.ay = new AxisLabelSettings();
        }
        if (this.volumeXAxis.ay == null) {
            this.volumeAxis.ay = new AxisLabelSettings();
        }
        if (this.indicatorAxis.ay == null) {
            this.indicatorAxis.ay = new AxisLabelSettings();
        }
        if (this.indicatorXAxis.ay == null) {
            this.indicatorXAxis.ay = new AxisLabelSettings();
        }
        this.zoomSliderAxis = this.r8(0);
        this.zoomSliderAxis.name = "zoomSliderAxis";
        this.zoomSliderXAxis = this.qt("zoomSliderXAxis");
        if (this.zoomSliderAxis.ay == null) {
            this.zoomSliderAxis.ay = new AxisLabelSettings();
        }
        if (this.zoomSliderXAxis.ay == null) {
            this.zoomSliderXAxis.ay = new AxisLabelSettings();
        }
    }
    ha(a, b) {
        let c = typeCast(MarkerSeries.$, a);
        if (c != null) {
            c.oi = this.aq(a, b);
        }
    }
    iv(a) {
        if (a.suggestedSecondaryAxis == 2) {
            this.yAxis.j2 = true;
            this.yAxis.kp = 10;
        }
    }
    iy() {
        this.yAxis.j2 = this.tb;
        this.yAxis.kp = this.ux;
    }
    rc(a) {
        let b;
        if (this.ra == 0) {
            if (a == null || a.index > 0 || stringIsNullOrEmpty(a.getMemberPathFor(12))) {
                b = 4;
            }
            else {
                b = 2;
            }
        }
        else {
            b = this.ra;
        }
        b = this.rb(b);
        return b;
    }
    rb(a) {
        if ((a == 1 || a == 2)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    }
    rl(a) {
        if ((a == 2 || a == 3)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 5;
        }
        if (a == 5) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 6;
        }
        if (a == 6) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    }
    re(a) {
        if (a == 2) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 1;
        }
        if (a == 1) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    }
    vk(a) {
        let b = a.getMemberPathFor(14);
        if (stringIsNullOrEmpty(b)) {
            b = a.getMemberPathFor(11);
        }
        return b;
    }
    qv(axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createXAxis(axisType_).i);
        }
        else {
            let a;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    }
    r9(axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createYAxis(axisType_).i);
        }
        else {
            let a;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    }
    sf() {
        return this.az(1);
    }
    sg() {
        return this.az(0);
    }
    se() {
        return this.az(2);
    }
    sh() {
        return this.az(20);
    }
    get sw() {
        return (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy"));
    }
    get rw() {
        if (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy")) {
            return TypeRegistrar.create("HorizontalAnchoredCategorySeriesProxy");
        }
        else {
            throw new BaseError(1, "horizontal series module is not loaded, but is required.");
        }
    }
    get sz() {
        return (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy"));
    }
    get ru() {
        if (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy")) {
            return TypeRegistrar.create("FinancialPriceSeriesProxy");
        }
        else {
            throw new BaseError(1, "financial series module is not loaded, but is required.");
        }
    }
    get sx() {
        return (TypeRegistrar.isRegistered("IndicatorProxy"));
    }
    get ry() {
        if (TypeRegistrar.isRegistered("IndicatorProxy")) {
            return TypeRegistrar.create("IndicatorProxy");
        }
        else {
            throw new BaseError(1, "financial series module is not loaded, but is required.");
        }
    }
    get sy() {
        return (TypeRegistrar.isRegistered("OverlayProxy"));
    }
    get r3() {
        if (TypeRegistrar.isRegistered("OverlayProxy")) {
            return TypeRegistrar.create("OverlayProxy");
        }
        else {
            throw new BaseError(1, "overlay series module is not loaded, but is required.");
        }
    }
    ay(a, b) {
        let c = this.vk(a);
        switch (this.rc(a)) {
            case 3:
                let d = this.sf();
                this.rw.setValueMemberPath(d, c);
                this.rw.setXAxis(d, this.xAxis);
                this.rw.setYAxis(d, this.yAxis);
                this.rw.setCategoryMode(d, 1);
                return d;
            case 4:
                let e = this.sg();
                this.rw.setValueMemberPath(e, c);
                this.rw.setXAxis(e, this.xAxis);
                this.rw.setYAxis(e, this.yAxis);
                this.rw.setCategoryMode(e, 1);
                return e;
            default:
            case 1:
            case 2:
                let f = this.sh();
                this.ru.setOpenMemberPath(f, a.getMemberPathFor(11));
                this.ru.setHighMemberPath(f, a.getMemberPathFor(12));
                this.ru.setLowMemberPath(f, a.getMemberPathFor(13));
                this.ru.setCloseMemberPath(f, a.getMemberPathFor(14));
                this.ru.setVolumeMemberPath(f, a.getMemberPathFor(15));
                this.ru.setXAxis(f, this.xAxis);
                this.ru.setYAxis(f, this.yAxis);
                this.ru.setDisplayType(f, this.ra == 1 ? 1 : 0);
                this.ru.setCategoryMode(f, 1);
                return f;
        }
    }
    ix() {
        super.ix();
        this.x3(this.xAxis);
        this.yq(false);
        if (this.rf != 0 && this.volumeChart != null) {
            this.x9();
        }
        this.x3(this.volumeXAxis);
        this.x3(this.indicatorXAxis);
        this.yn();
        this.yp();
        if (this.rm != 0) {
            this.ya();
            this.x3(this.zoomSliderXAxis);
        }
    }
    ou(a, b) {
        super.ou(a, b);
        a(this.volumeXAxis);
        if (this.tk != null) {
            for (let c of fromEnum(this.tk)) {
                a(c);
            }
        }
        let d = true;
        switch (b) {
            case "XAxisMajorStroke":
            case "XAxisMajorStrokeThickness":
                d = false;
                break;
        }
        if (d) {
            a(this.zoomSliderXAxis);
        }
    }
    oy(a, b) {
        super.oy(a, b);
        if (b) {
            a(this.volumeAxis);
            if (this.ti != null) {
                for (let c of fromEnum(this.ti)) {
                    a(c);
                }
            }
            a(this.zoomSliderAxis);
        }
    }
    ow(a) {
        super.ow(a);
        this.oo(this.volumeXAxis, a);
        this.oo(this.indicatorXAxis, a);
        this.oo(this.zoomSliderXAxis, a);
    }
    o0(a) {
        super.o0(a);
        this.oo(this.volumeAxis, a);
        this.oo(this.indicatorAxis, a);
        this.oo(this.zoomSliderAxis, a);
    }
    oz(a) {
        super.oz(a);
        this.on(this.volumeAxis, a);
        this.on(this.indicatorAxis, a);
        this.on(this.zoomSliderAxis, a);
    }
    ov(a) {
        super.ov(a);
        this.on(this.volumeXAxis, a);
        this.on(this.indicatorXAxis, a);
        this.on(this.zoomSliderXAxis, a);
    }
    ho(a) {
        super.ho(a);
        if (a == null) {
            return;
        }
        if (a == this.zoomSliderChart) {
            a.py = a.p1 = false;
            a.legend = null;
            if (this.dataChart != null) {
                a.pe = this.dataChart.pe;
                a.ph = this.dataChart.ph;
            }
        }
        else {
            SyncManager.d(a, ((() => {
                let $ret = new SyncSettings();
                $ret.syncChannel = this.we();
                $ret.synchronizeHorizontally = true;
                $ret.synchronizeVertically = false;
                return $ret;
            })()));
            SyncManager.c(a);
        }
        a.bw = 2;
    }
    we() {
        if (this.vc == null) {
            FinancialChart.uw++;
            this.vc = FinancialChart.uw.toString();
        }
        return this.vc;
    }
    xp(a, b) {
        this.xb();
        this.x5();
    }
    xb() {
        if (this.yAxis.b1()) {
            return;
        }
        let a = this.yAxis.av.a6;
        if (this.rf != 0) {
            a = Math.max(a, this.volumeAxis.av.a6);
        }
        for (let b of fromEnum(this.ti)) {
            a = Math.max(a, b.av.a6);
        }
        this.xc(a);
    }
    xc(a) {
        if (this.yAxis.b1()) {
            return;
        }
        this.yAxis.d7 = this.volumeAxis.d7 = a;
        for (let b of fromEnum(this.ti)) {
            b.d7 = a;
        }
        this.zoomSliderAxis.d7 = this.yAxis.d7;
    }
    xh(a) {
        if (this.indicatorCharts == null) {
            return;
        }
        for (let b = 0; b < this.indicatorCharts.count; b++) {
            let c = this.indicatorCharts._inner[b];
            for (let d = 0; d < c.series.count; d++) {
                a(c.series._inner[d], b);
            }
        }
    }
    xk(a) {
        if (this.volumeChart == null) {
            return;
        }
        for (let b = 0; b < this.volumeChart.series.count; b++) {
            a(this.volumeChart.series._inner[b], b);
        }
    }
    xi(a) {
        if (this.dataChart == null) {
            return;
        }
        for (let b = 0; b < this.dataChart.series.count; b++) {
            let c = this.dataChart.series._inner[b];
            if (!this.s3(c)) {
                continue;
            }
            a(c, b);
        }
    }
    xj(a, b) {
        if (this.dataChart == null) {
            return;
        }
        for (let c = 0; c < this.dataChart.series.count; c++) {
            let d = this.dataChart.series._inner[c];
            if (this.s3(d)) {
                continue;
            }
            let e = this.uq(d, c);
            a(d, e);
        }
        if (b) {
            this.xl(a);
        }
    }
    xl(a) {
        if (this.zoomSliderChart == null) {
            return;
        }
        for (let b = 0; b < this.zoomSliderChart.series.count; b++) {
            a(this.zoomSliderChart.series._inner[b], b);
        }
    }
    uq(a, b) {
        if (a.b4 != this.dataChart) {
            return b;
        }
        let c = this.x == null || this.x.dataSeries == null ? 0 : this.x.dataSeries.count;
        let d = this.rq == null ? 0 : this.rq.count;
        return b - (c * d);
    }
    hi(a) {
        super.hi(a);
        this.xk(a);
        this.xh(a);
        this.xl(a);
    }
    get volumeChart() {
        return this.sl;
    }
    set volumeChart(a) {
        let b = this.volumeChart;
        if (a != b) {
            this.sl = a;
            this.id("VolumeChart", b, this.volumeChart);
        }
    }
    x9() {
        if (this.dataChart == null) {
            return;
        }
        this.volumeChart.series.clear();
        let a = new List$1(Series.$, 0);
        let b = -1;
        for (let c = 0; c < this.dataChart.series.count; c++) {
            let d = this.dataChart.series._inner[c];
            if (this.s3(d) || d.cx) {
                continue;
            }
            b++;
            let e;
            let f = this.rf;
            f = this.re(f);
            switch (f) {
                case 2:
                    e = this.sg();
                    break;
                case 3:
                    e = this.se();
                    break;
                default:
                case 1:
                    e = this.sf();
                    break;
            }
            this.rw.setCategoryMode(e, 1);
            e.name = "volumeSeries_" + b;
            e.itemsSource = d.itemsSource;
            this.rw.setXAxis(e, this.volumeXAxis);
            this.rw.setYAxis(e, this.volumeAxis);
            this.rw.setValueMemberPath(e, this.x != null && this.x.dataSeries != null && this.x.dataSeries.count > b ? this.x.dataSeries._inner[b].getMemberPathFor(15) : null);
            e.gy = d.gy + " Volume";
            e.nb = ArrayExtension.getModulus$1(Brush.$, this.qn, b);
            e.ng = ArrayExtension.getModulus$1(Brush.$, this.qo, b);
            e.fv = this.t6;
            a.add(e);
        }
        let g = this.ch("volume", false);
        if (g != null) {
            a.o(g);
        }
        for (let h = 0; h < a.count; h++) {
            let i = a._inner[h];
            this.volumeChart.series.add(i);
            this.ht(i, h);
        }
    }
    s0(a) {
        if (!this.sw) {
            return false;
        }
        return this.rw.matchesType(a);
    }
    s4(a) {
        if (!this.sz) {
            return false;
        }
        return this.ru.matchesType(a);
    }
    s1(a) {
        if (!this.sx) {
            return false;
        }
        return this.ry.matchesType(a);
    }
    s3(a) {
        if (!this.sy) {
            return false;
        }
        return this.r3.matchesType(a);
    }
    x8() {
        if (this.dataChart == null) {
            return;
        }
        let a = 0;
        let b = this.ro == null ? 0 : this.ro.count;
        let c = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        let d = b + c;
        for (let e = 0; e < d; e++) {
            let f = new List$1(Series.$, 0);
            let g = this.indicatorCharts._inner[e];
            let h = e >= b;
            let i = h ? this.customIndicatorNames._inner[e - b] : EnumUtil.getName(FinancialIndicatorType_$type, this.ro._inner[e]);
            let j = -1;
            for (let k = 0; k < this.dataChart.series.count; k++) {
                let l = this.dataChart.series._inner[k];
                if (this.s3(l) || l.cx) {
                    continue;
                }
                j++;
                let m;
                if (h) {
                    let n = this.si("Custom");
                    this.ry.handleCustomIndicatorEvent(n, runOn(this, this.xn));
                    m = n;
                }
                else {
                    m = this.sk(this.ro._inner[e]);
                }
                if (m == null) {
                    continue;
                }
                m.name = "indicator_" + a++;
                this.ry.setXAxis(m, this.tk._inner[e]);
                this.ry.setYAxis(m, this.ti._inner[e]);
                m.itemsSource = l.itemsSource;
                this.ry.setOpenMemberPath(m, this.x.dataSeries._inner[j].getMemberPathFor(11));
                this.ry.setHighMemberPath(m, this.x.dataSeries._inner[j].getMemberPathFor(12));
                this.ry.setLowMemberPath(m, this.x.dataSeries._inner[j].getMemberPathFor(13));
                this.ry.setCloseMemberPath(m, this.x.dataSeries._inner[j].getMemberPathFor(14));
                this.ry.setVolumeMemberPath(m, this.x.dataSeries._inner[j].getMemberPathFor(15));
                m.gy = l.gy + " " + i;
                m.nb = ArrayExtension.getModulus$1(Brush.$, this.qh, e);
                m.fv = this.t3;
                if (this.s1(m)) {
                    this.ry.setNegativeBrush(m, ArrayExtension.getModulus$1(Brush.$, this.qi, e));
                    this.ry.setDisplayType(m, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.r0, e));
                }
                if (this.us != -2147483648 && this.s1(m)) {
                    this.ry.setPeriodOverride(m, this.us);
                }
                if (this.s1(m)) {
                    this.ry.setSmoothingPeriod(m, this.uv);
                }
                if (this.s1(m)) {
                    this.ry.setSignalPeriod(m, this.uu);
                }
                if (this.s1(m)) {
                    this.ry.setShortPeriod(m, this.ut);
                    this.ry.setLongPeriod(m, this.ur);
                }
                this.ht(m, e);
                f.add(m);
            }
            let o = this.ch(i, false);
            for (let p = 0; p < f.count; p++) {
                let q = f._inner[p];
                g.series.add(q);
            }
            if (o != null) {
                for (let r = 0; r < o.count; r++) {
                    let s = o._inner[r];
                    g.series.add(s);
                    this.ht(s, r);
                }
            }
        }
    }
    si(indicatorName_) {
        return (this.externalObject.createIndicator(indicatorName_ + 'Indicator').i);
    }
    sk(a) {
        return this.si(EnumUtil.getName(FinancialIndicatorType_$type, a));
    }
    yq(a) {
        if (this.q8 == null) {
            return;
        }
        let b = this.xAxis;
        if (b.actualMinimumValue > b.actualMaximumValue) {
            return;
        }
        this.q8.as = b.actualMinimumValue;
        this.q8.ar = b.actualMaximumValue;
        if (a) {
            this.q8.au = b.visibleMinimum;
            this.q8.at = b.visibleMaximum;
        }
        this.q8.bn();
    }
    ee() {
        let a = ((() => {
            let $ret = new FinancialChartVisualData();
            $ret.mainChart = super.ee();
            $ret.volumeChart = this.volumeChart == null ? null : this.volumeChart.qx();
            $ret.toolbar = this.q8 == null ? null : this.q8.aj();
            $ret.zoomChart = this.zoomSliderChart == null ? null : this.zoomSliderChart.qx();
            return $ret;
        })());
        if (this.indicatorCharts != null) {
            a.indicatorCharts = new List$1(Base.$, 0);
            for (let b of fromEnum(this.indicatorCharts)) {
                a.indicatorCharts.add1(b.qx());
            }
        }
        if (this.dataChart != null) {
            a.mainChartLeft = this.yz(this.dataChart).x;
            a.mainChartTop = this.yz(this.dataChart).y;
        }
        if (this.volumeChart != null) {
            a.volumeChartLeft = this.yz(this.volumeChart).x;
            a.volumeChartTop = this.yz(this.volumeChart).y;
        }
        if (this.zoomSliderChart != null) {
            a.zoomChartLeft = this.yz(this.zoomSliderChart).x;
            a.zoomChartTop = this.yz(this.zoomSliderChart).y;
        }
        if (this.q8 != null) {
            let c = this.y0(this.q8);
            a.toolbarLeft = c.left;
            a.toolbarTop = c.top;
            a.toolbarWidth = c.width;
            a.toolbarHeight = c.height;
        }
        if (this.indicatorCharts != null) {
            a.indicatorChartLefts = new List$1(Number_$type, 0);
            a.indicatorChartTops = new List$1(Number_$type, 0);
            for (let d of fromEnum(this.indicatorCharts)) {
                a.indicatorChartLefts.add(this.yz(d).x);
                a.indicatorChartTops.add(this.yz(d).y);
            }
        }
        let e = this.y2();
        a.legendLeft = e.left;
        a.legendTop = e.top;
        a.legendWidth = e.width;
        a.legendHeight = e.height;
        a.legend = this.rs == null ? null : this.rs.exportVisualData();
        return a;
    }
    vh() {
        let a = this.ee();
        a.scaleByViewport();
        return a.serialize();
    }
    sj(overlayName_) {
        return (this.externalObject.createOverlay(overlayName_ + 'Overlay').i);
    }
    yp() {
        if (this.dataChart == null) {
            return;
        }
        let a = new List$1(Series.$, 0);
        for (let b of fromEnum(this.dataChart.series)) {
            if (this.s3(b)) {
                a.add(b);
            }
        }
        for (let c of fromEnum(a)) {
            this.dataChart.series.remove(c);
        }
        if (this.rq == null) {
            return;
        }
        let d = new List$1(Series.$, 0);
        let e = -1;
        for (let f = 0; f < this.dataChart.series.count; f++) {
            let g = this.dataChart.series._inner[f];
            if (this.s3(g) || g.cx) {
                continue;
            }
            e++;
            for (let h = 0; h < this.rq.count; h++) {
                let i = this.rq._inner[h];
                let j;
                switch (i) {
                    case 1:
                        j = this.sj(EnumUtil.getName(FinancialOverlayType_$type, i));
                        break;
                    default:
                    case 0:
                        j = this.sj(EnumUtil.getName(FinancialOverlayType_$type, i));
                        break;
                }
                j.name = g.name + "_" + EnumUtil.getName(FinancialOverlayType_$type, i);
                this.r3.setXAxis(j, this.xAxis);
                this.r3.setYAxis(j, this.yAxis);
                j.itemsSource = g.itemsSource;
                let k = e * this.rq.count + h;
                j.nb = ArrayExtension.getModulus$1(Brush.$, this.ql, k);
                j.ng = ArrayExtension.getModulus$1(Brush.$, this.qm, k);
                j.fv = this.t4;
                j.gy = g.gy + " " + EnumUtil.getName(FinancialOverlayType_$type, i);
                let l = g;
                if (l == null) {
                    continue;
                }
                let m = this.x.dataSeries._inner[e];
                this.r3.setOpenMemberPath(j, m.getMemberPathFor(11));
                this.r3.setHighMemberPath(j, m.getMemberPathFor(12));
                this.r3.setLowMemberPath(j, m.getMemberPathFor(13));
                this.r3.setCloseMemberPath(j, m.getMemberPathFor(14));
                this.r3.setVolumeMemberPath(j, m.getMemberPathFor(15));
                d.add(j);
            }
        }
        let n = new Array(this.dataChart.series.count);
        this.dataChart.series.copyTo(n, 0);
        this.dataChart.skipDataCleanup = true;
        this.dataChart.series.clear();
        this.dataChart.skipDataCleanup = false;
        for (let o = 0; o < n.length; o++) {
            n[o].gi = -1;
        }
        d.o(n);
        for (let p = 0; p < d.count; p++) {
            let q = d._inner[p];
            this.dataChart.series.add(q);
            this.ht(q, p);
        }
    }
    yn() {
        if (this.s9) {
            return;
        }
        this.s9 = true;
        if (this.indicatorCharts != null) {
            let a = this.indicatorCharts;
            this.indicatorCharts = null;
            for (let b of fromEnum(a)) {
                this.x4(b);
            }
        }
        if ((this.ro == null || this.ro.count == 0) && (this.customIndicatorNames == null || this.customIndicatorNames.count == 0)) {
            this.indicatorCharts = null;
            if (this.ti != null) {
                this.ti.clear();
            }
            if (this.tk != null) {
                this.tk.clear();
            }
            this.ye();
            this.yo();
            this.s9 = false;
            return;
        }
        if (this.indicatorCharts == null) {
            this.indicatorCharts = new List$1(XamDataChart.$, 0);
        }
        this.indicatorCharts.clear();
        this.ti.clear();
        this.tk.clear();
        let c = this.ro == null ? 0 : this.ro.count;
        let d = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        let e = c + d;
        for (let f = 0; f < e; f++) {
            let g = new XamDataChart();
            this.indicatorCharts.add(g);
            this.x2(g);
            let h = f >= c;
            if (h) {
                g.hy = this.customIndicatorNames._inner[f - c];
            }
            else {
                g.hy = this.vj(this.ro._inner[f]);
            }
            if (this.indicatorAxis != null) {
                let i;
                let j;
                if (f == 0) {
                    i = this.indicatorAxis;
                    j = this.indicatorXAxis;
                }
                else {
                    i = new NumericYAxis();
                    if (!this.indicatorXAxis.b7) {
                        j = this.qu(0);
                    }
                    else {
                        j = this.qu(1);
                    }
                }
                j.name = "indicatorXAxis_" + f;
                i.name = "indicatorAxis_" + f;
                g.axes.add(i);
                g.axes.add(j);
                this.ti.add(i);
                this.tk.add(j);
                if (this.bw) {
                    this.or(i);
                }
                if (this.bw) {
                    this.op(j);
                }
            }
        }
        this.x8();
        this.ye();
        if (this.q8 != null) {
            this.q8.ae = this.ro;
        }
        this.xd();
        this.yo();
        this.s9 = false;
    }
    hl() {
        super.hl();
        this.op(this.xAxis);
        this.op(this.volumeXAxis);
        if (this.tk != null) {
            for (let a of fromEnum(this.tk)) {
                this.op(a);
            }
        }
        this.or(this.yAxis);
        this.or(this.volumeAxis);
        if (this.ti != null) {
            for (let b of fromEnum(this.ti)) {
                this.or(b);
            }
        }
        this.op(this.zoomSliderXAxis);
        this.or(this.zoomSliderAxis);
    }
    get_ca() {
        return !this.s7;
    }
    get td() {
        return (this.externalObject._dynamicContent);
    }
    yv(a, b) {
        this.yh(a, b);
        this.xd();
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.axes.add(this.zoomSliderAxis);
            this.zoomSliderChart.axes.add(this.zoomSliderXAxis);
        }
        this.ya();
        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
        this.yf();
        this.yw(a, b);
    }
    ya() {
        if (this.dataChart == null || this.zoomSliderChart == null) {
            return;
        }
        this.zoomSliderChart.series.clear();
        let a = new List$1(Series.$, 0);
        for (let b = 0; b < this.dataChart.series.count; b++) {
            let c = this.dataChart.series._inner[b];
            if (this.s3(c) || c.cx) {
                continue;
            }
            let d;
            let e = this.rm;
            e = this.rl(e);
            let f = this.uq(c, b);
            if (e == 1) {
                switch (this.rc(this.x != null && this.x.dataSeries != null && this.x.dataSeries.count > f ? this.x.dataSeries._inner[f] : null)) {
                    case 1:
                        e = 2;
                        break;
                    case 2:
                        e = 3;
                        break;
                    case 3:
                        e = 4;
                        break;
                    case 4:
                        e = 5;
                        break;
                }
            }
            switch (e) {
                case 2:
                    d = this.sh();
                    this.ru.setDisplayType(d, 1);
                    break;
                case 3:
                    d = this.sh();
                    this.ru.setDisplayType(d, 0);
                    break;
                case 5:
                    d = this.sg();
                    break;
                case 6:
                    d = this.se();
                    break;
                default:
                case 4:
                    d = this.sf();
                    break;
            }
            let g = this.x != null && this.x.dataSeries != null && this.x.dataSeries.count > f ? this.x.dataSeries._inner[f] : null;
            if (d.cz && !d.c6) {
                this.rw.setCategoryMode(d, 1);
                this.rw.setXAxis(d, this.zoomSliderXAxis);
                this.rw.setYAxis(d, this.zoomSliderAxis);
                this.rw.setValueMemberPath(d, g == null ? null : this.vk(g));
            }
            else if (d.c6) {
                this.ru.setCategoryMode(d, 1);
                this.ru.setXAxis(d, this.zoomSliderXAxis);
                this.ru.setYAxis(d, this.zoomSliderAxis);
                if (g != null) {
                    this.ru.setOpenMemberPath(d, g.getMemberPathFor(11));
                    this.ru.setHighMemberPath(d, g.getMemberPathFor(12));
                    this.ru.setLowMemberPath(d, g.getMemberPathFor(13));
                    this.ru.setCloseMemberPath(d, g.getMemberPathFor(14));
                    this.ru.setVolumeMemberPath(d, g.getMemberPathFor(15));
                }
            }
            d.name = "zoomSliderSeries_" + f;
            d.itemsSource = c.itemsSource;
            d.gy = c.gy;
            a.add(d);
        }
        for (let h = 0; h < a.count; h++) {
            let i = a._inner[h];
            this.zoomSliderChart.series.add(i);
            this.ht(i, h);
        }
    }
    h8(a, b, c) {
        super.h8(a, b, c);
        if (a == null || !b) {
            return;
        }
        let d = true;
        let e = true;
        switch (c) {
            case "Brushes":
            case "Outlines":
                d = e = false;
                break;
        }
        if (this.indicatorCharts != null && d) {
            for (let f of fromEnum(this.indicatorCharts)) {
                a(f);
            }
        }
        if (this.volumeChart != null && e) {
            a(this.volumeChart);
        }
        if (this.zoomSliderChart != null) {
            a(this.zoomSliderChart);
        }
    }
    xn(a, b) {
        let c = b;
        let d = a;
        let e = -1;
        if (this.indicatorCharts != null) {
            e = this.indicatorCharts.indexOf(d.b4);
        }
        e -= this.ro == null ? 0 : this.ro.count;
        if (this.applyCustomIndicators != null) {
            this.applyCustomIndicators(this, new FinancialChartCustomIndicatorArgs(c, d, e));
        }
    }
    yj(a, b, c) {
        if (a != null) {
            if (b != null) {
                a.axes.remove(b);
            }
            a.axes.add(c);
        }
        if (this.bw) {
            this.op(c);
        }
    }
    get tc() {
        return TypeRegistrar.isRegistered("IgxZoomSliderComponent");
    }
    xo(a, b) {
        this.yn();
    }
    s5(a, b) {
        if (b <= (0)) {
            return false;
        }
        switch (a) {
            case 5: return true;
            case 4:
            case 3: return b >= timeSpanFromDays(365);
            case 2: return b >= timeSpanFromDays(180);
            case 1: return b >= timeSpanFromDays(90);
            case 0: return b >= timeSpanFromDays(30);
        }
        return false;
    }
    yd() {
        let a = this.q6 != null ? this.q6 : new FinancialChartRangeSelectorOptionCollection(1, [5, 4, 3, 2, 1, 0]);
        let b = new FinancialChartRangeSelectorOptionCollection(0);
        let c = this.xAxis;
        let d = +(c.actualMaximumValue) - +(c.actualMinimumValue);
        for (let e of fromEnum(a)) {
            if (this.s5(e, d)) {
                b.add(e);
            }
        }
        this.q5 = b;
        if (this.q8 != null) {
            this.q8.u = this.q5;
        }
    }
    xs(a, b) {
        this.yd();
    }
    xx(a, b) {
        this.rq = this.q8.ag;
    }
    xw(a, b) {
        this.ro = this.q8.ae;
    }
    xq(a, b) {
        this.yn();
    }
    xr(a, b) {
        this.yp();
    }
    x1(a, b) {
        let c = a;
        if (c.bf == null) {
            return;
        }
        if (this.s7) {
            this.yc(c.bf);
        }
    }
    x4(a) {
        SyncManager.e(a);
        a.axes.clear();
        a.series.clear();
        a.gridAreaRectChanged = delegateRemove(a.gridAreaRectChanged, runOn(this, this.xp));
        a.provideContainer(null);
        if (this.volumeChart == null && this.indicatorCharts == null) {
            this.yAxis.d7 = this.volumeAxis.d7 = this.indicatorAxis.d7 = 0;
            this.xAxis.ay.visibility = this.p7;
        }
    }
    x2(a) {
        let b = a != this.zoomSliderChart;
        if (b) {
            if (this.dataChart != null) {
                a.o8 = new Rect(0, this.dataChart.os.x, a.o8.y, this.dataChart.os.width, a.o8.height);
            }
            let c = ((() => {
                let $ret = new SyncSettings();
                $ret.syncChannel = "one";
                $ret.synchronizeHorizontally = true;
                $ret.synchronizeVertically = false;
                return $ret;
            })());
            SyncManager.d(a, c);
            SyncManager.c(a);
        }
        a.gridAreaRectChanged = delegateCombine(a.gridAreaRectChanged, runOn(this, this.xp));
        this.hn(a);
    }
    xd() {
        if (this.indicatorCharts != null || this.volumeChart != null) {
            this.on(this.xAxis, (a) => a.visibility = 1);
        }
        for (let a = 0; a < this.tk.count; a++) {
            let b = this.tk._inner[a];
            let c = a < this.tk.count - 1 || this.volumeChart != null;
            this.on(b, (d) => d.visibility = c ? 1 : 0);
        }
    }
    yh(a, b) {
        if (a != null) {
            this.x4(a);
        }
        if (b != null) {
            this.x2(b);
        }
    }
    yt(a, b) {
        this.yh(a, b);
        this.xd();
        if (this.volumeChart != null) {
            if (this.volumeAxis != null) {
                this.volumeChart.axes.add(this.volumeAxis);
                this.volumeChart.axes.add(this.volumeXAxis);
            }
            this.x9();
            this.volumeXAxis.itemsSource = this.xAxis.itemsSource;
        }
        this.yu(a, b);
    }
    xt(a, b) {
        this.yr();
    }
    yr() {
        if (this.q8 == null || +(this.q8.au) == +(dateMaxValue()) || +(this.q8.at) == +(dateMinValue()) || this.dataChart == null) {
            return;
        }
        let a = this.xAxis;
        let b = a.getWindowRectForSelection(this.q8.au, this.q8.at);
        if (b.width == 0 || isNaN_(b.width) || isInfinity(b.width)) {
            return;
        }
        this.s8 = true;
        this.dataChart.o8 = new Rect(0, b.left, this.dataChart.o8.top, b.width, this.dataChart.o8.height);
        if (this.sq != null) {
            this.sq.windowRect = this.dataChart.os;
        }
        if (this.s7) {
            this.yc(this.dataChart);
        }
        this.s8 = false;
    }
    x0(a, b) {
        this.yd();
        this.yq(!this.s8);
    }
    xm(a, b) {
        if (!this.s8) {
            if (this.s7) {
                this.yc(a);
            }
            let c = false;
            let d = this.ij(() => this.yq(true), c);
            c = d.p1;
            if (this.sq != null) {
                this.sq.windowRect = this.dataChart.os;
            }
        }
    }
    yl(a, b, c, d) {
        if (a == null || b == null) {
            return;
        }
        if (c != -1) {
            this.s8 = true;
            a.o8 = new Rect(0, d, a.os.top, c, a.os.height);
            this.s8 = false;
        }
        let e = 1.7976931348623157E+308;
        let f = -1.7976931348623157E+308;
        let g = new Rect(0, 0, 0, 1, 1);
        let h = new ScalerParams(0, g, g, this.yAxis.ca, a.ow);
        for (let i of fromEnum(a.series)) {
            h.b = i.fa();
            let j = i.ap(a.os);
            let k = j == null || j.c == 1.7976931348623157E+308 || isNaN_(j.c);
            if (k) {
                continue;
            }
            let l = b.dz(j.c, h);
            let m = b.dz(j.b, h);
            f = Math.max(f, l);
            e = Math.min(e, m);
        }
        let n = a.os.width;
        if (c != -1) {
            n = c;
        }
        let o = a.os.left;
        if (d != -1) {
            o = d;
        }
        if (e == 1.7976931348623157E+308 || f == -1.7976931348623157E+308 || isNaN_(e) || isNaN_(f)) {
            return;
        }
        this.s8 = true;
        let p = new Rect(0, o, e, n, f - e);
        a.o8 = p;
        this.s8 = false;
    }
    yk(a) {
        if (a == null) {
            return;
        }
        if (a == this.dataChart) {
            this.yl(this.dataChart, this.yAxis, -1, -1);
            if (this.volumeChart != null) {
                this.yl(this.volumeChart, this.volumeAxis, this.dataChart.os.width, this.dataChart.os.left);
            }
        }
        else if (a == this.volumeChart) {
            this.yl(this.volumeChart, this.volumeAxis, -1, -1);
            this.yl(this.dataChart, this.yAxis, this.volumeChart.os.width, this.volumeChart.os.left);
        }
    }
    yc(a) {
        this.ii(() => this.yk(a));
    }
    xu(a, b) {
        if (this.s7) {
            this.yc(a);
        }
    }
    ys() {
        if (!this.td) {
            return;
        }
        this.xg();
        if (this.rm == 0) {
            this.zoomSliderChart = null;
        }
        else if (this.zoomSliderChart == null) {
            this.zoomSliderChart = ((() => {
                let $ret = new XamDataChart();
                $ret.name = "ZoomSliderChart";
                return $ret;
            })());
        }
        else {
            this.ya();
        }
    }
    xg() {
        let container_ = this.ui.rootWrapper.getNativeElement();
        let containerParent_ = container_.parentElement;
        if (this.sq != null && containerParent_ != null && !this.te) {
            this.te = true;
            if (TypeRegistrar.isRegistered("IgxZoomSliderComponent")) {
                let z_ = this.sq;
                let f_ = this.externalObject;
                let sliderComponent_ = TypeRegistrar.get("IgxZoomSliderComponent");
                let sliderInstance_ = TypeRegistrar.create("IgxZoomSliderComponent");
                sliderInstance_._implementation = z_;
                sliderComponent_._staticStyling(container_, sliderInstance_, f_);
            }
        }
    }
    ym() {
        if (this.rh != 1) {
            return;
        }
        this.ot((a) => {
            let b;
            b = a.breaks;
            b.clear();
            if (this.xAxisBreaks == null) {
                return;
            }
            for (let c of fromEnum(this.xAxisBreaks)) {
                b.add(c);
            }
        });
    }
    i2(a, b, c) {
        super.i2(a, b, c);
        if (this.x.dataSeries.count > 0) {
            if (this.rh == 1 && stringIsNullOrEmpty(this.e6)) {
                this.ae.setXMemberPath(a, c.getMemberPathFor(17));
            }
            if (stringIsNullOrEmpty(this.e8)) {
                this.ae.setYMemberPath(a, this.vk(c));
            }
            if (stringIsNullOrEmpty(this.e2)) {
                this.ae.setLabelMemberPath(a, this.vk(c));
            }
            if (stringIsNullOrEmpty(this.ez)) {
                this.ae.setContentMemberPath(a, this.vk(c));
            }
        }
    }
    vj(a) {
        switch (a) {
            case 0: return "Absolute Volume Oscillator";
            case 1: return "Accumulation/Distribution Indicator";
            case 2: return "Average Directional Index";
            case 3: return "Average True Range Indicator";
            case 4: return "Bollinger Bandwidth";
            case 5: return "Chaikin Oscillator";
            case 6: return "Chaikin Volatility Indicator";
            case 7: return "Commodity Channel Index";
            case 8: return "Detrended Price Oscillator";
            case 9: return "Ease of Movement Indicator";
            case 10: return "Fast Stochastic Oscillator";
            case 11: return "Force Index Indicator";
            case 12: return "Full Stochastic Oscillator";
            case 13: return "Market Facilitation Index";
            case 14: return "Mass Index Indicator";
            case 15: return "Median Price Indicator";
            case 16: return "Money Flow Index";
            case 17: return "MACD Indicator";
            case 18: return "Negative Volume Index";
            case 19: return "On Balance Volume Indicator";
            case 20: return "Percentage Price Oscillator";
            case 21: return "Percentage Volume Oscillator";
            case 22: return "Positive Volume Index";
            case 23: return "Price Volume Trend";
            case 24: return "ROC - Rate of Change Indicator";
            case 25: return "RSI - Relative Strength Index";
            case 26: return "Slow Stochastic Oscillator";
            case 27: return "Standard Deviation Indicator";
            case 28: return "Stoch RSI";
            case 29: return "TRIX Indicator";
            case 30: return "Typical Price Indicator";
            case 31: return "Ultimate Oscillator";
            case 32: return "Weighted Close Indicator";
            case 33: return "Williams %R Indicator";
            default: return "Unknown";
        }
    }
    op(a) {
        super.op(a);
        let b = a;
        this.x3(b);
        if (a.bf != null) {
            for (let c of fromEnum(a.bf.series)) {
                if (this.s0(c)) {
                    this.rw.setXAxis(c, b);
                }
                else if (this.s4(c)) {
                    this.ru.setXAxis(c, b);
                }
                else if (this.s1(c)) {
                    this.ry.setXAxis(c, b);
                }
                else if (this.s3(c)) {
                    this.r3.setXAxis(c, b);
                }
            }
        }
        let d = a == this.zoomSliderXAxis;
        if (d) {
            a.it = this.yy;
            a.d6 = this.ud;
            this.on(a, (e) => e.visibility = 1);
        }
        let e = a;
        e.minimumValue = this.tq;
        e.maximumValue = this.tp;
    }
    or(a) {
        super.or(a);
        if (a.bf != null && a == this.yAxis) {
            for (let b of fromEnum(a.bf.series)) {
                if (this.s0(b)) {
                    this.rw.setYAxis(b, this.yAxis);
                }
                else if (this.s4(b)) {
                    this.ru.setYAxis(b, this.yAxis);
                }
                else if (this.s1(b)) {
                    this.ry.setYAxis(b, this.yAxis);
                }
                else if (this.s3(b)) {
                    this.r3.setYAxis(b, this.yAxis);
                }
            }
        }
        a.jx = this.ta;
        a.kl = this.ub;
        a.kk = this.ua;
        if (a == this.yAxis) {
            a.kh = this.t9;
        }
        let c = a == this.zoomSliderAxis;
        if (c) {
            this.on(a, (d) => d.visibility = 1);
        }
    }
    x3(a) {
        a.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
        a.fa = XYChart.md(a, this.x.dataSeries);
        if (this.x.dataSeries.count > 0) {
            let b = this.x.dataSeries._inner[0].getMemberPathFor(17);
            a.g2(b);
        }
    }
    ht(a, b) {
        super.ht(a, b);
        if (a == null) {
            return;
        }
        let c = this.zoomSliderChart == a.b4;
        let d = this.dataChart != null && this.dataChart.series.contains(a);
        if ((d || c) && a.de) {
            a.k8(this.qj != null ? ArrayExtension.getModulus$1(Brush.$, this.qj, b) : null, this.qk != null ? ArrayExtension.getModulus$1(Brush.$, this.qk, b) : null);
        }
        let e = this.s1(a);
        if (this.s3(a)) {
            a.nb = this.ql != null ? ArrayExtension.getModulus$1(Brush.$, this.ql, b) : null;
            a.ng = this.qm != null ? ArrayExtension.getModulus$1(Brush.$, this.qm, b) : null;
            a.fv = this.t4;
        }
        else if (e) {
            a.nb = this.qh != null ? ArrayExtension.getModulus$1(Brush.$, this.qh, b) : null;
            a.fv = this.t3;
        }
        else if (!a.cx && (d || c)) {
            a.nb = this.j != null ? ArrayExtension.getModulus$1(Brush.$, this.j, b) : null;
            a.ng = this.n != null ? ArrayExtension.getModulus$1(Brush.$, this.n, b) : null;
        }
        let f = this.volumeChart != null && this.volumeChart == a.b4;
        if (f) {
            a.fv = this.t6;
        }
        a.legend = c || f || e || !a.isUsableInLegend ? null : this.legend != null ? this.legend : this.s2 ? this.rs : null;
    }
    id(a, b, c) {
        super.id(a, b, c);
        switch (a) {
            case "YAxisIsLogarithmic":
                this.yAxis.j2 = this.tb;
                if (this.volumeAxis != null) {
                    this.volumeAxis.j2 = this.tb;
                }
                if (this.zoomSliderAxis != null) {
                    this.zoomSliderAxis.j2 = this.tb;
                }
                break;
            case "YAxisLogarithmBase":
                this.yAxis.kp = this.ux;
                if (this.volumeAxis != null) {
                    this.volumeAxis.kp = this.ux;
                }
                if (this.zoomSliderAxis != null) {
                    this.zoomSliderAxis.kp = this.ux;
                }
                break;
            case "VolumeType":
                let d = EnumUtil.getEnumValue(FinancialChartVolumeType_$type, b);
                if (this.rf == 0) {
                    this.volumeChart = null;
                }
                else if (this.volumeChart == null) {
                    this.volumeChart = ((() => {
                        let $ret = new XamDataChart();
                        $ret.name = "VolumeChart";
                        return $ret;
                    })());
                }
                else {
                    this.x9();
                }
                break;
            case "VolumeChart":
                this.yt(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "DataChart":
                if (typeCast(XamDataChart.$, b) !== null) {
                    let e = b;
                    e.gridAreaRectChanged = delegateRemove(e.gridAreaRectChanged, runOn(this, this.xp));
                    e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.xm));
                    e.seriesDataUpdated = delegateRemove(e.seriesDataUpdated, runOn(this, this.xu));
                }
                if (this.dataChart != null) {
                    let f = this.dataChart;
                    f.gridAreaRectChanged = delegateCombine(f.gridAreaRectChanged, runOn(this, this.xp));
                    let g = this.dataChart;
                    g.actualWindowRectChanged = delegateCombine(g.actualWindowRectChanged, runOn(this, this.xm));
                    let h = this.dataChart;
                    h.seriesDataUpdated = delegateCombine(h.seriesDataUpdated, runOn(this, this.xu));
                }
                this.ys();
                break;
            case "XAxisMode":
                this.xAxis = this.qu(this.rh);
                this.xAxis.name = "xAxis";
                this.volumeXAxis = this.qu(this.rh);
                this.volumeXAxis.name = "volumeXAxis";
                this.indicatorXAxis = this.qu(this.rh);
                this.indicatorXAxis.name = "indicatorXAxis_0";
                this.zoomSliderXAxis = this.qu(this.rh);
                this.zoomSliderXAxis.name = "zoomSliderXAxis";
                this.on(this.zoomSliderXAxis, (i) => i.visibility = 1);
                this.xd();
                if (this.rh == 1) {
                    this.ym();
                }
                break;
            case "YAxisMode":
                this.yAxis = this.r8(this.rj);
                this.yAxis.name = "yAxis";
                this.zoomSliderAxis = this.r8(this.rj);
                this.zoomSliderAxis.name = "zoomSliderAxis";
                this.volumeAxis = this.r8(this.rj);
                this.volumeAxis.name = "volumeAxis";
                break;
            case "Toolbar":
                let i = typeCast(FinancialChartToolbar.$, b);
                if (i != null) {
                    i.rangeChanged = delegateRemove(i.rangeChanged, runOn(this, this.xt));
                    i.indicatorTypesChanged = delegateRemove(i.indicatorTypesChanged, runOn(this, this.xw));
                    i.overlayTypesChanged = delegateRemove(i.overlayTypesChanged, runOn(this, this.xx));
                }
                if (this.q8 != null) {
                    this.q8.ae = this.ro;
                    this.q8.ag = this.rq;
                    this.q8.u = this.q5;
                    this.yq(true);
                    let j = this.q8;
                    j.rangeChanged = delegateCombine(j.rangeChanged, runOn(this, this.xt));
                    let k = this.q8;
                    k.indicatorTypesChanged = delegateCombine(k.indicatorTypesChanged, runOn(this, this.xw));
                    let l = this.q8;
                    l.overlayTypesChanged = delegateCombine(l.overlayTypesChanged, runOn(this, this.xx));
                }
                break;
            case "XAxis":
                let m = typeCast(CategoryAxisBase.$, b);
                if (m != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(m);
                    }
                }
                let n = typeCast(ITimeRangeSelectorAxis_$type, b);
                if (n != null) {
                    n.visibleRangeChanged = delegateRemove(n.visibleRangeChanged, runOn(this, this.x0));
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.xAxis);
                }
                if (this.bw) {
                    this.op(this.xAxis);
                    this.hg();
                }
                this.yq(false);
                this.yr();
                this.yd();
                let o = this.xAxis;
                o.visibleRangeChanged = delegateCombine(o.visibleRangeChanged, runOn(this, this.x0));
                break;
            case "ChartType":
                this.ix();
                break;
            case "VolumeXAxis":
                this.yj(this.volumeChart, typeCast(Axis.$, b), this.volumeXAxis);
                break;
            case "ZoomSliderXAxis":
                this.yj(this.zoomSliderChart, typeCast(Axis.$, b), this.zoomSliderXAxis);
                break;
            case "IndicatorXAxis":
                this.yn();
                break;
            case "YAxis":
                let p = typeCast(NumericYAxis.$, b);
                if (p != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(p);
                    }
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.yAxis);
                }
                if (this.bw) {
                    this.or(this.yAxis);
                    this.or(this.yAxis);
                }
                let q = this.yAxis;
                q.rangeChanged = delegateCombine(q.rangeChanged, runOn(this, this.x1));
                break;
            case "VolumeAxis":
                let r = typeCast(Axis.$, b);
                if (this.volumeChart != null && r != null) {
                    this.volumeChart.axes.remove(r);
                }
                if (this.volumeChart != null && this.volumeAxis != null) {
                    this.volumeChart.axes.add(this.volumeAxis);
                    this.x9();
                }
                if (this.bw) {
                    this.or(this.volumeAxis);
                }
                let s = this.volumeAxis;
                s.rangeChanged = delegateCombine(s.rangeChanged, runOn(this, this.x1));
                break;
            case "IndicatorAxis":
                if (this.indicatorCharts != null) {
                    for (let t = 0; t < this.indicatorCharts.count; t++) {
                        let u = this.indicatorCharts._inner[t];
                        let v = new List$1(Axis.$, 0);
                        for (let w of fromEnum(u.axes)) {
                            if (typeCast(NumericYAxis.$, w) !== null) {
                                v.add(w);
                            }
                        }
                        for (let x of fromEnum(v)) {
                            u.axes.remove(x);
                        }
                        let y = null;
                        if (t == 0) {
                            y = this.indicatorAxis;
                        }
                        else if (this.rj == 1) {
                            y = this.r8(this.rj);
                        }
                        else if (typeCast(NumericYAxis.$, this.indicatorAxis) !== null) {
                            y = new NumericYAxis();
                        }
                        if (y != null) {
                            u.axes.add(y);
                        }
                        if (this.bw) {
                            this.or(y);
                        }
                    }
                }
                break;
            case "IsWindowSyncedToVisibleRange":
                if (this.dataChart != null) {
                    this.dataChart.p1 = this.cb && this.ca;
                }
                if (this.volumeChart != null) {
                    this.volumeChart.p1 = this.cb && this.ca;
                }
                if (this.s7) {
                    this.yk(this.dataChart);
                }
                else {
                    this.volumeChart.qv = 1;
                }
                break;
            case "IndicatorTypes":
                let z = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), b);
                if (z != null) {
                    z.collectionChanged = delegateRemove(z.collectionChanged, runOn(this, this.xq));
                }
                let aa = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), c);
                if (aa != null) {
                    aa.collectionChanged = delegateCombine(aa.collectionChanged, runOn(this, this.xq));
                }
                this.yn();
                break;
            case "OverlayTypes":
                let ab = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), b);
                if (ab != null) {
                    ab.collectionChanged = delegateRemove(ab.collectionChanged, runOn(this, this.xr));
                }
                let ac = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), c);
                if (ac != null) {
                    ac.collectionChanged = delegateCombine(ac.collectionChanged, runOn(this, this.xr));
                }
                this.yp();
                break;
            case "YAxisAbbreviateLargeNumbers":
                this.ox((ad) => ad.jx = this.ta);
                break;
            case "YAxisMinimumValue":
                this.oy((ad) => ad.kl = this.ub, false);
                break;
            case "YAxisMaximumValue":
                this.oy((ad) => ad.kk = this.ua, false);
                break;
            case "YAxisInterval":
                this.oy((ad) => ad.kh = this.t9, false);
                break;
            case "ZoomSliderType":
                this.ys();
                break;
            case "ZoomSliderChart":
                if (!this.tc) {
                    return;
                }
                this.yv(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "NegativeBrushes":
            case "NegativeOutlines":
                this.xj((ad, ae) => {
                    if (ad.de) {
                        ad.k8(this.qj != null ? ArrayExtension.getModulus$1(Brush.$, this.qj, ae) : null, this.qk != null ? ArrayExtension.getModulus$1(Brush.$, this.qk, ae) : null);
                    }
                }, true);
                break;
            case "OverlayBrushes":
                this.hi((ad, ae) => {
                    if (!(this.s3(ad))) {
                        return;
                    }
                    ad.nb = this.ql != null ? ArrayExtension.getModulus$1(Brush.$, this.ql, ae) : null;
                });
                break;
            case "OverlayOutlines":
                this.hi((ad, ae) => {
                    if (!(this.s3(ad))) {
                        return;
                    }
                    ad.ng = this.qm != null ? ArrayExtension.getModulus$1(Brush.$, this.qm, ae) : null;
                });
                break;
            case "OverlayThickness":
                this.hi((ad, ae) => {
                    if (!(this.s3(ad))) {
                        return;
                    }
                    ad.fv = this.t4;
                });
                break;
            case "VolumeBrushes":
                this.xk((ad, ae) => ad.nb = ArrayExtension.getModulus$1(Brush.$, this.qn, ae));
                break;
            case "VolumeOutlines":
                this.xk((ad, ae) => ad.ng = ArrayExtension.getModulus$1(Brush.$, this.qo, ae));
                break;
            case "VolumeThickness":
                this.xk((ad, ae) => ad.fv = this.t6);
                break;
            case "IndicatorNegativeBrushes":
                this.xh((ad, ae) => this.ry.setNegativeBrush(ad, ArrayExtension.getModulus$1(Brush.$, this.qi, ae)));
                break;
            case "IndicatorBrushes":
                this.xh((ad, ae) => ad.nb = ArrayExtension.getModulus$1(Brush.$, this.qh, ae));
                break;
            case "IndicatorThickness":
                this.xh((ad, ae) => ad.fv = this.t3);
                break;
            case "IndicatorDisplayTypes":
                this.xh((ad, ae) => this.ry.setDisplayType(ad, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.r0, ae)));
                break;
            case "IndicatorPeriod":
                this.xh((ad, ae) => {
                    if (this.us == -2147483648 || !(this.s1(ad))) {
                        return;
                    }
                    this.ry.setPeriodOverride(ad, this.us);
                });
                break;
            case "IndicatorMultiplier":
                this.xh((ad, ae) => {
                    if (!(this.s3(ad))) {
                        return;
                    }
                    this.r3.setMultiplier(ad, this.t2);
                });
                break;
            case "IndicatorSmoothingPeriod":
                this.xh((ad, ae) => {
                    if (!(this.s1(ad))) {
                        return;
                    }
                    this.ry.setSmoothingPeriod(ad, this.uv);
                });
                break;
            case "IndicatorShortPeriod":
                this.xh((ad, ae) => {
                    if (!(this.s1(ad))) {
                        return;
                    }
                    this.ry.setShortPeriod(ad, this.ut);
                });
                break;
            case "IndicatorLongPeriod":
                this.xh((ad, ae) => {
                    if (!(this.s1(ad))) {
                        return;
                    }
                    this.ry.setLongPeriod(ad, this.ur);
                });
                break;
            case "IndicatorSignalPeriod":
                this.xh((ad, ae) => {
                    if (!(this.s1(ad))) {
                        return;
                    }
                    this.ry.setSignalPeriod(ad, this.uu);
                });
                break;
            case "RangeSelectorOptions":
                let ad = typeCast(FinancialChartRangeSelectorOptionCollection.$, b);
                if (ad != null) {
                    ad.collectionChanged = delegateRemove(ad.collectionChanged, runOn(this, this.xs));
                }
                if (this.q6 != null) {
                    let ae = this.q6;
                    ae.collectionChanged = delegateCombine(ae.collectionChanged, runOn(this, this.xs));
                }
                this.yd();
                break;
            case "CustomIndicatorNames":
                let af = typeCast(ObservableCollection$1.$.specialize(String_$type), b);
                if (af != null) {
                    af.collectionChanged = delegateRemove(af.collectionChanged, runOn(this, this.xo));
                }
                if (this.customIndicatorNames != null) {
                    let ag = this.customIndicatorNames;
                    ag.collectionChanged = delegateCombine(ag.collectionChanged, runOn(this, this.xo));
                }
                this.yn();
                break;
            case "Legend":
                if (this.zoomSliderChart != null) {
                    this.zoomSliderChart.legend = null;
                }
                break;
            case "Brushes":
                this.xj((ah, ai) => ah.nb = this.j != null ? ArrayExtension.getModulus$1(Brush.$, this.j, ai) : null, true);
                break;
            case "Outlines":
                this.xj((ah, ai) => ah.ng = this.n != null ? ArrayExtension.getModulus$1(Brush.$, this.n, ai) : null, true);
                break;
            case "XAxisLabelVisibility":
                if (this.p7 == 0 && this.zoomSliderXAxis != null) {
                    this.on(this.zoomSliderXAxis, (ah) => ah.visibility = 1);
                }
                this.xd();
                break;
            case "YAxisLabelVisibility":
                if (this.p8 != 0 || this.zoomSliderAxis == null) {
                    break;
                }
                this.on(this.zoomSliderAxis, (ah) => ah.visibility = 1);
                break;
            case "ZoomSliderXAxisMajorStroke":
                this.zoomSliderXAxis.it = this.yy;
                break;
            case "ZoomSliderXAxisMajorStrokeThickness":
                this.zoomSliderXAxis.d6 = this.ud;
                break;
            case "FinancialChartLegend":
            case "IsLegendVisible":
                let ah = this.s2 && this.legend == null;
                {
                    let ai = (aj, ak) => {
                        if (aj.isUsableInLegend) {
                            aj.legend = ah ? this.rs : null;
                        }
                    };
                    this.xj(ai, false);
                    this.xi(ai);
                }
                break;
            case "ZoomSliderAxis":
                let aj = typeCast(Axis.$, b);
                if (aj != null && this.zoomSliderChart != null) {
                    this.zoomSliderChart.axes.remove(aj);
                }
                if (this.zoomSliderAxis != null) {
                    if (this.zoomSliderChart != null) {
                        this.zoomSliderChart.axes.add(this.zoomSliderAxis);
                        this.ya();
                        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
                    }
                    if (this.bw) {
                        this.or(this.zoomSliderAxis);
                    }
                    this.on(this.zoomSliderAxis, (ak) => ak.visibility = 1);
                }
                break;
            case "XAxisMinimumValue":
                this.ot((ak) => {
                    let al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                    if (al != null) {
                        al.minimumValue = this.tq;
                    }
                });
                break;
            case "XAxisMaximumValue":
                this.ot((ak) => {
                    let al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                    if (al != null) {
                        al.maximumValue = this.tp;
                    }
                });
                break;
        }
    }
    get tb() {
        return this.sv;
    }
    set tb(a) {
        let b = this.tb;
        if (a != b) {
            this.sv = a;
            this.id("YAxisIsLogarithmic", b, this.tb);
        }
    }
    get ux() {
        return this.up;
    }
    set ux(a) {
        let b = this.ux;
        if (a != b) {
            this.up = a;
            this.id("YAxisLogarithmBase", b, this.ux);
        }
    }
    get t9() {
        return this.tw;
    }
    set t9(a) {
        let b = this.t9;
        if (a != b) {
            this.tw = a;
            this.id("YAxisInterval", b, this.t9);
        }
    }
    get ub() {
        return this.ty;
    }
    set ub(a) {
        let b = this.ub;
        if (a != b) {
            this.ty = a;
            this.id("YAxisMinimumValue", b, this.ub);
        }
    }
    get ua() {
        return this.tx;
    }
    set ua(a) {
        let b = this.ua;
        if (a != b) {
            this.tx = a;
            this.id("YAxisMaximumValue", b, this.ua);
        }
    }
    get uc() {
        return this.tz;
    }
    set uc(a) {
        let b = this.uc;
        if (a != b) {
            this.tz = a;
            this.id("YAxisMinorInterval", b, this.uc);
        }
    }
    get t8() {
        return this.yAxis.kd;
    }
    get t7() {
        return this.yAxis.kc;
    }
    get rf() {
        return this.rd;
    }
    set rf(a) {
        let b = this.rf;
        if (a != b) {
            this.rd = a;
            this.id("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.rf));
        }
    }
    get rh() {
        return this.rg;
    }
    set rh(a) {
        let b = this.rh;
        if (a != b) {
            this.rg = a;
            this.id("XAxisMode", enumGetBox(FinancialChartXAxisMode_$type, b), enumGetBox(FinancialChartXAxisMode_$type, this.rh));
        }
    }
    get rj() {
        return this.ri;
    }
    set rj(a) {
        let b = this.rj;
        if (a != b) {
            this.ri = a;
            this.id("YAxisMode", enumGetBox(FinancialChartYAxisMode_$type, b), enumGetBox(FinancialChartYAxisMode_$type, this.rj));
        }
    }
    get s6() {
        return this.ss;
    }
    set s6(a) {
        let b = this.s6;
        if (a != b) {
            this.ss = a;
            this.id("IsToolbarVisible", b, this.s6);
        }
    }
    get ra() {
        return this.q9;
    }
    set ra(a) {
        let b = this.ra;
        if (a != b) {
            this.q9 = a;
            this.id("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.ra));
        }
    }
    get_o6() {
        return super.get_o6();
    }
    set_o6(a) {
        super.set_o6(a);
    }
    get s7() {
        return this.st;
    }
    set s7(a) {
        let b = this.s7;
        if (a != b) {
            this.st = a;
            this.id("IsWindowSyncedToVisibleRange", b, this.s7);
        }
    }
    get ro() {
        return this.rn;
    }
    set ro(a) {
        let b = this.ro;
        if (a != b) {
            this.rn = a;
            this.id("IndicatorTypes", b, this.ro);
        }
    }
    get rq() {
        return this.rp;
    }
    set rq(a) {
        let b = this.rq;
        if (a != b) {
            this.rp = a;
            this.id("OverlayTypes", b, this.rq);
        }
    }
    get indicatorCharts() {
        return this.tg;
    }
    set indicatorCharts(a) {
        let b = this.indicatorCharts;
        if (a != b) {
            this.tg = a;
            this.id("IndicatorCharts", b, this.indicatorCharts);
        }
    }
    get ta() {
        return this.su;
    }
    set ta(a) {
        let b = this.ta;
        if (a != b) {
            this.su = a;
            this.id("YAxisAbbreviateLargeNumbers", b, this.ta);
        }
    }
    get_dp() {
        return super.get_dp();
    }
    set_dp(a) {
        super.set_dp(a);
    }
    get_jw() {
        return super.get_jw();
    }
    set_jw(a) {
        super.set_jw(a);
    }
    get zoomSliderChart() {
        return this.sm;
    }
    set zoomSliderChart(a) {
        let b = this.zoomSliderChart;
        if (a != b) {
            this.sm = a;
            this.id("ZoomSliderChart", b, this.zoomSliderChart);
        }
    }
    get zoomSliderAxis() {
        return this.r7;
    }
    set zoomSliderAxis(a) {
        let b = this.zoomSliderAxis;
        if (a != b) {
            this.r7 = a;
            this.id("ZoomSliderAxis", b, this.zoomSliderAxis);
        }
    }
    get zoomSliderXAxis() {
        return this.qs;
    }
    set zoomSliderXAxis(a) {
        let b = this.zoomSliderXAxis;
        if (a != b) {
            this.qs = a;
            this.id("ZoomSliderXAxis", b, this.zoomSliderXAxis);
        }
    }
    get rm() {
        return this.rk;
    }
    set rm(a) {
        let b = this.rm;
        if (a != b) {
            this.rk = a;
            this.id("ZoomSliderType", enumGetBox(FinancialChartZoomSliderType_$type, b), enumGetBox(FinancialChartZoomSliderType_$type, this.rm));
        }
    }
    get qj() {
        return this.qb;
    }
    set qj(a) {
        let b = this.qj;
        if (a != b) {
            this.qb = a;
            this.id("NegativeBrushes", b, this.qj);
        }
    }
    get qk() {
        return this.qc;
    }
    set qk(a) {
        let b = this.qk;
        if (a != b) {
            this.qc = a;
            this.id("NegativeOutlines", b, this.qk);
        }
    }
    get ql() {
        return this.qd;
    }
    set ql(a) {
        let b = this.ql;
        if (a != b) {
            this.qd = a;
            this.id("OverlayBrushes", b, this.ql);
        }
    }
    get qm() {
        return this.qe;
    }
    set qm(a) {
        let b = this.qm;
        if (a != b) {
            this.qe = a;
            this.id("OverlayOutlines", b, this.qm);
        }
    }
    get qo() {
        return this.qg;
    }
    set qo(a) {
        let b = this.qo;
        if (a != b) {
            this.qg = a;
            this.id("VolumeOutlines", b, this.qo);
        }
    }
    get qn() {
        return this.qf;
    }
    set qn(a) {
        let b = this.qn;
        if (a != b) {
            this.qf = a;
            this.id("VolumeBrushes", b, this.qn);
        }
    }
    get qi() {
        return this.qa;
    }
    set qi(a) {
        let b = this.qi;
        if (a != b) {
            this.qa = a;
            this.id("IndicatorNegativeBrushes", b, this.qi);
        }
    }
    get qh() {
        return this.p9;
    }
    set qh(a) {
        let b = this.qh;
        if (a != b) {
            this.p9 = a;
            this.id("IndicatorBrushes", b, this.qh);
        }
    }
    get t6() {
        return this.tv;
    }
    set t6(a) {
        let b = this.t6;
        if (a != b) {
            this.tv = a;
            this.id("VolumeThickness", b, this.t6);
        }
    }
    get t4() {
        return this.tt;
    }
    set t4(a) {
        let b = this.t4;
        if (a != b) {
            this.tt = a;
            this.id("OverlayThickness", b, this.t4);
        }
    }
    get t3() {
        return this.ts;
    }
    set t3(a) {
        let b = this.t3;
        if (a != b) {
            this.ts = a;
            this.id("IndicatorThickness", b, this.t3);
        }
    }
    get r0() {
        return this.rz;
    }
    set r0(a) {
        let b = this.r0;
        if (a != b) {
            this.rz = a;
            this.id("IndicatorDisplayTypes", b, this.r0);
        }
    }
    get us() {
        return this.ul;
    }
    set us(a) {
        let b = this.us;
        if (a != b) {
            this.ul = a;
            this.id("IndicatorPeriod", b, this.us);
        }
    }
    get t2() {
        return this.tr;
    }
    set t2(a) {
        let b = this.t2;
        if (a != b) {
            this.tr = a;
            this.id("IndicatorMultiplier", b, this.t2);
        }
    }
    get uv() {
        return this.uo;
    }
    set uv(a) {
        let b = this.uv;
        if (a != b) {
            this.uo = a;
            this.id("IndicatorSmoothingPeriod", b, this.uv);
        }
    }
    get ut() {
        return this.um;
    }
    set ut(a) {
        let b = this.ut;
        if (a != b) {
            this.um = a;
            this.id("IndicatorShortPeriod", b, this.ut);
        }
    }
    get ur() {
        return this.uk;
    }
    set ur(a) {
        let b = this.ur;
        if (a != b) {
            this.uk = a;
            this.id("IndicatorLongPeriod", b, this.ur);
        }
    }
    get uu() {
        return this.un;
    }
    set uu(a) {
        let b = this.uu;
        if (a != b) {
            this.un = a;
            this.id("IndicatorSignalPeriod", b, this.uu);
        }
    }
    get q6() {
        return this.q4;
    }
    set q6(a) {
        let b = this.q6;
        if (a != b) {
            this.q4 = a;
            this.id("RangeSelectorOptions", b, this.q6);
        }
    }
    get customIndicatorNames() {
        return this.q0;
    }
    set customIndicatorNames(a) {
        let b = this.q0;
        if (a != b) {
            this.q0 = a;
            this.id("CustomIndicatorNames", b, this.customIndicatorNames);
        }
    }
    get_cb() {
        return super.get_cb();
    }
    set_cb(a) {
        super.set_cb(a);
    }
    get yy() {
        return this.yx;
    }
    set yy(a) {
        let b = this.yy;
        if (a != b) {
            this.yx = a;
            this.id("ZoomSliderXAxisMajorStroke", b, this.yy);
        }
    }
    get ud() {
        return this.t0;
    }
    set ud(a) {
        let b = this.ud;
        if (a != b) {
            this.t0 = a;
            this.id("ZoomSliderXAxisMajorStrokeThickness", b, this.ud);
        }
    }
    get s2() {
        return this.sr;
    }
    set s2(a) {
        let b = this.s2;
        if (a != b) {
            this.sr = a;
            this.id("IsLegendVisible", b, this.s2);
        }
    }
    get rs() {
        return this.rr;
    }
    set rs(a) {
        let b = this.rs;
        if (a != b) {
            this.rr = a;
            this.id("FinancialChartLegend", b, this.rs);
        }
    }
    get xAxis() {
        return this.qr;
    }
    set xAxis(a) {
        let b = this.xAxis;
        if (a != b) {
            this.qr = a;
            this.id("XAxis", b, this.xAxis);
        }
    }
    get yAxis() {
        return this.r6;
    }
    set yAxis(a) {
        let b = this.yAxis;
        if (a != b) {
            this.r6 = a;
            this.id("YAxis", b, this.yAxis);
        }
    }
    get volumeAxis() {
        return this.r5;
    }
    set volumeAxis(a) {
        let b = this.volumeAxis;
        if (a != b) {
            this.r5 = a;
            this.id("VolumeAxis", b, this.volumeAxis);
        }
    }
    get volumeXAxis() {
        return this.qq;
    }
    set volumeXAxis(a) {
        let b = this.volumeXAxis;
        if (a != b) {
            this.qq = a;
            this.id("VolumeXAxis", b, this.volumeXAxis);
        }
    }
    get indicatorAxis() {
        return this.r4;
    }
    set indicatorAxis(a) {
        let b = this.indicatorAxis;
        if (a != b) {
            this.r4 = a;
            this.id("IndicatorAxis", b, this.indicatorAxis);
        }
    }
    get indicatorXAxis() {
        return this.qp;
    }
    set indicatorXAxis(a) {
        let b = this.indicatorXAxis;
        if (a != b) {
            this.qp = a;
            this.id("IndicatorXAxis", b, this.indicatorXAxis);
        }
    }
    get ti() {
        return this.tf;
    }
    set ti(a) {
        let b = this.ti;
        if (a != b) {
            this.tf = a;
            this.id("IndicatorAxes", b, this.ti);
        }
    }
    get tk() {
        return this.th;
    }
    set tk(a) {
        let b = this.tk;
        if (a != b) {
            this.th = a;
            this.id("IndicatorXAxes", b, this.tk);
        }
    }
    get tq() {
        return this.to;
    }
    set tq(a) {
        let b = this.tq;
        if (+a != +b) {
            this.to = a;
            this.id("XAxisMinimumValue", b, this.tq);
        }
    }
    get tp() {
        return this.tn;
    }
    set tp(a) {
        let b = this.tp;
        if (+a != +b) {
            this.tn = a;
            this.id("XAxisMaximumValue", b, this.tp);
        }
    }
    get xAxisBreaks() {
        return this.tl;
    }
}
FinancialChart.$t = markType(FinancialChart, 'FinancialChart', XYChart.$);
FinancialChart.uw = 0;
/**
 * @hidden
 */
export class FinancialChartToolbar extends TemplatedHtmlControl {
    constructor(a, b) {
        super("financialChartToolbar", b, "");
        this.o = null;
        this.r = null;
        this.z = null;
        this.p = null;
        this.w = null;
        this.aq = dateMaxValue();
        this.ap = dateMinValue();
        this.ao = dateMaxValue();
        this.an = dateMinValue();
        this.rangeChanged = null;
        this.chartTypeChanged = null;
        this.trendLineTypeChanged = null;
        this.volumeTypeChanged = null;
        this.indicatorTypesChanged = null;
        this.overlayTypesChanged = null;
        this.x = 0;
        this.ah = 0;
        this.ab = 0;
        this.ad = null;
        this.af = null;
        this.t = null;
        this.ak = false;
        this.o = a;
        this.w = new FinancialChartToolbarViewModel();
        this.s = new FinancialChartRangeSelector(a != null ? a.u8 : null);
        this.aa = new FinancialChartTypePicker(a != null ? a.u5 : null);
        this.q = new FinancialChartIndicatorMenu(1, a != null ? a.u6 : null);
    }
    bg(a) {
        let b = a.querySelectorAll(".financialChartToolbarArea");
        if (b != null && b.length > 0) {
            this.g = b[0];
            if (!this.al) {
                this.g.hide();
            }
        }
        let c = a.querySelectorAll(".financialChartIndicatorMenu");
        if (c != null && c.length > 0) {
            this.q.g = c[0];
        }
        let d = a.querySelectorAll(".financialChartRangeSelector");
        if (d != null && d.length > 0) {
            this.s.g = d[0];
        }
        let e = a.querySelectorAll(".financialChartTypePicker");
        if (e != null && e.length > 0) {
            this.aa.g = e[0];
        }
    }
    bl(a) {
        this.q.u(a);
        this.aa.u(a);
    }
    get s() {
        return this.r;
    }
    set s(a) {
        let b = this.s;
        if (a != b) {
            this.r = a;
            this.bm("RangeSelector", b, this.s);
        }
    }
    get aa() {
        return this.z;
    }
    set aa(a) {
        let b = this.aa;
        if (a != b) {
            this.z = a;
            this.bm("ChartTypePicker", b, this.aa);
        }
    }
    get q() {
        return this.p;
    }
    set q(a) {
        let b = this.q;
        if (a != b) {
            this.p = a;
            this.bm("IndicatorMenu", b, this.q);
        }
    }
    bm(a, b, c) {
        switch (a) {
            case "RangeStart":
                if (this.s != null) {
                    this.s.t = this.as;
                }
                break;
            case "RangeEnd":
                if (this.s != null) {
                    this.s.s = this.ar;
                }
                break;
            case "SelectionStart":
                if (this.s != null) {
                    this.s.v = this.au;
                }
                break;
            case "SelectionEnd":
                if (this.s != null) {
                    this.s.u = this.at;
                }
                break;
            case "RangeSelector":
                let d = b;
                if (d != null) {
                    d.rangeChanged = delegateRemove(d.rangeChanged, runOn(this, this.bj));
                }
                if (this.s != null) {
                    this.s.t = this.as;
                    this.s.s = this.ar;
                    this.s.o = this.u;
                    this.s.v = this.au;
                    this.s.u = this.at;
                    let e = this.s;
                    e.rangeChanged = delegateCombine(e.rangeChanged, runOn(this, this.bj));
                }
                break;
            case "ChartTypePicker":
                let f = b;
                if (f != null) {
                    f.selectionChanged = delegateRemove(f.selectionChanged, runOn(this, this.bi));
                }
                if (this.aa != null) {
                    this.aa.w = this.y;
                    let g = this.aa;
                    g.selectionChanged = delegateCombine(g.selectionChanged, runOn(this, this.bi));
                }
                break;
            case "ChartType":
                if (this.aa != null) {
                    this.aa.w = this.y;
                }
                break;
            case "RangeSelectorOptions":
                if (this.s != null) {
                    this.s.o = this.u;
                }
                break;
            case "IsToolbarVisible":
                if (this.g == null) {
                    break;
                }
                if (this.al) {
                    this.g.show();
                }
                else {
                    this.g.hide();
                }
                break;
            case "IndicatorMenu":
                let h = typeCast(FinancialChartIndicatorMenu.$, b);
                if (h != null) {
                    h.selectionChanged = delegateRemove(h.selectionChanged, runOn(this, this.bh));
                }
                if (this.q != null) {
                    let i = this.q;
                    i.selectionChanged = delegateCombine(i.selectionChanged, runOn(this, this.bh));
                }
                break;
            case "IndicatorTypes":
                if (this.indicatorTypesChanged != null) {
                    this.indicatorTypesChanged(this, EventArgs.empty);
                }
                break;
            case "OverlayTypes":
                if (this.overlayTypesChanged != null) {
                    this.overlayTypesChanged(this, EventArgs.empty);
                }
                break;
            case "TrendLineType":
                if (this.trendLineTypeChanged != null) {
                    this.trendLineTypeChanged(this, EventArgs.empty);
                }
                break;
            case "VolumeType":
                if (this.volumeTypeChanged != null) {
                    this.volumeTypeChanged(this, EventArgs.empty);
                }
                break;
        }
    }
    bh(a, b) {
        this.ag = this.q.z;
        this.ae = this.q.y;
        this.ai = this.q.aa;
        this.ac = this.q.x;
    }
    bi(a, b) {
        this.y = this.aa.w;
        if (this.chartTypeChanged != null) {
            this.chartTypeChanged(this, b);
        }
    }
    bj(a, b) {
        this.au = this.s.v;
        this.at = this.s.u;
        if (this.rangeChanged != null) {
            this.rangeChanged(this, b);
        }
    }
    v() {
        let a = new FinancialChartToolbarContext();
        a.container = this.d;
        a.vm = this.w;
        a.vm.financialChartIndicatorMenu = ((() => {
            let $ret = new FinancialChartIndicatorMenuContext();
            $ret.vm = this.q.p;
            return $ret;
        })());
        a.vm.financialChartTypePicker = ((() => {
            let $ret = new FinancialChartTypePickerContext();
            $ret.vm = this.aa.p;
            return $ret;
        })());
        a.vm.financialChartRangeSelector = ((() => {
            let $ret = new FinancialChartRangeSelectorContext();
            $ret.vm = this.s.q;
            return $ret;
        })());
        return a;
    }
    l(a) {
        super.l(a);
        if (a == null) {
            return;
        }
        this.s.l(a);
        this.aa.l(a);
        this.q.l(a);
        this.bk();
    }
    bk() {
    }
    get au() {
        return this.aq;
    }
    set au(a) {
        let b = this.au;
        if (+a != +b) {
            this.aq = a;
            this.bm("SelectionStart", b, this.au);
        }
    }
    get at() {
        return this.ap;
    }
    set at(a) {
        let b = this.at;
        if (+a != +b) {
            this.ap = a;
            this.bm("SelectionEnd", b, this.at);
        }
    }
    get as() {
        return this.ao;
    }
    set as(a) {
        let b = this.as;
        if (+a != +b) {
            this.ao = a;
            this.bm("RangeStart", b, this.as);
        }
    }
    get ar() {
        return this.an;
    }
    set ar(a) {
        let b = this.ar;
        if (+a != +b) {
            this.an = a;
            this.bm("RangeEnd", b, this.ar);
        }
    }
    bn() {
        if (this.s != null) {
            this.s.ab();
        }
    }
    get y() {
        return this.x;
    }
    set y(a) {
        let b = this.y;
        if (a != b) {
            this.x = a;
            this.bm("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.y));
        }
    }
    get ai() {
        return this.ah;
    }
    set ai(a) {
        let b = this.ai;
        if (a != b) {
            this.ah = a;
            this.bm("TrendLineType", enumGetBox(TrendLineType_$type, b), enumGetBox(TrendLineType_$type, this.ai));
        }
    }
    get ac() {
        return this.ab;
    }
    set ac(a) {
        let b = this.ac;
        if (a != b) {
            this.ab = a;
            this.bm("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.ac));
        }
    }
    get ae() {
        return this.ad;
    }
    set ae(a) {
        let b = this.ae;
        if (!FinancialChartToolbar.am(b, a)) {
            this.ad = a;
            this.bm("IndicatorTypes", b, this.ae);
        }
    }
    get ag() {
        return this.af;
    }
    set ag(a) {
        let b = this.ag;
        if (!FinancialChartToolbar.am(b, a)) {
            this.af = a;
            this.bm("OverlayTypes", b, this.ag);
        }
    }
    static am(a, b) {
        if (a == b) {
            return true;
        }
        if ((a == null && b != null) || (a != null && b == null)) {
            return false;
        }
        if (a.count != b.count) {
            return false;
        }
        for (let c of fromEn(a)) {
            if (!b.contains(c)) {
                return false;
            }
        }
        return true;
    }
    aj() {
        return ((() => {
            let $ret = new FinancialChartToolbarVisualData();
            $ret.rangeSelector = this.s == null ? null : this.s.r();
            return $ret;
        })());
    }
    get u() {
        return this.t;
    }
    set u(a) {
        let b = this.u;
        if (a != b) {
            this.t = a;
            this.bm("RangeSelectorOptions", b, this.u);
        }
    }
    get al() {
        return this.ak;
    }
    set al(a) {
        let b = this.al;
        if (a != b) {
            this.ak = a;
            this.bm("IsToolbarVisible", b, this.al);
        }
    }
}
FinancialChartToolbar.$t = markType(FinancialChartToolbar, 'FinancialChartToolbar', TemplatedHtmlControl.$);
/**
 * @hidden
 */
export class FinancialChartRangeSelector extends TemplatedHtmlControl {
    constructor(a) {
        super("financialChartRangeSelector", a, "");
        this.q = null;
        this.rangeChanged = null;
        this.p = null;
        this.p = new FinancialChartRangeSelectorView();
        this.q = new FinancialChartRangeSelectorViewModel();
        this.q.onRangeChanged = runOn(this, this.z);
        this.p.c = this.q;
    }
    get v() {
        return this.q.selectionStart;
    }
    set v(a) {
        this.q.selectionStart = a;
    }
    get u() {
        return this.q.selectionEnd;
    }
    set u(a) {
        this.q.selectionEnd = a;
    }
    get t() {
        return this.q.rangeStart;
    }
    set t(a) {
        this.q.rangeStart = a;
    }
    get s() {
        return this.q.rangeEnd;
    }
    set s(a) {
        this.q.rangeEnd = a;
    }
    ab() {
        if (this.q.onPropertiesChanged()) {
            this.p.g(this.q);
        }
    }
    l(a) {
        super.l(a);
        this.p.f(this.d, this.q);
    }
    z() {
        if (this.rangeChanged != null) {
            this.rangeChanged(this, EventArgs.empty);
        }
    }
    r() {
        return this.p.d(this.g);
    }
    get o() {
        return this.q.options;
    }
    set o(a) {
        let b = !FinancialChartToolbar.am(this.q.options, a);
        if (b) {
            this.q.options = a;
            this.aa();
        }
    }
    aa() {
        if (this.q != null) {
            this.q.ao();
        }
        if (this.p != null) {
            this.p.i(this.o);
        }
    }
}
FinancialChartRangeSelector.$t = markType(FinancialChartRangeSelector, 'FinancialChartRangeSelector', TemplatedHtmlControl.$);
FinancialChartRangeSelector.x = 0;
//# sourceMappingURL=FinancialChart_combined.js.map