/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { DependencyProperty } from "igniteui-angular-core";
import { TrendLineType_$type } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap_$type } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { CategoryFrame } from "./CategoryFrame";
import { Number_$type, typeCast, enumGetBox, EnumUtil, runOn, markType, markDep } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { CategorySeries } from "./CategorySeries";
import { NotImplementedException } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { LineGeometry } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { GeometryGroup } from "igniteui-angular-core";
import { Extensions } from "igniteui-angular-core";
import { IndicatorRenderer } from "./IndicatorRenderer";
/**
 * @hidden
 */
export class FinancialIndicator extends FinancialSeries {
    constructor() {
        super();
        this._indicatorColumn = null;
        this.rq = null;
        this.ok = new CategoryFrame(3);
        this.om = new CategoryFrame(3);
        this.oj = new CategoryFrame(3);
        this.indicatorColumn = new List$1(Number_$type, 0);
        this.rq = new AxisRange(-100, 100);
    }
    bp() {
        return new FinancialIndicatorView(this);
    }
    kk(a) {
        super.kk(a);
        this.rr = a;
    }
    r3(a) {
        if (this.o2 != null && !this.o2.cn()) {
            this.k3(true);
        }
    }
    rv(a, b, c) {
        if (isNaN_(b.x) || isNaN_(b.y)) {
            return false;
        }
        let d = this.o2;
        let e = 0;
        if (d != null) {
            e = d.ee(d.kn);
        }
        if ((a.y >= e && a.y <= b.y) || (a.y <= e && a.y >= b.y)) {
            return true;
        }
        return false;
    }
    bj() {
        if (this.bk == 0) {
            return 1;
        }
        else {
            return super.bj();
        }
    }
    n2(a) {
        if (this.oh == null || this.o2 == null) {
            return Rect.empty;
        }
        let b = this.no(a);
        let c = this.bs.bv;
        let d = this.bs.bu;
        let e = this.getEffectiveViewport1(this.bs);
        let f = new ScalerParams(0, c, d, this.o2.ca, e);
        f.b = this.fa();
        let g = this.aj(this.oh, this.oj.f, this.qd(this.bs), this.qf(this.bs), a, true);
        if (g == null) {
            return Rect.empty;
        }
        let h = g[0];
        let i = g[1];
        let j = Math.abs(b.x - h[0]);
        let k = Math.abs(b.x - i[0]);
        let l = this.o2.dz(this.o2.kn, f);
        let m = 1;
        if (j < k) {
            let n = h[0] - 0.5 * m;
            let o = h[1];
            let p = l;
            return new Rect(0, n, Math.min(o, p), m, Math.max(o, p) - Math.min(o, p));
        }
        else {
            let q = i[0] - 0.5 * m;
            let r = i[1];
            let s = l;
            return new Rect(0, q, Math.min(r, s), m, Math.max(r, s) - Math.min(r, s));
        }
    }
    dy(a, b) {
        let c = this.nt(this.nw(a), true, false);
        if (this.rs == 1) {
            if (this.rv(a, c, b)) {
                return true;
            }
        }
        if (this.rs == 1 || this.rs == 0) {
            if (this.dx(a, b)) {
                return true;
            }
        }
        if (this.rs == 2) {
            if (this.d1(a, b)) {
                return true;
            }
        }
        return false;
    }
    jo(a, b, c, d) {
        super.jo(a, b, c, d);
        if (this.oh != null && typeCast(ISortingAxis_$type, this.oh) !== null) {
            this.oh.i$i();
        }
        if (this.rr.b7) {
            this.rr.b5.g$e(a, b, c, d);
        }
        if (d != null && this.ps.containsKey(d)) {
            let e = this.ps.tryGetValue(d, d);
            d = e.p1;
        }
        if (this.oh != null && typeCast(ISortingAxis_$type, this.oh) !== null) {
            a = 4;
            b = 0;
            c = this.cd.count;
        }
        switch (a) {
            case 3:
                if (this.ru(b, c, d)) {
                    this.r5(b, c, d);
                    this.r3(true);
                }
                break;
            case 2:
                if (this.ru(b, this.cd.count - b, d)) {
                    this.r5(b, this.cd.count - b, d);
                    this.r3(true);
                }
                break;
            case 1:
                if (this.ru(b, this.cd.count - b, d)) {
                    let f = new Array(c);
                    for (let g = 0; g < c; g++) {
                        f[g] = 0;
                    }
                    this.indicatorColumn.s(b, f);
                    this.r5(b, this.cd.count - b, d);
                    this.r3(true);
                }
                break;
            case 0:
                if (this.ru(b, this.cd.count - b, d)) {
                    this.indicatorColumn.v(b, c);
                    this.r5(b, this.cd.count - b, d);
                    this.r3(true);
                }
                break;
            case 4:
                if (this.ru(b, this.cd.count - b, d)) {
                    this.indicatorColumn = new List$1(Number_$type, 2, this.cd.count);
                    let h = new Array(c);
                    for (let i = 0; i < c; i++) {
                        h[i] = 0;
                    }
                    this.indicatorColumn.s(0, h);
                    this.r5(b, this.cd.count - b, d);
                    this.r3(true);
                }
                break;
        }
    }
    get sg() {
        return this.c(FinancialIndicator.r6);
    }
    set sg(a) {
        this.h(FinancialIndicator.r6, a);
    }
    r0() {
        return -1;
    }
    get indicatorColumn() {
        return this._indicatorColumn;
    }
    set indicatorColumn(a) {
        this._indicatorColumn = a;
    }
    kp(a, b, c, d) {
        switch (b) {
            case "XAxis":
                this.rr.cd();
                break;
            case "TrendLineType":
                let e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.rr.b5 = CategoryTrendLineManagerFactory.a(this.rr.b5, this.oh, this.ls, this, this.cg);
                }
                break;
        }
        super.kp(a, b, c, d);
        if (this.rr.b7 && this.rr.b5.g$b(a, b, c, d)) {
            this.k3(false);
            let f = typeCast(FinancialIndicatorView.$, this.br);
            if (f != null && f.b7) {
                f.b5.g$b(a, b, c, d);
            }
            this.ka();
        }
        switch (b) {
            case "FastItemsSource":
                if (this.cd != null) {
                    this.indicatorColumn = new List$1(Number_$type, 2, this.cd.count);
                    let g = new Array(this.cd.count);
                    for (let h = 0; h < this.cd.count; h++) {
                        g[h] = 0;
                    }
                    this.indicatorColumn.s(0, g);
                    this.r5(0, this.cd.count, null);
                    if (this.o2 != null && !this.o2.cn()) {
                        this.ox.bx.e(this.fq);
                        this.k3(false);
                    }
                }
                break;
            case "TrendLineBrush":
                this.lg();
                break;
            case FinancialIndicator.$$p[0]:
                this.jl(true, this.bs);
                this.k3(false);
                this.ka();
                break;
            case "OpenColumn":
            case "HighColumn":
            case "LowColumn":
            case "CloseColumn":
            case "VolumeColumn":
                if (this.cd != null) {
                    if (this.indicatorColumn.count != this.cd.count) {
                        this.indicatorColumn = new List$1(Number_$type, 2, this.cd.count);
                        let i = new Array(this.cd.count);
                        for (let j = 0; j < this.cd.count; j++) {
                            i[j] = 0;
                        }
                        this.indicatorColumn.s(0, i);
                    }
                    if (this.ru(0, this.cd.count - 1, b)) {
                        this.r4();
                    }
                }
                break;
            case "XAxis":
                if (this.oh != null && (typeCast(ISortingAxis_$type, this.oh) !== null || typeCast(ISortingAxis_$type, c) !== null)) {
                    this.r4();
                }
                break;
            case "YAxis":
            case FinancialIndicator.$$p[1]:
                this.r4();
                this.ka();
                break;
            case "TrendLineType":
                this.ka();
                break;
        }
    }
    fh(a, b, c) {
        if (this.indicatorColumn == null) {
            return super.fh(a, b, c);
        }
        let d = this.getEffectiveViewport1(this.bs);
        let e = this.p7(this.bs.bv, this.bs.bu, d);
        let f = new ScalerParams(0, this.bs.bv, this.bs.bu, this.oh.ca, d);
        f.c = this.b6.o7;
        return this.fj(this.indicatorColumn, a, this.oh, f, e, runOn(this, this.p6), b, c);
    }
    gf(a, b) {
        if (this.indicatorColumn == null) {
            return super.gf(a, b);
        }
        return this.gg(a, b, this.oh, runOn(this, this.p6), this.indicatorColumn);
    }
    gd(a, b) {
        if (this.indicatorColumn == null) {
            return super.gd(a, b);
        }
        return this.ge(a, b, this.oh, runOn(this, this.p6), this.indicatorColumn);
    }
    get_eb() {
        return true;
    }
    ru(a, b, c) {
        if (c == null) {
            return true;
        }
        if (this.rw(a, b).contains(c)) {
            return true;
        }
        return false;
    }
    r5(a, b, c) {
        this.rt(a, b);
    }
    ao(a) {
        if (this.cd == null) {
            return null;
        }
        if (a != null && a == this.o2) {
            return this.rq;
        }
        return null;
    }
    dq(a) {
        let b = this.cd != null ? this.cd.indexOf(a) : -1;
        let c = this.bs.bv;
        c = c.copy();
        let d = this.bs.bu;
        let e = new Rect(0, 0, 0, 1, 1);
        let f = this.n0(this.bs);
        if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            if (this.oh != null) {
                let g = new ScalerParams(0, e, e, this.oh.ca, f);
                let h = this.oh.dz(b, g);
                if (h < c.left + 0.1 * c.width) {
                    h = h + 0.4 * c.width;
                }
                if (h > c.right - 0.1 * c.width) {
                    h = h - 0.4 * c.width;
                }
                c.x = h - 0.5 * c.width;
            }
            if (this.o2 != null && this.indicatorColumn != null && b < this.indicatorColumn.count) {
                let i = new ScalerParams(0, e, e, this.o2.ca, f);
                i.b = this.fa();
                let j = this.o2.dz(this.indicatorColumn._inner[b], i);
                if (j < c.top + 0.1 * c.height) {
                    j = j + 0.4 * c.height;
                }
                if (j > c.bottom - 0.1 * c.height) {
                    j = j - 0.4 * c.height;
                }
                c.y = j - 0.5 * c.height;
            }
            this.b1.ap(this.b6, c, true);
        }
        return b >= 0;
    }
    ec(a, b, c) {
        let d = super.ec(a, b, c);
        if (this.indicatorColumn == null || this.indicatorColumn.count == 0) {
            d = false;
        }
        return d;
    }
    q7(a, b) {
        super.q7(a, b);
        let c = b.bv;
        let d = b.bu;
        let e = this.getEffectiveViewport1(b);
        let f = this.oh;
        let g = this.o2;
        let h = new ScalerParams(0, c, d, f.ca, e);
        let i = new ScalerParams(0, c, d, g.ca, e);
        i.b = this.fa();
        a.f.clear();
        a.m.clear();
        a.p.clear();
        let j = 0;
        let k = typeCast(ISortingAxis_$type, this.oh);
        if (k != null && k.i$b.count != this.cd.count) {
            return;
        }
        j = this.p7(c, d, e);
        let l = this.r0();
        if (l == -1) {
            l = this.trendLinePeriod;
        }
        let m = typeCast(FinancialIndicatorView.$, b);
        if (m.b7) {
            m.b5.prepareLineCore(a.p, this.trendLineType, this.indicatorColumn, l, (n) => this.oh.dz(n, h), (n) => this.o2.dz(n, i), ((() => {
                let $ret = new TrendResolutionParams();
                $ret.c = b.bx.b;
                $ret.d = b.bx.c;
                $ret.e = b.bx.d;
                $ret.a = j;
                $ret.b = this.fq;
                $ret.f = d;
                $ret.g = c;
                return $ret;
            })()));
        }
        let n = this.oh.d2(2, h) - this.oh.d2(1, h);
        for (let o = b.bx.c; o <= b.bx.d; ++o) {
            let p;
            if (k == null) {
                p = b.bx.getBucket(o);
            }
            else {
                let q = k.i$b._inner[o];
                let r = k.i$d(q);
                let s = this.indicatorColumn._inner[o];
                let t = s;
                let u = r;
                while (o < b.bx.d) {
                    q = k.i$b._inner[o + 1];
                    u = k.i$d(q);
                    if (u - r > n) {
                        break;
                    }
                    o++;
                    let v = this.indicatorColumn._inner[o];
                    s = Math.min(s, v);
                    t = Math.max(t, v);
                }
                let w = NaN;
                if (!isNaN_(r)) {
                    w = this.oh.dz(r, h);
                }
                p = [w, s, t];
            }
            if (!isNaN_(p[0])) {
                if (this.oh != null && typeCast(ISortingAxis_$type, this.oh) !== null) {
                    p[0] = p[0] + j;
                }
                else {
                    p[0] = f.dz(p[0], h) + j;
                }
                p[1] = g.dz(p[1], i);
                if (b.bx.b > 1 || k != null) {
                    p[2] = g.dz(p[2], i);
                }
                else {
                    p[2] = p[1];
                }
                a.f.add(p);
            }
        }
        return;
    }
    jl(a, b) {
        super.jl(a, b);
        let c = b;
        c.b8(a);
        if (c.b7) {
            c.b5.g$d();
        }
    }
    oq() {
        switch (this.rs) {
            case 1: return 1;
            case 2: return 1;
            case 0: return 12;
        }
        return 1;
    }
    q9(a, b) {
        super.q9(a, b);
        let c = typeCast(FinancialIndicatorView.$, b);
        let d = (e) => a.f._inner[e][0];
        let e = (f) => a.f._inner[f][1];
        if (c.b7) {
            c.b5.g$d();
            c.b5.g$g(a.p);
        }
        let f = b.bu;
        let g = this.getEffectiveViewport1(b);
        let h = 0;
        let i = this.m9;
        let j = this.rm;
        if (b.b0(a)) {
            c.b8(false);
            if (a.f.count > 0) {
                switch (this.rs) {
                    case 0:
                        let k = CategorySeries.pp(a.f, a.f.count - 1, f, b.bv, false);
                        c.cc(a.f.count, d, e, true, k);
                        break;
                    case 1:
                        if (this.o2 != null) {
                            h = this.qb(b);
                        }
                        else {
                            h = 0.5 * (f.top + f.bottom);
                        }
                        let l = CategorySeries.pp(a.f, a.f.count - 1, f, b.bv, false);
                        c.ca(a.f.count, d, e, true, h, l);
                        break;
                    case 2:
                        h = this.qb(b);
                        c.cb(a.f.count, d, e, true, h);
                        break;
                    default: throw new NotImplementedException(0);
                }
            }
            b.b2(a);
        }
        let m = a.f;
        let n = this.cd.count;
        this.op.a0(this, this.po(), runOn(this, this.n9), this.qd(b), this.qf(b));
        let o = false;
        let p = this.op.b;
        if (p != null) {
            o = true;
        }
        this.op.ak = i;
        this.op.ag = i;
        if (o) {
            let q = new ScalerParams(0, b.bv, b.bu, this.oh.ca, g);
            this.op.f = false;
            this.q6(m, -1, n, this.oh, q, b.q);
        }
        this.op.ad(c.cu, true, false, true, false);
        this.op.ad(c.cw, true, false, true, false);
        this.op.ad(c.cv, false, true, false, false);
        c.cv._opacity = 0.8 * this.op.j * this.er;
        this.op.ad(c.ct, true, false, false, false);
        this.op.ak = j;
        this.op.ag = j;
        if (o) {
            let r = new ScalerParams(0, b.bv, b.bu, this.oh.ca, g);
            this.op.f = true;
            this.q6(m, -1, n, this.oh, r, b.q);
        }
        this.op.ad(c.cq, true, false, true, false);
        this.op.ad(c.cs, true, false, true, false);
        this.op.ad(c.cr, false, true, false, false);
        c.cr._opacity = 0.8 * this.op.j * this.er;
        this.op.ad(c.cp, true, false, false, false);
        c.ce();
    }
    lg() {
        super.lg();
        if (this.gi < 0) {
            return;
        }
        if (this.rr.b7) {
            this.rr.cf();
        }
    }
    r4() {
        if (this.rr.b7) {
            this.rr.b5.g$i();
        }
        this.rt(0, this.indicatorColumn.count);
        if (this.o2 != null && !this.o2.cn()) {
            this.k3(false);
        }
    }
    jv(a) {
        super.jv(a);
        this.a5.exportTrendlineData(this, a, this.rr.b5.g$j);
    }
}
FinancialIndicator.$t = markType(FinancialIndicator, 'FinancialIndicator', FinancialSeries.$, [ITrendLineSeries_$type]);
FinancialIndicator.r6 = DependencyProperty.i("ActualTrendLineBrush", Brush.$, FinancialIndicator.$, new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
FinancialIndicator.$$p = markDep(DependencyProperty, PropertyMetadata, FinancialIndicator, 'raisePropertyChanged', ['DisplayType:rs:r7', [IndicatorDisplayType_$type, enumGetBox(IndicatorDisplayType_$type, 0)], 'IgnoreFirst:ry:r8', [1, 0], 'TrendLineType::se', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::sd', [1, 1.5], 'TrendLinePeriod::sc', [1, 7], 'TrendLineBrush::r9', [Brush.$, null], 'TrendLineZIndex:rz:sf', [1, 1001], 'TrendLineDashArray:sh:sa', [DoubleCollection.$], 'TrendLineDashCap:si:sb', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
/**
 * @hidden
 */
export class FinancialIndicatorBucketCalculator extends FinancialBucketCalculator {
    constructor(a) {
        super(a);
        this.f = null;
        this.f = a;
    }
    getBucket(a) {
        let b = a * this.b;
        let c = Math.min(b + this.b - 1, this.f.b3.indicatorColumn.count - 1);
        let d = NaN;
        let e = NaN;
        for (let f = b; f <= c; ++f) {
            let g = this.f.b3.indicatorColumn._inner[f];
            if (!isNaN_(d)) {
                if (!isNaN_(g)) {
                    d = Math.min(d, g);
                    e = Math.max(e, g);
                }
            }
            else {
                d = g;
                e = g;
            }
        }
        if (!isNaN_(d)) {
            return [0.5 * (b + c), d, e];
        }
        return [NaN, NaN, NaN];
    }
}
FinancialIndicatorBucketCalculator.$t = markType(FinancialIndicatorBucketCalculator, 'FinancialIndicatorBucketCalculator', FinancialBucketCalculator.$);
/**
 * @hidden
 */
export class FinancialIndicatorView extends FinancialSeriesView {
    constructor(a) {
        super(a);
        this.b3 = null;
        this.b6 = null;
        this.cu = ((() => {
            let $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        this.cq = ((() => {
            let $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        this.cv = ((() => {
            let $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        this.cr = ((() => {
            let $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        this.cw = ((() => {
            let $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        this.cs = ((() => {
            let $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        this.ct = ((() => {
            let $ret = new Path();
            $ret.ak = new GeometryGroup();
            return $ret;
        })());
        this.cp = ((() => {
            let $ret = new Path();
            $ret.ak = new GeometryGroup();
            return $ret;
        })());
        this.b4 = null;
        this.cm = new Path();
        this.co = new Path();
        this.cn = new Path();
        this.cl = new Path();
        this.ci = new Path();
        this.ck = new Path();
        this.cj = new Path();
        this.ch = new Path();
        this.b3 = a;
        this.b6 = ((() => {
            let $ret = new Pool$1(LineGeometry.$);
            $ret.create = runOn(this, this.cg);
            $ret.destroy = runOn(this, this.b9);
            return $ret;
        })());
    }
    by() {
        return new FinancialIndicatorBucketCalculator(this);
    }
    as() {
        super.as();
        if (!this.q) {
            this.bz.rm = ((() => {
                let $ret = new Brush();
                $ret.fill = "#ee5879";
                return $ret;
            })());
        }
    }
    cg() {
        return new LineGeometry();
    }
    b9(a) {
    }
    get b5() {
        if (this.b4 == null) {
            this.b4 = CategoryTrendLineManagerFactory.a(this.b4, this.e.aq(), this.e.ls, this.e, this.e.cg);
        }
        return this.b4;
    }
    set b5(a) {
        this.b4 = a;
    }
    get b7() {
        return this.b4 != null;
    }
    b8(a) {
        Extensions.e(this.cu.ak);
        Extensions.e(this.cv.ak);
        Extensions.e(this.cw.ak);
        Extensions.e(this.cq.ak);
        Extensions.e(this.cr.ak);
        Extensions.e(this.cs.ak);
        Extensions.d(this.ct.ak);
        Extensions.d(this.cp.ak);
        if (a) {
            this.b6.count = 0;
        }
        this.aq();
    }
    ce() {
    }
    cc(a, b, c, d, e) {
        IndicatorRenderer.g(a, b, c, d, this.bv, this.bu, this.cu, this.cq, this.bx.b, this.e.fq, e);
        this.aq();
    }
    ca(a, b, c, d, e, f) {
        IndicatorRenderer.e(a, b, c, d, this.bv, this.bu, this.cu, this.cv, this.cq, this.cr, e, this.bx.b, this.e.fq, f);
        this.aq();
    }
    cb(a, b, c, d, e) {
        IndicatorRenderer.f(a, b, c, d, this.bu, e, this.b6, this.ct, this.cp);
        this.aq();
    }
    cf() {
        this.b3.sg = null;
        if (this.b3.trendLineBrush != null) {
            this.b3.sg = this.b3.trendLineBrush;
        }
        else {
            this.b3.sg = this.b3.m9;
        }
    }
    bc() {
        super.bc();
        let a = this.bo();
        this.cm.ak = this.cu.ak;
        this.co.ak = this.cw.ak;
        this.cn.ak = this.cv.ak;
        this.cl.ak = this.ct.ak;
        this.ci.ak = this.cq.ak;
        this.ck.ak = this.cs.ak;
        this.cj.ak = this.cr.ak;
        this.ch.ak = this.cp.ak;
        this.cm._stroke = a;
        this.co._stroke = a;
        this.cm.ac = this.e.eu + 3;
        this.co.ac = this.e.eu + 3;
        this.cn._fill = a;
        this.cn._opacity = 1;
        this.cl._stroke = a;
        this.cl.ac = this.e.eu + 3;
        this.ci._stroke = a;
        this.ck._stroke = a;
        this.ci.ac = this.e.eu + 3;
        this.ck.ac = this.e.eu + 3;
        this.cj._fill = a;
        this.cj._opacity = 1;
        this.ch._stroke = a;
        this.ch.ac = this.e.eu + 3;
    }
    a6(a, b) {
        super.a6(a, b);
        if (a.d) {
            if (b) {
                if (this.b3.rs == 2) {
                    a.s(this.cl);
                    a.s(this.ch);
                }
                else {
                    a.s(this.cn);
                    a.s(this.cm);
                    a.s(this.co);
                    a.s(this.cj);
                    a.s(this.ci);
                    a.s(this.ck);
                }
            }
            else {
                if (this.b3.rs == 2) {
                    a.s(this.ct);
                    a.s(this.cp);
                }
                else {
                    a.s(this.cv);
                    a.s(this.cu);
                    a.s(this.cw);
                    a.s(this.cr);
                    a.s(this.cq);
                    a.s(this.cs);
                }
            }
        }
    }
    a5(a, b) {
        if (a.d) {
            if (this.b3.trendLineType != 0 && !b) {
                let c = this.b5.g$j;
                c.ac = this.b3.trendLineThickness;
                c._stroke = this.b3.sg;
                c.ad = this.b3.si;
                c.ai = this.b3.sh;
                a.u(c);
            }
        }
        super.a5(a, b);
    }
    al(a) {
        super.al(a);
        this.e.a5.exportPathData(a, this.ct, "positiveColumnsShape", ["Positive", "Main"]);
        this.e.a5.exportPathData(a, this.cp, "negativeColumnsShape", ["Negative"]);
        this.e.a5.exportPathData(a, this.cu, "positive0", ["Positive", "Main"]);
        this.e.a5.exportPathData(a, this.cw, "positive1", ["Positive"]);
        this.e.a5.exportPathData(a, this.cv, "positive01", ["PositiveFill"]);
        this.e.a5.exportPathData(a, this.cq, "negative0", ["Negative", "Main"]);
        this.e.a5.exportPathData(a, this.cs, "negative1", ["Negative"]);
        this.e.a5.exportPathData(a, this.cr, "negative01", ["NegativeFill"]);
    }
    cd() {
        if (this.b7) {
            this.b4 = CategoryTrendLineManagerFactory.a(this.b4, this.e.aq(), this.e.ls, this.e, this.e.cg);
        }
    }
}
FinancialIndicatorView.$t = markType(FinancialIndicatorView, 'FinancialIndicatorView', FinancialSeriesView.$);
//# sourceMappingURL=FinancialIndicator_combined.js.map