/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { FullStochasticOscillatorIndicatorStrategy } from "./FullStochasticOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
/**
 * @hidden
 */
export class FullStochasticOscillatorIndicator extends StrategyBasedIndicator {
    constructor() {
        super();
        this.trendLineBrush = ((() => {
            let $ret = new Brush();
            $ret.fill = "#565656";
            return $ret;
        })());
        this.trendLineType = 10;
        this.trendLinePeriod = 3;
    }
    get_sk() {
        return new FullStochasticOscillatorIndicatorStrategy();
    }
    get sk() {
        return this.get_sk();
    }
    get_sx() {
        return FullStochasticOscillatorIndicator.$;
    }
    get sx() {
        return this.get_sx();
    }
    get s5() {
        return typeGetValue(this.c(FullStochasticOscillatorIndicator.ta));
    }
    set s5(a) {
        this.h(FullStochasticOscillatorIndicator.ta, a);
    }
    sq() {
        return this.s5;
    }
    sz(a) {
        this.s5 = a;
    }
    get smoothingPeriod() {
        return typeGetValue(this.c(FullStochasticOscillatorIndicator.tb));
    }
    set smoothingPeriod(a) {
        this.h(FullStochasticOscillatorIndicator.tb, a);
    }
    ss() {
        return this.smoothingPeriod;
    }
    get s7() {
        return typeGetValue(this.c(FullStochasticOscillatorIndicator.tc));
    }
    set s7(a) {
        this.h(FullStochasticOscillatorIndicator.tc, a);
    }
    sp() {
        return this.s7;
    }
    r0() {
        return this.s7;
    }
}
FullStochasticOscillatorIndicator.$t = markType(FullStochasticOscillatorIndicator, 'FullStochasticOscillatorIndicator', StrategyBasedIndicator.$);
FullStochasticOscillatorIndicator.ta = StrategyBasedIndicator.s2(14, FullStochasticOscillatorIndicator.$);
FullStochasticOscillatorIndicator.tb = StrategyBasedIndicator.s3(3, FullStochasticOscillatorIndicator.$, "SmoothingPeriod");
FullStochasticOscillatorIndicator.tc = StrategyBasedIndicator.s3(3, FullStochasticOscillatorIndicator.$, "TriggerPeriod");
//# sourceMappingURL=FullStochasticOscillatorIndicator.js.map