/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ScatterBase } from "./ScatterBase";
import { DependencyProperty } from "igniteui-angular-core";
import { Point_$type, typeCast, runOn, markType, markDep } from "igniteui-angular-core";
import { ScatterFrame } from "./ScatterFrame";
import { ScatterSplineSeriesView } from "./ScatterSplineSeriesView";
import { Clipper } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { OwnedPoint } from "./OwnedPoint";
import { PathGeometry } from "igniteui-angular-core";
import { Numeric } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
/**
 * @hidden
 */
export class ScatterSplineSeries extends ScatterBase {
    constructor() {
        super();
        this.ab = ScatterSplineSeries.$;
        this.p8 = new ScatterFrame();
        this.qa = new ScatterFrame();
        this.p7 = new ScatterFrame();
    }
    bp() {
        return new ScatterSplineSeriesView(this);
    }
    kp(a, b, c, d) {
        super.kp(a, b, c, d);
        switch (b) {
            case ScatterSplineSeries.$$p[0]:
                this.k3(false);
                this.ka();
                break;
        }
    }
    bj() {
        if (this.bk == 0) {
            return 2;
        }
        else {
            return super.bj();
        }
    }
    ru(a, b) {
        super.ru(a, b);
        a.m.clear();
        a.u.clear();
        let c = b.bv;
        let d = b.bu;
        let e = this.getEffectiveViewport1(b);
        let f = this.fq * this.fq;
        let g = Math.min(this.qi != null ? this.qi.count : 0, this.qj != null ? this.qj.count : 0);
        let h = new ScalerParams(0, c, d, this.p3.d, e);
        let i = ((() => {
            let $ret = new ScalerParams(0, c, d, this.p3.e, e);
            $ret.b = this.fa();
            return $ret;
        })());
        let j = (k) => this.p3.a.dz(this.qi.item(k), h);
        let k = (l) => this.p3.b.dz(this.qj.item(l), i);
        let l = ((() => {
            let $ret = new Clipper(0, d, false);
            $ret.i = a.m;
            return $ret;
        })());
        for (let m = 0; m < g;) {
            let n = m;
            ++m;
            while (m < g && this.sv(j, k, n, m) < f) {
                ++m;
            }
            if (g > this.q3) {
                l.j(this.sz(j, k, n, m - 1));
            }
            else {
                let o = new OwnedPoint();
                o.c = { $type: Point_$type, x: j(n), y: k(n) };
                o.a = this.cd.item(n);
                if (!a.u.containsKey(o.a)) {
                    a.u.addItem(o.a, o);
                }
            }
        }
        if (g > this.q3) {
            l.i = null;
        }
    }
    sz(a, b, c, d) {
        if (c == d) {
            return { $type: Point_$type, x: a(c), y: b(c) };
        }
        let e = 0;
        let f = 0;
        let g = (d - c + 1);
        for (let h = c; h <= d; ++h) {
            e += a(h);
            f += b(h);
        }
        return { $type: Point_$type, x: e / g, y: f / g };
    }
    sv(a, b, c, d) {
        let e = a(d) - a(c);
        let f = b(d) - b(c);
        return e * e + f * f;
    }
    get_qq() {
        return true;
    }
    jl(a, b) {
        super.jl(a, b);
        let c = typeCast(ScatterSplineSeriesView.$, b);
        c.c4(false);
    }
    r5(a, b) {
        this.jl(false, b);
        super.r5(a, b);
        this.rx(a);
        let c = typeCast(ScatterSplineSeriesView.$, b);
        let d = c.dg;
        this.qf.ax(this, this.qv(), runOn(this, this.pr));
        let e = false;
        let f = this.qf.b;
        if (f != null) {
            e = true;
        }
        if (e) {
            this.rq(-1, this.qi.count, b.q);
        }
        this.qf.ad(d, true, false, true, false);
        c.dg.ak = new PathGeometry();
        c.dg.ak.c = Numeric.h(a.m.count, (g) => a.m._inner[g].x, (g) => a.m._inner[g].y, this.sw);
    }
}
ScatterSplineSeries.$t = markType(ScatterSplineSeries, 'ScatterSplineSeries', ScatterBase.$);
ScatterSplineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterSplineSeries, 'raisePropertyChanged', ['Stiffness:sw:sy', [1, 0.5]]);
//# sourceMappingURL=ScatterSplineSeries.js.map