import { forwardRef } from '@angular/core';
import { IgxHorizontalAnchoredCategorySeriesComponent } from "./igx-horizontal-anchored-category-series-component";
import { IgxAnchoredCategorySeriesComponent } from "./igx-anchored-category-series-component";
import { IgxCategorySeriesComponent } from "./igx-category-series-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { toPoint, fromPoint } from "igniteui-angular-core";
/**
 * Represents one part of a stacked series.
*/
export const IgxFragmentBaseComponent_PROVIDERS = [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxFragmentBaseComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxFragmentBaseComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxFragmentBaseComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxFragmentBaseComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxFragmentBaseComponent) }];
export class IgxFragmentBaseComponent extends IgxHorizontalAnchoredCategorySeriesComponent {
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Gets whether the current series is a stack fragment.
    */
    get isFragment() {
        return this.i.c7;
    }
    getSeriesValuePosition(world, useInterpolation, skipUnknowns) {
        let iv = this.i.nt(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    }
}
//# sourceMappingURL=igx-fragment-base-component.js.map