var IgxTreemapNodeStyleMappingComponent_1;
import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { TreemapNodeStyleMappingTargetType, TreemapNodeStyleMappingTargetType_$type } from "./TreemapNodeStyleMappingTargetType";
import { TreemapValueMappingMode, TreemapValueMappingMode_$type } from "./TreemapValueMappingMode";
import { IgxTreemapNodeStyleComponent } from "./igx-treemap-node-style-component";
import { TreemapNodeStyleMapping } from "./TreemapNodeStyleMapping";
import { ensureEnum } from "igniteui-angular-core";
/**
 * Represents a style to apply to a set of nodes in the treemap.
*/
export const IgxTreemapNodeStyleMappingComponent_PROVIDERS = [{ provide: IgxTreemapNodeStyleComponent, useExisting: forwardRef(() => IgxTreemapNodeStyleMappingComponent) }];
let IgxTreemapNodeStyleMappingComponent = IgxTreemapNodeStyleMappingComponent_1 = class IgxTreemapNodeStyleMappingComponent extends IgxTreemapNodeStyleComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new TreemapNodeStyleMapping();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the unique name of the mapping.
    */
    get targetType() {
        return this.i.bf;
    }
    set targetType(v) {
        this.i.bf = ensureEnum(TreemapNodeStyleMappingTargetType_$type, v);
    }
    /**
     * Gets or sets the unique name of the mapping.
    */
    get name() {
        return this.i.bs;
    }
    set name(v) {
        this.i.bs = v;
    }
    /**
     * Gets or sets the minimum value to which the mapping applies.
    */
    get minimumValue() {
        return this.i.bl;
    }
    set minimumValue(v) {
        this.i.bl = +v;
    }
    /**
     * Gets or sets the maximum value to which the mapping applies.
    */
    get maximumValue() {
        return this.i.bk;
    }
    set maximumValue(v) {
        this.i.bk = +v;
    }
    /**
     * Gets or sets the value to which the mapping applies.
    */
    get value() {
        return this.i.bn;
    }
    set value(v) {
        this.i.bn = v;
    }
    /**
     * Gets or sets the mapping mode to use to evaluate whether the mapping applies.
    */
    get mappingMode() {
        return this.i.bh;
    }
    set mappingMode(v) {
        this.i.bh = ensureEnum(TreemapValueMappingMode_$type, v);
    }
};
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxTreemapNodeStyleMappingComponent.prototype, "targetType", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", String),
    tslib_1.__metadata("design:paramtypes", [String])
], IgxTreemapNodeStyleMappingComponent.prototype, "name", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxTreemapNodeStyleMappingComponent.prototype, "minimumValue", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxTreemapNodeStyleMappingComponent.prototype, "maximumValue", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Object),
    tslib_1.__metadata("design:paramtypes", [Object])
], IgxTreemapNodeStyleMappingComponent.prototype, "value", null);
tslib_1.__decorate([
    Input(),
    tslib_1.__metadata("design:type", Number),
    tslib_1.__metadata("design:paramtypes", [Number])
], IgxTreemapNodeStyleMappingComponent.prototype, "mappingMode", null);
IgxTreemapNodeStyleMappingComponent = IgxTreemapNodeStyleMappingComponent_1 = tslib_1.__decorate([
    Component({
        selector: 'igx-treemap-node-style-mapping',
        template: ``,
        providers: [{ provide: IgxTreemapNodeStyleComponent, useExisting: forwardRef(() => IgxTreemapNodeStyleMappingComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    tslib_1.__metadata("design:paramtypes", [])
], IgxTreemapNodeStyleMappingComponent);
export { IgxTreemapNodeStyleMappingComponent };
//# sourceMappingURL=igx-treemap-node-style-mapping-component.js.map