/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { RadialBucketCalculator } from "./RadialBucketCalculator";
import { markType, Point_$type, enumGetBox, typeCast, runOn, markDep } from "igniteui-angular-core";
import { isNaN_, intDivide, isInfinity } from "igniteui-angular-core";
import { RadialBase } from "./RadialBase";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { DependencyProperty } from "igniteui-angular-core";
import { TrendLineType_$type } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap_$type } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { RadialFrame } from "./RadialFrame";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { NumericAxisBase } from "./NumericAxisBase";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { RadialBaseView } from "./RadialBaseView";
import { CollisionAvoider } from "./CollisionAvoider";
import { Clipper } from "igniteui-angular-core";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { RadialTrendLineManager } from "./RadialTrendLineManager";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { PropertyMetadata } from "igniteui-angular-core";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
/**
 * @hidden
 */
var AnchoredRadialBucketCalculator = /** @class */ (function (_super) {
    tslib_1.__extends(AnchoredRadialBucketCalculator, _super);
    function AnchoredRadialBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.f = null;
        _this.f = a;
        return _this;
    }
    AnchoredRadialBucketCalculator.prototype.getBucket = function (a) {
        var b = this.f.cw.q9;
        var c = Math.min(a * this.b, b.count - 1);
        var d = Math.min(c + this.b - 1, b.count - 1);
        var e = NaN;
        var f = NaN;
        for (var g = c; g <= d; ++g) {
            var h = b.item(g);
            if (!isNaN_(e)) {
                if (!isNaN_(h)) {
                    e = Math.min(e, h);
                    f = Math.max(f, h);
                }
            }
            else {
                e = h;
                f = h;
            }
        }
        if (!isNaN_(e)) {
            return [0.5 * (c + d), e, f];
        }
        return [0.5 * (c + d), NaN, NaN];
    };
    AnchoredRadialBucketCalculator.$t = markType(AnchoredRadialBucketCalculator, 'AnchoredRadialBucketCalculator', RadialBucketCalculator.$);
    return AnchoredRadialBucketCalculator;
}(RadialBucketCalculator));
export { AnchoredRadialBucketCalculator };
/**
 * @hidden
 */
var AnchoredRadialSeries = /** @class */ (function (_super) {
    tslib_1.__extends(AnchoredRadialSeries, _super);
    function AnchoredRadialSeries() {
        var _this = _super.call(this) || this;
        _this.q4 = null;
        _this.q8 = null;
        _this.r5 = { $type: Point_$type, x: 0, y: 0 };
        _this.q6 = null;
        _this.q5 = null;
        _this.q6 = new RadialFrame(3);
        _this.q4 = new CategoryLineRasterizer();
        return _this;
    }
    AnchoredRadialSeries.prototype.bp = function () {
        return new AnchoredRadialSeriesView(this);
    };
    AnchoredRadialSeries.prototype.ji = function () {
        _super.prototype.ji.call(this);
        this.pr = null;
        this.py = null;
    };
    AnchoredRadialSeries.prototype.gt = function (a, b) {
        var c = this.ic(b);
        if (c == AnchoredRadialSeries.$$p[0]) {
            return this.gu(a, b, this.rl);
        }
        return _super.prototype.gt.call(this, a, b);
    };
    AnchoredRadialSeries.prototype.kk = function (a) {
        _super.prototype.kk.call(this, a);
        this.q3 = a;
    };
    AnchoredRadialSeries.prototype.gf = function (a, b) {
        return this.gg(a, b, this.pr, null, this.q9);
    };
    AnchoredRadialSeries.prototype.gd = function (a, b) {
        return this.ge(a, b, this.pr, null, this.q9);
    };
    AnchoredRadialSeries.prototype.e2 = function (a, b, c, d, e) {
        if (this.q9 == null) {
            return Number.POSITIVE_INFINITY;
        }
        return this.e3(a, b, this.pr, d, e, this.q9.count, null);
    };
    AnchoredRadialSeries.prototype.fh = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bs);
        var e = this.re(this.pr, this.bs.bv, this.bs.bu, d);
        var f = new ScalerParams(0, this.bs.bv, this.bs.bu, this.pr.ca, d);
        f.c = this.b6.o7;
        return this.fj(this.q9, a, this.pr, f, e, null, b, c);
    };
    AnchoredRadialSeries.prototype.nt = function (a, b, c) {
        if (this.py == null || this.pr == null || this.bs == null || this.bs.bv.isEmpty || this.bs.bu.isEmpty) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        var d = this.getEffectiveViewport1(this.bs);
        var e = new ScalerParams(0, this.bs.bv, this.bs.bu, this.py.ca, d);
        e.c = this.getEffectiveViewport1(this.bs);
        var f = this.fh(a, b, c);
        f = this.py.dz(f, e);
        var g = this.pz.c(a);
        if (!b && this.pr != null) {
            var h = this.gf(a, c);
            var i = this.gd(a, c);
            var j = this.re(this.pr, this.bs.bv, this.bs.bu, d);
            var k = new ScalerParams(0, this.bs.bv, this.bs.bu, this.pr.ca, d);
            k.c = this.b6.o7;
            var l = this.e2(a, h, this.pr, k, j);
            var m = this.e2(a, i, this.pr, k, j);
            if (m <= l) {
                g = this.pr.dz(i, k) + j;
            }
            else {
                g = this.pr.dz(h, k) + j;
            }
        }
        var n = this.pz.d(g, f, this.bs.bv, this.bs.bu);
        var o = this.pz.e(g, f, this.bs.bv, this.bs.bu);
        return { $type: Point_$type, x: n, y: o };
    };
    Object.defineProperty(AnchoredRadialSeries.prototype, "q9", {
        get: function () {
            return this.q8;
        },
        set: function (a) {
            if (this.q8 != a) {
                var b = this.q8;
                this.q8 = a;
                this.raisePropertyChanged("ValueColumn", b, this.q8);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AnchoredRadialSeries.prototype, "r1", {
        get: function () {
            return this.c(AnchoredRadialSeries.rs);
        },
        set: function (a) {
            this.h(AnchoredRadialSeries.rs, a);
        },
        enumerable: true,
        configurable: true
    });
    AnchoredRadialSeries.prototype.ao = function (a) {
        if (a != null && a == this.pr && this.q9 != null && this.q9.count > 0) {
            return new AxisRange(0, this.q9.count - 1);
        }
        if (a != null && a == this.py && this.q9 != null && this.q9.count > 0) {
            return new AxisRange(this.q9.minimum, this.q9.maximum);
        }
        return null;
    };
    AnchoredRadialSeries.prototype.kp = function (a, b, c, d) {
        _super.prototype.kp.call(this, a, b, c, d);
        if (this.q3.cx.g$b(a, b, c, d)) {
            this.k3(false);
            this.ka();
        }
        var e = typeCast(NumericAxisBase.$, this.py);
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) !== null) {
                    c.deregisterColumn(this.q9);
                    this.q9 = null;
                }
                if (typeCast(IFastItemsSource_$type, d) !== null) {
                    this.q9 = this.ca(this.rl);
                    this.q3.cs.e(this.fq);
                }
                if (e != null && !e.cn()) {
                    this.q3.cs.e(this.fq);
                    this.k3(false);
                }
                break;
            case AnchoredRadialSeries.$$p[0]:
                if (this.cd != null) {
                    this.cd.deregisterColumn(this.q9);
                    this.q9 = this.ca(this.rl);
                }
                break;
            case "ValueColumn":
                if (e != null && !e.cn()) {
                    this.q3.cs.e(this.fq);
                    this.k3(false);
                }
                break;
            case "TrendLineBrush":
                this.lg();
                break;
            case "TrendLineType":
                this.ka();
                break;
        }
    };
    AnchoredRadialSeries.prototype.jo = function (a, b, c, d) {
        switch (a) {
            case 4:
            case 1:
            case 0:
                this.q3.cs.e(this.fq);
                break;
        }
        this.q3.cx.g$e(a, b, c, d);
        switch (a) {
            case 4:
                if (this.py != null && !this.py.cn()) {
                    this.k3(true);
                }
                break;
            case 1:
                if (this.py != null && !this.py.cn()) {
                    this.k3(true);
                }
                break;
            case 0:
                if (this.py != null && !this.py.cn()) {
                    this.k3(true);
                }
                break;
            case 2:
                if (this.rl != null && this.q3.cs.b > 0 && this.py != null && !this.py.cn()) {
                    this.k3(true);
                }
                break;
            case 3:
                if (d == this.rl) {
                    if (this.py != null && !this.py.cn()) {
                        this.k3(true);
                    }
                }
                break;
        }
    };
    AnchoredRadialSeries.prototype.ec = function (a, b, c) {
        var d = _super.prototype.ec.call(this, a, b, c);
        var e = c;
        if (this.cd == null || this.cd.count == 0 || this.pr == null || this.q9 == null || this.pr.j8 == 0 || this.py == null || isInfinity(this.py.kd) || isInfinity(this.py.kc) || e.cs.b < 1) {
            d = false;
        }
        return d;
    };
    AnchoredRadialSeries.prototype.getOffsetValue = function () {
        return this.re(this.pr, this.bs.bv, this.bs.bu, this.getEffectiveViewport1(this.bs));
    };
    AnchoredRadialSeries.prototype.getCategoryWidth = function () {
        return this.pr.getCategorySize(this.bs.bv, this.bs.bu, this.getEffectiveViewport1(this.bs));
    };
    AnchoredRadialSeries.prototype.get_rc = function () {
        return false;
    };
    Object.defineProperty(AnchoredRadialSeries.prototype, "rc", {
        get: function () {
            return this.get_rc();
        },
        enumerable: true,
        configurable: true
    });
    AnchoredRadialSeries.prototype.re = function (a, b, c, d) {
        var e = 0;
        var f = this.preferredCategoryMode(a);
        if (f == 0 && a.categoryMode != 0) {
            f = 1;
        }
        switch (f) {
            case 0:
                e = 0;
                break;
            case 1:
                e = 0.5 * a.getCategorySize(b, c, d);
                break;
            case 2:
                e = a.getGroupCenter(this.qk(), b, c, d);
                break;
        }
        if (a.ca) {
            e = -e;
        }
        return e;
    };
    AnchoredRadialSeries.prototype.qs = function (a, b) {
        var _this = this;
        var c = b.bv;
        var d = b.bu;
        var e = this.getEffectiveViewport1(b);
        var f = this.pr;
        var g = this.py;
        var h = g.kd;
        var i = g.kc;
        a.f.clear();
        a.m.clear();
        a.p.clear();
        var j = this.ok();
        var k = 0;
        var l = b;
        var m = new CollisionAvoider();
        var n = 0;
        var o = b.cs.d;
        n = this.re(f, c, d, e);
        l.cx.i = this.py.ls;
        l.cx.h = this.py.lr;
        l.cx.j = function (p, q) { return _this.rf(p, q, c, d); };
        l.cx.k = function (p, q) { return _this.rg(p, q, c, d); };
        var p = ((function () {
            var $ret = new Clipper(0, d, false);
            $ret.i = a.p;
            return $ret;
        })());
        var q = ((function () {
            var $ret = new TrendResolutionParams();
            $ret.c = b.cs.b;
            $ret.d = b.cs.c;
            $ret.e = o;
            $ret.a = n;
            $ret.b = _this.fq;
            $ret.f = d;
            $ret.g = c;
            return $ret;
        })());
        l.cx.l(a.p, this.q7, this.q9, this.ri, function (r) { return _this.pr.getScaledAngle(r); }, function (r) { return _this.py.ly(r); }, q, p);
        var r = true;
        if (this.rd(b)) {
            o--;
        }
        for (var s = b.cs.c; s <= o; ++s) {
            var t = s;
            if (t * b.cs.b >= this.pr.j8) {
                t -= intDivide((this.pr.j8), b.cs.b);
            }
            var u = b.cs.getBucket(t);
            if (!isNaN_(u[0])) {
                u[0] = f.getScaledAngle(u[0]) + n;
                if (u[1] < h || u[1] > i) {
                    continue;
                }
                u[1] = g.ly(u[1]);
                if (b.cs.b > 1) {
                    if (u[2] < h || u[2] > i) {
                        continue;
                    }
                    u[2] = g.ly(u[2]);
                }
                else {
                    u[2] = u[1];
                }
                if ((isNaN_(u[1]) || isNaN_(u[2])) && r && this.rc && this.rb()) {
                    o++;
                }
                else {
                    r = false;
                }
                a.f.add(u);
                if (j) {
                    var v = Math.min(t * b.cs.b, this.cd.count - 1);
                    var w = this.pz.d(u[0], u[1], c, d);
                    var x = this.pz.e(u[0], u[1], c, d);
                    var y = new Rect(0, w - 5, x - 5, 11, 11);
                    if (!isNaN_(w) && !isNaN_(x) && !isInfinity(w) && !isInfinity(x) && m.tryAdd(y)) {
                        a.m.add({ $type: Point_$type, x: w, y: x });
                        var z = b.ct.item(k);
                        z.al = t;
                        z.ak = v;
                        z.content.item = this.cd.item(v);
                        ++k;
                    }
                }
            }
            else {
                if (r && this.rc && this.rb()) {
                    o++;
                }
            }
        }
        b.ct.count = k;
        return;
    };
    AnchoredRadialSeries.prototype.rf = function (a, b, c, d) {
        return this.pz.d(a, b, c, d);
    };
    AnchoredRadialSeries.prototype.rg = function (a, b, c, d) {
        return this.pz.e(a, b, c, d);
    };
    AnchoredRadialSeries.prototype.rd = function (a) {
        var b = a;
        return !this.rc && b.cs.c == 0 && b.cs.d == this.pr.j8;
    };
    AnchoredRadialSeries.prototype.q2 = function (a, b, c) {
        var d = null;
        var e = c.bv;
        var f = c.bu;
        if (b > -1 && !e.isEmpty && !f.isEmpty) {
            var g = a._inner[0][0] < f.left - 2000 ? f.left - 10 : NaN;
            var h = f.bottom + 10;
            var i = a._inner[b][0] > f.right + 2000 ? f.right + 10 : NaN;
            var j = f.top - 10;
            d = new Clipper(1, g, h, i, j, false);
        }
        return d;
    };
    AnchoredRadialSeries.prototype.rr = function (a, b, c, d, e) {
        if (a.count > 0 && d.count > 0) {
            if (!e || this.ra()) {
                a.add(this.r5);
                a.add(a._inner[0]);
                d.add(this.r5);
                d.add(d._inner[0]);
            }
        }
    };
    AnchoredRadialSeries.prototype.rb = function () {
        return !this.ra();
    };
    AnchoredRadialSeries.prototype.ra = function () {
        var a = this.bs.bv;
        return !a.containsPoint({ $type: Point_$type, x: 0.5, y: 0.5 });
    };
    AnchoredRadialSeries.prototype.jl = function (a, b) {
        _super.prototype.jl.call(this, a, b);
        var c = b;
        if (a) {
            c.ct.clear();
        }
        c.cx.g$d();
    };
    AnchoredRadialSeries.prototype.qv = function (a, b) {
        var c = b.bv;
        var d = b.bu;
        var e = this.getEffectiveViewport1(b);
        var f = this.ny(b);
        var g = b;
        g.cx.g$g(a.p);
        CategoryMarkerManager.e(this, a.m, g.ct, this.om);
        this.ro(b, a);
        g.cm();
        this.rn(d, c, e, f, g);
    };
    AnchoredRadialSeries.prototype.q1 = function (a, b, c) {
        if (b < a || a < 0 || a > this.q9.count || b < 0 || b > this.q9.count || c == null) {
            return null;
        }
        var d = new Array((b - a) + 1);
        var e = c.cf;
        var f = null;
        if (e) {
            f = c.i$b;
        }
        for (var g = a; g <= b; g++) {
            var h = g;
            if (e) {
                h = f._inner[h];
            }
            d[g - a] = this.cd.item(g);
        }
        return d;
    };
    AnchoredRadialSeries.prototype.rp = function (a, b, c, d, e, f) {
        var g = this.be != 1;
        this.p4.a1(this.p4.d, d.cf, a, b, c, d, e, f, true);
        this.p4.aa(this.es);
        var h = this.p4.av;
        var i = null;
        var j = this.cd;
        var k = null;
        if (g && this.b6 != null) {
            i = this.b6.az.getHighlightingInfo(this, j, h.o, h.n, true);
            if (this.b6.az.isCrossSeriesHighlight(this)) {
                k = this.b6.az.getHighlightingInfo(this, j, h.o, h.n, true);
            }
            h.b = i;
        }
        h.f = f;
        this.qt(h);
        this.p4.y(this, i, f, g, h.m, this.b6.az.totalHighlightingProgress);
    };
    AnchoredRadialSeries.prototype.rq = function (a, b, c, d, e, f) {
        var g = this.be != 1;
        this.p4.a1(this.p4.b, d.cf, a, b, c, d, e, f, false);
        this.p4.ab(this.es);
        var h = this.p4.aw;
        var i = null;
        var j = this.cd;
        if (g && this.b6 != null) {
            i = this.b6.az.getHighlightingInfo(this, j, h.o, h.n, false);
            h.b = i;
        }
        h.f = f;
        this.qu(h);
        this.p4.z(this, i, f, g, b < 0);
    };
    AnchoredRadialSeries.prototype.ro = function (a, b) {
        a.b3 = true;
        this.p4.az(this, this.qf(), runOn(this, this.po), this.qi(a), this.qj(a));
        var c = this.p4.d;
        var d = c != null;
        var e = this.pr;
        if (e == null) {
            return;
        }
        var f = this.getEffectiveViewport1(a);
        var g = new ScalerParams(0, a.bv, a.bu, e.ca, f);
        var h = this.cd == null ? 0 : this.cd.count;
        var i = a;
        var j = b.f;
        var k = i.cs.c;
        var l = i.cs.d;
        var m = i.cs.b;
        var n = k * m;
        for (var o = 0; o < a.ct.count; o++) {
            var p = a.ct.item(o);
            var q = p.content;
            if (d) {
                var r = p.al;
                this.rp(j, r, h, e, g, a.q);
            }
            this.p4.ac(p, q);
        }
    };
    AnchoredRadialSeries.prototype.rn = function (a, b, c, d, e) {
        e.cy(a, b, c, d);
    };
    AnchoredRadialSeries.prototype.lg = function () {
        _super.prototype.lg.call(this);
        if (this.gi < 0) {
            return;
        }
        this.q3.cz();
    };
    AnchoredRadialSeries.prototype.gw = function (a, b) {
        if (a == this.q3.cx.g$j) {
            return null;
        }
        return _super.prototype.gw.call(this, a, b);
    };
    AnchoredRadialSeries.prototype.dq = function (a) {
        var b = this.bs.bv;
        b = b.copy();
        var c = this.bs.bu;
        var d = !b.isEmpty && !c.isEmpty && this.cd != null ? this.cd.indexOf(a) : -1;
        if (this.pr == null || this.q9 == null || this.py == null) {
            return false;
        }
        if (d < 0 || d > this.q9.count - 1) {
            return false;
        }
        var e = this.pr.getScaledAngle(d);
        var f = this.py.ly(this.q9.item(d));
        if (isNaN_(f)) {
            f = (this.py.lr + this.py.ls) / 2;
        }
        var g = 0.5 + (Math.cos(e) * f);
        var h = 0.5 + (Math.sin(e) * f);
        if (!isNaN_(g)) {
            if (g < b.left + 0.1 * b.width) {
                g = g + 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
            if (g > b.right - 0.1 * b.width) {
                g = g - 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
        }
        if (!isNaN_(h)) {
            if (h < b.top + 0.1 * b.height) {
                h = h + 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
            if (h > b.bottom - 0.1 * b.height) {
                h = h - 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
        }
        if (this.b1 != null) {
            this.b1.ap(this.b6, b, true);
        }
        return d >= 0;
    };
    AnchoredRadialSeries.prototype.k5 = function (a, b) {
        _super.prototype.k5.call(this, a, b);
        if (!this.d2) {
            this.bs.a2(b);
            return;
        }
        this.bs.a2(b);
        var c = typeCast(AnchoredRadialSeriesView.$, this.br);
        c.cs.e(this.fq);
        if (this.cp(this.br)) {
            return;
        }
        if (!this.dw) {
            this.q6 = new RadialFrame(3);
            this.qs(this.q6, c);
        }
        this.dw = false;
        this.qv(this.q6, c);
        this.d2 = false;
    };
    AnchoredRadialSeries.prototype.k2 = function (a, b, c, d, e) {
        _super.prototype.k2.call(this, a, b, c, d, e);
        var f = this.a3.a$h.item(d);
        var g = f;
        g.cs.e(this.fq);
        f.a1(c);
        if (this.cp(g)) {
            return;
        }
        if (this.q5 == null) {
            this.q5 = new RadialFrame(3);
        }
        this.q5.u();
        this.qs(this.q5, g);
        this.qv(this.q5, g);
    };
    AnchoredRadialSeries.prototype.jv = function (a) {
        _super.prototype.jv.call(this, a);
        this.a5.exportTrendlineData(this, a, this.q3.cx.g$j);
    };
    AnchoredRadialSeries.$t = markType(AnchoredRadialSeries, 'AnchoredRadialSeries', RadialBase.$);
    AnchoredRadialSeries.rs = DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredRadialSeries.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    AnchoredRadialSeries.$$p = markDep(DependencyProperty, PropertyMetadata, AnchoredRadialSeries, 'raisePropertyChanged', ['ValueMemberPath:rl:r0', [2, null], 'TrendLineType:q7:ry', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness:rh:rx', [1, 1.5], 'TrendLinePeriod:ri:rw', [1, 7], 'TrendLineZIndex:rj:rz', [1, 1], 'TrendLineBrush:r2:rt', [Brush.$, null], 'TrendLineDashArray:r3:ru', [DoubleCollection.$], 'TrendLineDashCap:r4:rv', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return AnchoredRadialSeries;
}(RadialBase));
export { AnchoredRadialSeries };
/**
 * @hidden
 */
var AnchoredRadialSeriesView = /** @class */ (function (_super) {
    tslib_1.__extends(AnchoredRadialSeriesView, _super);
    function AnchoredRadialSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cw = null;
        _this.cx = null;
        _this.cs = new AnchoredRadialBucketCalculator(_this);
        _this.cw = a;
        _this.cx = new RadialTrendLineManager();
        return _this;
    }
    AnchoredRadialSeriesView.prototype.cy = function (a, b, c, d) {
    };
    AnchoredRadialSeriesView.prototype.cz = function () {
        this.cw.r1 = null;
        if (this.cw.r2 != null) {
            this.cw.r1 = this.cw.r2;
        }
        else {
            this.cw.r1 = this.cw.m9;
        }
    };
    AnchoredRadialSeriesView.prototype.a5 = function (a, b) {
        if (a.d) {
            if (!b) {
            }
            if (this.cw.q7 != 0 && !b) {
                var c = this.cx.g$j;
                c.ac = this.cw.rh;
                c._stroke = this.cw.r1;
                c.ai = this.cw.r3;
                c.ad = this.cw.r4;
                a.u(c);
            }
        }
        _super.prototype.a5.call(this, a, b);
    };
    AnchoredRadialSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'>";
        if (this.cw.pr.fa != null) {
            a += "<span>${item." + this.cw.pr.fa + "}</span><br/>";
        }
        a += "<span";
        var b = this.e.a3.a$r(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.cw.gy + ": </span><span class='ui-priority-primary'>" + "${item." + this.cw.rl + "}</span></div>";
        return a;
    };
    AnchoredRadialSeriesView.$t = markType(AnchoredRadialSeriesView, 'AnchoredRadialSeriesView', RadialBaseView.$);
    return AnchoredRadialSeriesView;
}(RadialBaseView));
export { AnchoredRadialSeriesView };
//# sourceMappingURL=AnchoredRadialBucketCalculator_combined.js.map