import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxVerticalAnchoredCategorySeriesComponent } from "./igx-vertical-anchored-category-series-component";
import { IgxAnchoredCategorySeriesComponent } from "./igx-anchored-category-series-component";
import { IgxCategorySeriesComponent } from "./igx-category-series-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { BarSeries } from "./BarSeries";
import { toPoint, fromRect } from "igniteui-angular-core";
/**
 * Represents a IgxDataChartComponent bar series.
*/
export var IgxBarSeriesComponent_PROVIDERS = [{ provide: IgxVerticalAnchoredCategorySeriesComponent, useExisting: forwardRef(function () { return IgxBarSeriesComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(function () { return IgxBarSeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(function () { return IgxBarSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxBarSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxBarSeriesComponent; }) }];
var IgxBarSeriesComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxBarSeriesComponent, _super);
    function IgxBarSeriesComponent() {
        return _super.call(this) || this;
    }
    IgxBarSeriesComponent_1 = IgxBarSeriesComponent;
    IgxBarSeriesComponent.prototype.createImplementation = function () {
        return new BarSeries();
    };
    Object.defineProperty(IgxBarSeriesComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxBarSeriesComponent.prototype, "radiusX", {
        /**
         * Gets or sets the x-radius of the ellipse that is used to round the corners of the bar.
        */
        get: function () {
            return this.i.sz;
        },
        set: function (v) {
            this.i.sz = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxBarSeriesComponent.prototype, "radiusY", {
        /**
         * Gets or sets the y-radius of the ellipse that is used to round the corners of the bar.
        */
        get: function () {
            return this.i.s0;
        },
        set: function (v) {
            this.i.s0 = +v;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinate for which to get a value bounding box for
    */
    IgxBarSeriesComponent.prototype.getSeriesValueBoundingBox = function (world) {
        var iv = this.i.n2(toPoint(world));
        return fromRect(iv);
    };
    /**
     * Scrolls the series to display the item for the specified data item.
     * The series is scrolled by the minimum amount required to place the specified data item within
     * the central 80% of the visible axis.
    
    * @param item  * The data item (item) to scroll to.
    */
    IgxBarSeriesComponent.prototype.scrollIntoView = function (item) {
        var iv = this.i.dq(item);
        return (iv);
    };
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    */
    IgxBarSeriesComponent.prototype.getItemSpan = function () {
        var iv = this.i.e9();
        return (iv);
    };
    var IgxBarSeriesComponent_1;
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxBarSeriesComponent.prototype, "radiusX", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxBarSeriesComponent.prototype, "radiusY", null);
    IgxBarSeriesComponent = IgxBarSeriesComponent_1 = tslib_1.__decorate([
        Component({
            selector: 'igx-bar-series',
            template: "",
            providers: [{ provide: IgxVerticalAnchoredCategorySeriesComponent, useExisting: forwardRef(function () { return IgxBarSeriesComponent_1; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(function () { return IgxBarSeriesComponent_1; }) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(function () { return IgxBarSeriesComponent_1; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxBarSeriesComponent_1; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxBarSeriesComponent_1; }) }],
            changeDetection: ChangeDetectionStrategy.OnPush
        }),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxBarSeriesComponent);
    return IgxBarSeriesComponent;
}(IgxVerticalAnchoredCategorySeriesComponent));
export { IgxBarSeriesComponent };
//# sourceMappingURL=igx-bar-series-component.js.map