import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxAnchoredRadialSeriesComponent } from "./igx-anchored-radial-series-component";
import { IgxRadialBaseComponent } from "./igx-radial-base-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { RadialPieSeries } from "./RadialPieSeries";
/**
 * Represents a IgxDataChartComponent radial pie series.
 * Compare values across categories by using radial pie slices.
*/
export var IgxRadialPieSeriesComponent_PROVIDERS = [{ provide: IgxAnchoredRadialSeriesComponent, useExisting: forwardRef(function () { return IgxRadialPieSeriesComponent; }) }, { provide: IgxRadialBaseComponent, useExisting: forwardRef(function () { return IgxRadialPieSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxRadialPieSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxRadialPieSeriesComponent; }) }];
var IgxRadialPieSeriesComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxRadialPieSeriesComponent, _super);
    function IgxRadialPieSeriesComponent() {
        return _super.call(this) || this;
    }
    IgxRadialPieSeriesComponent_1 = IgxRadialPieSeriesComponent;
    IgxRadialPieSeriesComponent.prototype.createImplementation = function () {
        return new RadialPieSeries();
    };
    Object.defineProperty(IgxRadialPieSeriesComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxRadialPieSeriesComponent.prototype, "radiusX", {
        /**
         * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
        */
        get: function () {
            return this.i.r7;
        },
        set: function (v) {
            this.i.r7 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxRadialPieSeriesComponent.prototype, "radiusY", {
        /**
         * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
        */
        get: function () {
            return this.i.r8;
        },
        set: function (v) {
            this.i.r8 = +v;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    */
    IgxRadialPieSeriesComponent.prototype.getItemSpan = function () {
        var iv = this.i.e9();
        return (iv);
    };
    var IgxRadialPieSeriesComponent_1;
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxRadialPieSeriesComponent.prototype, "radiusX", null);
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxRadialPieSeriesComponent.prototype, "radiusY", null);
    IgxRadialPieSeriesComponent = IgxRadialPieSeriesComponent_1 = tslib_1.__decorate([
        Component({
            selector: 'igx-radial-pie-series',
            template: "",
            providers: [{ provide: IgxAnchoredRadialSeriesComponent, useExisting: forwardRef(function () { return IgxRadialPieSeriesComponent_1; }) }, { provide: IgxRadialBaseComponent, useExisting: forwardRef(function () { return IgxRadialPieSeriesComponent_1; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxRadialPieSeriesComponent_1; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxRadialPieSeriesComponent_1; }) }],
            changeDetection: ChangeDetectionStrategy.OnPush
        }),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxRadialPieSeriesComponent);
    return IgxRadialPieSeriesComponent;
}(IgxAnchoredRadialSeriesComponent));
export { IgxRadialPieSeriesComponent };
//# sourceMappingURL=igx-radial-pie-series-component.js.map