import * as tslib_1 from "tslib";
import { forwardRef, Input } from '@angular/core';
import { SplineType, SplineType_$type } from "./SplineType";
import { IgxHorizontalAnchoredCategorySeriesComponent } from "./igx-horizontal-anchored-category-series-component";
import { IgxAnchoredCategorySeriesComponent } from "./igx-anchored-category-series-component";
import { IgxCategorySeriesComponent } from "./igx-category-series-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { ensureEnum } from "igniteui-angular-core";
/**
 * Represents the base class for all IgxDataChartComponent spline series.
*/
export var IgxSplineSeriesBaseComponent_PROVIDERS = [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(function () { return IgxSplineSeriesBaseComponent; }) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(function () { return IgxSplineSeriesBaseComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(function () { return IgxSplineSeriesBaseComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxSplineSeriesBaseComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxSplineSeriesBaseComponent; }) }];
var IgxSplineSeriesBaseComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxSplineSeriesBaseComponent, _super);
    function IgxSplineSeriesBaseComponent() {
        return _super.call(this) || this;
    }
    Object.defineProperty(IgxSplineSeriesBaseComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSplineSeriesBaseComponent.prototype, "isAreaOrLine", {
        /**
         * Gets whether the current series shows an area or line shape.
        */
        get: function () {
            return this.i.cy;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSplineSeriesBaseComponent.prototype, "splineType", {
        /**
         * Gets or sets the type of spline to be rendered.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-spline-area-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         splineType="clamped"
        *         valueMemberPath="value">
        *     </igx-spline-area-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.series.splineType = SplineType.Clamped;
        * ```
        */
        get: function () {
            return this.i.s8;
        },
        set: function (v) {
            this.i.s8 = ensureEnum(SplineType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxSplineSeriesBaseComponent.prototype, "splineType", null);
    return IgxSplineSeriesBaseComponent;
}(IgxHorizontalAnchoredCategorySeriesComponent));
export { IgxSplineSeriesBaseComponent };
//# sourceMappingURL=igx-spline-series-base-component.js.map