import { EventArgs, IList$1, Base, Type, IEnumerable$1, Point } from "igniteui-angular-core";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { Series } from "./Series";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { IHasCategoryAxis } from "./IHasCategoryAxis";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { Brush } from "igniteui-angular-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { List$1 } from "igniteui-angular-core";
import { Dictionary$2 } from "igniteui-angular-core";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { AssigningCategoryStyleEventArgs } from "./AssigningCategoryStyleEventArgs";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { CalculatedColumn } from "./CalculatedColumn";
import { ColumnSupportingCalculation } from "./ColumnSupportingCalculation";
import { RenderSurface } from "./RenderSurface";
import { SupportingCalculation$1 } from "./SupportingCalculation$1";
/**
 * @hidden
 */
export declare class FinancialEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: number, b: number, c: FinancialCalculationDataSource, d: FinancialCalculationSupportingCalculations, e: FinancialSeries);
    private _position;
    position: number;
    private _count;
    count: number;
    private _dataSource;
    dataSource: FinancialCalculationDataSource;
    private _supportingCalculations;
    supportingCalculations: FinancialCalculationSupportingCalculations;
    private _basedOn;
    basedOn: IList$1<string>;
}
/**
 * @hidden
 */
export declare class FinancialBucketCalculator extends Base implements IBucketizer {
    static $t: Type;
    protected a: FinancialSeriesView;
    constructor(a: FinancialSeriesView);
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    c: number;
    d: number;
    b: number;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    e(a: number): void;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class FinancialSeries extends Series implements IHasCategoryAxis, IHasCategoryModePreference {
    static $t: Type;
    kk(a: SeriesView): void;
    ox: FinancialSeriesView;
    protected get_c6(): boolean;
    ag(): Axis[];
    gt(a: any, b: string): any;
    protected qg(): number;
    private qe;
    ah(a: Point): Point[][];
    ai(a: Point): Point[][];
    constructor();
    rm: Brush;
    nh(): Brush;
    ji(): void;
    oh: CategoryAxisBase;
    o2: NumericYAxis;
    qw: string;
    pc: IFastItemColumn$1<number>;
    private o7;
    qn: string;
    pa: IFastItemColumn$1<number>;
    private o5;
    qs: string;
    pb: IFastItemColumn$1<number>;
    private o6;
    qk: string;
    o9: IFastItemColumn$1<number>;
    private o4;
    q0: string;
    pe: IFastItemColumn$1<number>;
    private o8;
    pm: boolean;
    protected ph: boolean;
    assigningCategoryStyle: (sender: any, args: AssigningCategoryStyleEventArgs) => void;
    po(): boolean;
    protected q8(a: AssigningCategoryStyleEventArgs): void;
    protected op: CategorySeriesRenderManager;
    protected q6(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    p6(a: Point): number;
    gf(a: Point, b: boolean): number;
    gd(a: Point, b: boolean): number;
    e2(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    nt(a: Point, b: boolean, c: boolean): Point;
    fh(a: Point, b: boolean, c: boolean): number;
    fd(a: Point, b: boolean, c: boolean): number;
    ff(a: Point, b: boolean, c: boolean): number;
    p8(a: Point, b: boolean, c: boolean): number;
    p9(a: Point, b: boolean, c: boolean): number;
    qa(a: Point, b: boolean, c: boolean): number;
    np(a: Point, b: boolean, c: boolean): Point;
    nr(a: Point, b: boolean, c: boolean): Point;
    ro(a: Point, b: boolean, c: boolean): Point;
    rn(a: Point, b: boolean, c: boolean): Point;
    rp(a: Point, b: boolean, c: boolean): Point;
    j2(): void;
    protected lo(a: Rect, b: Rect): void;
    protected ln(a: Rect, b: Rect): void;
    protected pr: Dictionary$2<IFastItemColumn$1<number>, string>;
    protected ps: Dictionary$2<string, string>;
    private pd;
    private q5;
    private pg;
    protected kp(a: any, b: string, c: any, d: any): void;
    pj(a: any): boolean;
    pi(a: any): boolean;
    protected oa(a: number, b: number, c: Axis): any[];
    protected qd(a: SeriesView): number;
    protected qf(a: SeriesView): number;
    n9(a: number, b: number): any[];
    private o0;
    protected get_da(): boolean;
    jj(): void;
    au(a: any, b: Point, c: boolean): HighlightingInfo;
    qh(a: Point): number;
    protected oz(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected oy(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected pk(): boolean;
    e4(a: Point): number;
    f9(a: Point): number;
    protected get_dg(): boolean;
    aq(): CategoryAxisBase;
    gb(a: Point): number;
    gq(a: Point): any;
    ok: CategoryFrame;
    om: CategoryFrame;
    oj: CategoryFrame;
    protected p7(a: Rect, b: Rect, c: Rect): number;
    or: CategoryTransitionInMode;
    pn: boolean;
    protected dt(): boolean;
    protected oq(): CategoryTransitionInMode;
    protected b2(): TransitionInSpeedType;
    q9(a: CategoryFrame, b: FinancialSeriesView): void;
    q7(a: CategoryFrame, b: FinancialSeriesView): void;
    ec(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    os: CategoryTransitionSourceFramePreparer;
    qb(a: FinancialSeriesView): number;
    protected jm(): void;
    k4(a: boolean): void;
    typical: (sender: any, e: FinancialEventArgs) => void;
    typicalBasedOn: (sender: any, e: FinancialEventArgs) => void;
    protected pp(a: IList$1<string>): boolean;
    readonly pq: boolean;
    protected pl(): boolean;
    protected q4(a: FinancialEventArgs): void;
    protected readonly py: IEnumerable$1<number>;
    private _pv;
    private pv;
    protected readonly px: IEnumerable$1<number>;
    private _pu;
    private pu;
    protected readonly pw: IEnumerable$1<number>;
    private _pt;
    private pt;
    p0(a: IList$1<number>): IList$1<number>;
    private pf;
    protected pz(): IList$1<string>;
    private p4;
    getOpenColumnAsArray(): number[];
    private p2;
    getHighColumnAsArray(): number[];
    private p3;
    getLowColumnAsArray(): number[];
    private p1;
    getCloseColumnAsArray(): number[];
    private p5;
    getVolumeColumnAsArray(): number[];
    protected jo(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected ot(a: number, b: number): FinancialCalculationDataSource;
    qc(a: number): number;
    protected ou(a: FinancialCalculationDataSource): FinancialCalculationSupportingCalculations;
    readonly categoryAxis: CategoryAxisBase;
    private ol;
    k5(a: Rect, b: RenderSurface): void;
    private oi;
    k2(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    am(a: Axis): Axis;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    private on;
    oo: CategoryMode;
    protected get_de(): boolean;
    k8(a: Brush, b: Brush): void;
    private ra;
    private o1;
    private o3;
    gs(a: any): any;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class FinancialCalculationSupportingCalculations extends Base {
    static $t: Type;
    a: ColumnSupportingCalculation;
    c: ColumnSupportingCalculation;
    d: ColumnSupportingCalculation;
    b: ColumnSupportingCalculation;
    h: DataSourceSupportingCalculation;
    f: DataSourceSupportingCalculation;
    g: DataSourceSupportingCalculation;
    e: DataSourceSupportingCalculation;
    k: (arg1: (arg1: number) => number, arg2: number, arg3: number) => IEnumerable$1<number>;
    j: (arg1: (arg1: number) => number, arg2: number) => IEnumerable$1<number>;
    i: (arg1: number) => number;
}
/**
 * @hidden
 */
export declare class DataSourceSupportingCalculation extends SupportingCalculation$1<(dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>> {
    static $t: Type;
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>);
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>, c: IList$1<string>);
    constructor(a: number, ..._rest: any[]);
}
/**
 * @hidden
 */
export declare class FinancialCalculationDataSource extends Base {
    static $t: Type;
    private _openColumn;
    openColumn: IList$1<number>;
    private _closeColumn;
    closeColumn: IList$1<number>;
    private _highColumn;
    highColumn: IList$1<number>;
    private _lowColumn;
    lowColumn: IList$1<number>;
    private _volumeColumn;
    volumeColumn: IList$1<number>;
    private _indicatorColumn;
    indicatorColumn: IList$1<number>;
    private _typicalColumn;
    typicalColumn: CalculatedColumn;
    private _trueRange;
    trueRange: CalculatedColumn;
    private _trueLow;
    trueLow: CalculatedColumn;
    private _period;
    period: number;
    private _shortPeriod;
    shortPeriod: number;
    private _longPeriod;
    longPeriod: number;
    private _count;
    count: number;
    private _calculateFrom;
    calculateFrom: number;
    private _calculateCount;
    calculateCount: number;
    private _multiplier;
    multiplier: number;
    private _minimumValue;
    minimumValue: number;
    private _maximumValue;
    maximumValue: number;
    private _specifiesRange;
    specifiesRange: boolean;
    private _series;
    series: FinancialSeries;
}
/**
 * @hidden
 */
export declare abstract class FinancialSeriesView extends SeriesView {
    static $t: Type;
    bz: FinancialSeries;
    bx: FinancialBucketCalculator;
    b1: number;
    b0(a: CategoryFrame): boolean;
    b2(a: CategoryFrame): void;
    constructor(a: FinancialSeries);
    protected abstract by(): FinancialBucketCalculator;
    as(): void;
    getDefaultTooltipTemplate(): string;
    protected af(): void;
}
