import { Base, Type, Point } from "igniteui-angular-core";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { CategoryAngleAxis } from "./CategoryAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { SeriesRenderer$2 } from "./SeriesRenderer$2";
import { RadialFrame } from "./RadialFrame";
import { HighlightingInfo } from "./HighlightingInfo";
import { RadialSeriesRenderManager } from "./RadialSeriesRenderManager";
import { CategoryMode } from "./CategoryMode";
import { List$1 } from "igniteui-angular-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { AssigningRadialStyleEventArgs } from "./AssigningRadialStyleEventArgs";
import { AssigningRadialMarkerStyleEventArgs } from "./AssigningRadialMarkerStyleEventArgs";
import { RadialAxes } from "./RadialAxes";
import { Pool$1 } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class RadialBucketCalculator extends Base implements IBucketizer {
    static $t: Type;
    protected a: RadialBaseView;
    constructor(a: RadialBaseView);
    c: number;
    d: number;
    b: number;
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    e(a: number): void;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class RadialBase extends MarkerSeries implements IHasCategoryModePreference {
    static $t: Type;
    kk(a: SeriesView): void;
    p0: RadialBaseView;
    constructor();
    private qr;
    readonly categoryAxis: CategoryAxisBase;
    aq(): CategoryAxisBase;
    po(a: number, b: number): any[];
    protected p4: RadialSeriesRenderManager;
    ct(a: List$1<SeriesPointOfInterest>, b: boolean, c: number): boolean;
    private qm;
    p5: SeriesRenderer$2<RadialFrame, RadialBaseView>;
    protected get_dh(): boolean;
    qc: boolean;
    qb: boolean;
    protected p7: boolean;
    protected p6: boolean;
    protected get_da(): boolean;
    private pw;
    private px;
    protected pt(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected pu(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected pv(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    au(a: any, b: Point, c: boolean): HighlightingInfo;
    av(a: any, b: Point, c: boolean): HighlightingInfo;
    assigningRadialStyle: (sender: any, args: AssigningRadialStyleEventArgs) => void;
    assigningRadialMarkerStyle: (sender: any, args: AssigningRadialMarkerStyleEventArgs) => void;
    protected qg(): boolean;
    protected qf(): boolean;
    protected qu(a: AssigningRadialStyleEventArgs): void;
    protected qt(a: AssigningRadialMarkerStyleEventArgs): void;
    qi(a: SeriesView): number;
    qj(a: SeriesView): number;
    pr: CategoryAngleAxis;
    py: NumericRadiusAxis;
    ag(): Axis[];
    qa: boolean;
    protected lo(a: Rect, b: Rect): void;
    protected ln(a: Rect, b: Rect): void;
    abstract preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    protected kp(a: any, b: string, c: any, d: any): void;
    protected qe(): boolean;
    protected qd(): boolean;
    p9(a: any): boolean;
    p8(a: any): boolean;
    gq(a: Point): any;
    qh(a: Point): number;
    e4(a: Point): number;
    f9(a: Point): number;
    dq(a: any): boolean;
    p2: RadialFrame;
    p3: RadialFrame;
    p1: RadialFrame;
    abstract getOffsetValue(): number;
    abstract getCategoryWidth(): number;
    abstract qs(a: RadialFrame, b: RadialBaseView): void;
    abstract qv(a: RadialFrame, b: RadialBaseView): void;
    pz: RadialAxes;
    j2(): void;
    ec(a: Rect, b: Rect, c: SeriesView): boolean;
    k4(a: boolean): void;
    qk(): number;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class RadialBaseView extends MarkerSeriesView {
    static $t: Type;
    cs: RadialBucketCalculator;
    cr: RadialBase;
    constructor(a: RadialBase);
    ct: Pool$1<Marker>;
    cf(a: (arg1: Marker) => void): void;
    cu: number;
    cv: Point;
}
