import { Type } from '@angular/core';
import { IgxAxisComponent } from "./igx-axis-component";
import { IgxAnnotationLayerComponent } from "./igx-annotation-layer-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { CategoryToolTipLayer } from "./CategoryToolTipLayer";
/**
 * Represents an annotation layer that displays grouped tooltips for series that use a category axis.
*/
export declare const IgxCategoryToolTipLayerComponent_PROVIDERS: ({
    provide: typeof IgxAnnotationLayerComponent;
    useExisting: Type<any>;
} | {
    provide: typeof IgxSeriesComponent;
    useExisting: Type<any>;
})[];
export declare class IgxCategoryToolTipLayerComponent extends IgxAnnotationLayerComponent {
    protected createImplementation(): CategoryToolTipLayer;
    /**
                                 * @hidden
                                 */
    readonly i: CategoryToolTipLayer;
    constructor();
    /**
     * Gets whether the default tooltip behaviors for the chart are disabled if this layer is present.
    */
    readonly isDefaultTooltipBehaviorDisabled: boolean;
    /**
     * Gets or sets the Axis to target this annotation to. If null, this annotation layer will not render content.
    */
    targetAxis: IgxAxisComponent;
    /**
     * Gets or sets whether to use value interpolation when drawing the tooltips.
    */
    useInterpolation: boolean;
    findByName(name: string): any;
    protected _styling(container: any, component: any, parent?: any): void;
    /**
     * Hides any tooltips presented by the layer, if any.
    
    */
    hideToolTips(): void;
}
