import { Type } from '@angular/core';
import { IgxItemwiseStrategyBasedIndicatorComponent } from "./igx-itemwise-strategy-based-indicator-component";
import { IgxFinancialSeriesComponent } from "./igx-financial-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { MedianPriceIndicator } from "./MedianPriceIndicator";
/**
 * Represents a IgxDataChartComponent Median Price indicator series.
 * Default required members: High, Low
*
* Represents a Ignite UIDataChart Median Price indicator series.
*
* Example:
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
* 	<igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
* 	<igx-median-price-indicator
*         #series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         highMemberPath="high"
* 		lowMemberPath="low"
* 		volumeMemberPath="volume">
*     </igx-median-price-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxMedianPriceIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.volumeMemberPath= "volume";
* this.chart.series.add(series);
* ```
*/
export declare const IgxMedianPriceIndicatorComponent_PROVIDERS: ({
    provide: typeof IgxFinancialSeriesComponent;
    useExisting: Type<any>;
} | {
    provide: typeof IgxSeriesComponent;
    useExisting: Type<any>;
})[];
export declare class IgxMedianPriceIndicatorComponent extends IgxItemwiseStrategyBasedIndicatorComponent {
    protected createImplementation(): MedianPriceIndicator;
    /**
                                 * @hidden
                                 */
    readonly i: MedianPriceIndicator;
    constructor();
}
