import { Type } from '@angular/core';
import { IgxRing } from "./igx-ring";
import { IgxRingSeriesBaseComponent } from "./igx-ring-series-base-component";
import { RingSeries } from "./RingSeries";
import { IgxIndexCollection } from "./igx-index-collection";
export declare const IgxRingSeriesComponent_PROVIDERS: {
    provide: typeof IgxRingSeriesBaseComponent;
    useExisting: Type<any>;
}[];
/**
 * Represents one ring in IgxDoughnutChartComponent series.
*/
export declare class IgxRingSeriesComponent extends IgxRingSeriesBaseComponent {
    protected createImplementation(): RingSeries;
    readonly i: RingSeries;
    constructor();
    private _explodedSlices;
    /**
     * Gets or sets the collection of exploded slice indices.
    */
    explodedSlices: IgxIndexCollection;
    private _selectedSlices;
    /**
     * Gets or sets the collection of selected slice indices.
    */
    selectedSlices: IgxIndexCollection;
    sychronizeCollections(): void;
    /**
 * Gets reference to the ring data.
*/
    ring: IgxRing;
    findByName(name: string): any;
}
